import * as React from 'react';
import { EditableFieldBaseComponent } from '../field-base-component';
import type { DynamicPodComponentProps, DynamicPodDecoratorProperties } from './dynamic-pod-types';
export declare class DynamicPodComponent extends EditableFieldBaseComponent<DynamicPodDecoratorProperties, any, DynamicPodComponentProps, {
    fetchingReferenceTypes: boolean;
    fetchingOptionTypes: boolean;
}> {
    constructor(props: DynamicPodComponentProps);
    getMissingOptionTypes(): string[];
    getMissingReferenceTypes(): string[];
    checkDataModel(): void;
    componentDidMount(): void;
    componentDidUpdate(prevProps: DynamicPodComponentProps): void;
    private readonly onChange;
    private readonly onRemove;
    private readonly onNewPod;
    private addReferenceDataTypeInfo;
    render(): React.ReactNode;
}
export declare const ConnectedDynamicPodComponent: import("react-redux").ConnectedComponent<typeof DynamicPodComponent, {
    key?: React.Key | null | undefined;
    ref?: React.LegacyRef<DynamicPodComponent> | undefined;
    contextNode?: import("../../../types").NodePropertyType | undefined;
    parentElementId?: string | undefined;
    level?: number | undefined;
    columnDefinition?: any;
    handlersArguments?: import("../../nested-fields").NestedFieldHandlersArguments | undefined;
    isNested?: boolean | undefined;
    recordContext?: any;
    bind?: any;
    elementId: string;
    isParentDisabled?: boolean | undefined;
    isParentHidden?: boolean | undefined;
    fixedHeight?: number | undefined;
    item?: import("../../..").PageArticleItem | undefined;
    screenId: string;
    contextType?: import("../../../types").ContextType | undefined;
    nestedReadOnlyField?: boolean | undefined;
    shouldRenderLabelInNestedReadOnlyMode?: boolean | undefined;
    availableColumns?: number | undefined;
    context?: React.Context<import("react-redux").ReactReduxContextValue<any, UnknownAction> | null> | undefined;
    store?: import("redux").Store<any, import("redux").AnyAction> | undefined;
}>;
export default ConnectedDynamicPodComponent;
//# sourceMappingURL=dynamic-pod-component.d.ts.map