"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BusinessPartnerCompanyExceptionExtension = void 0;
const sageX3MasterData = require("@sage/x3-master-data");
const xtrem_core_1 = require("@sage/xtrem-core");
const xtrem_x3_gateway_1 = require("@sage/xtrem-x3-gateway");
const sageX3InvoicingData = require("..");
const joins = {
    referenceJoins: {
        businessPartnerTaxRule: {
            code: 'businessPartnerTaxRule',
        },
        customerTaxRule: {
            code: 'customerTaxRule',
        },
        supplierTaxRule: {
            code: 'supplierTaxRule',
        },
        customerPaymentTerm: {
            code: 'customerPaymentTerm',
        },
        supplierPaymentTerm: {
            code: 'supplierPaymentTerm',
        },
        customerEarlyDiscountOrLateCharge: {
            code: 'customerEarlyDiscountOrLateCharge',
        },
        supplierEarlyDiscountOrLateCharge: {
            code: 'supplierEarlyDiscountOrLateCharge',
        },
    },
};
let BusinessPartnerCompanyExceptionExtension = class BusinessPartnerCompanyExceptionExtension extends xtrem_core_1.NodeExtension {
};
exports.BusinessPartnerCompanyExceptionExtension = BusinessPartnerCompanyExceptionExtension;
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'VACBPR',
        columnType: 'string',
        node: () => sageX3InvoicingData.nodes.TaxRule,
    })
], BusinessPartnerCompanyExceptionExtension.prototype, "businessPartnerTaxRule", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'VACBPC',
        columnType: 'string',
        node: () => sageX3InvoicingData.nodes.TaxRule,
    })
], BusinessPartnerCompanyExceptionExtension.prototype, "customerTaxRule", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'VACBPS',
        columnType: 'string',
        node: () => sageX3InvoicingData.nodes.TaxRule,
    })
], BusinessPartnerCompanyExceptionExtension.prototype, "supplierTaxRule", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'PTEBPC',
        columnType: 'string',
        node: () => sageX3InvoicingData.nodes.PaymentTerm,
    })
], BusinessPartnerCompanyExceptionExtension.prototype, "customerPaymentTerm", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'PTEBPS',
        columnType: 'string',
        node: () => sageX3InvoicingData.nodes.PaymentTerm,
    })
], BusinessPartnerCompanyExceptionExtension.prototype, "supplierPaymentTerm", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'DEPBPC',
        columnType: 'string',
        node: () => sageX3InvoicingData.nodes.EarlyDiscountLateCharge,
    })
], BusinessPartnerCompanyExceptionExtension.prototype, "customerEarlyDiscountOrLateCharge", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'DEPBPS',
        columnType: 'string',
        node: () => sageX3InvoicingData.nodes.EarlyDiscountLateCharge,
    })
], BusinessPartnerCompanyExceptionExtension.prototype, "supplierEarlyDiscountOrLateCharge", void 0);
exports.BusinessPartnerCompanyExceptionExtension = BusinessPartnerCompanyExceptionExtension = __decorate([
    xtrem_core_1.decorators.nodeExtension({
        extends: () => sageX3MasterData.nodes.BusinessPartnerCompanyException,
        externalStorageManagerExtension: new xtrem_x3_gateway_1.X3StorageManagerExtension({
            joins,
        }),
    })
], BusinessPartnerCompanyExceptionExtension);
//# sourceMappingURL=business-partner-company-exception-extension.js.map