import * as sageX3MasterData from '@sage/x3-master-data';
import * as sageX3PhysicalFlowsData from '@sage/x3-physical-flows-data';
import { NodeExtension, Reference, decimal, TextStream, date } from '@sage/xtrem-core';
import * as sageX3SalesData from '..';
export declare class ProductExtension extends NodeExtension<sageX3MasterData.nodes.Product> {
    readonly productSalesRef: Reference<sageX3SalesData.nodes.ProductSales | null>;
    readonly basePrice: Promise<decimal | null>;
    readonly packaging: Reference<sageX3PhysicalFlowsData.nodes.Packaging | null>;
    readonly packagingCapacity: Promise<decimal | null>;
    readonly productPickingText: Promise<TextStream>;
    readonly productSalesText: Promise<TextStream>;
    readonly substitutionDate: Promise<date | null>;
    readonly substitutionProduct: Reference<sageX3MasterData.nodes.Product | null>;
}
declare module '@sage/x3-master-data/lib/nodes/product' {
    interface Product extends ProductExtension {
    }
}
//# sourceMappingURL=product-extension.d.ts.map