"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductExtension = void 0;
const sageX3MasterData = require("@sage/x3-master-data");
const xtrem_core_1 = require("@sage/xtrem-core");
const xtrem_x3_gateway_1 = require("@sage/xtrem-x3-gateway");
const sageX3Sales = require("..");
const joins = {
    referenceJoins: {
        loanContract: {
            id: 'loanContract',
        },
        warrantyContract: {
            id: 'warrantyContract',
        },
        serviceContract: {
            id: 'serviceContract',
        },
    },
};
let ProductExtension = class ProductExtension extends xtrem_core_1.NodeExtension {
};
exports.ProductExtension = ProductExtension;
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'TPLCONLND',
        columnType: 'string',
        node: () => sageX3Sales.nodes.ServiceContractTemplate,
    })
], ProductExtension.prototype, "loanContract", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'TPLCONGUA',
        columnType: 'string',
        node: () => sageX3Sales.nodes.ServiceContractTemplate,
    })
], ProductExtension.prototype, "warrantyContract", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'TPLCONSRV',
        columnType: 'string',
        node: () => sageX3Sales.nodes.ServiceContractTemplate,
    })
], ProductExtension.prototype, "serviceContract", void 0);
exports.ProductExtension = ProductExtension = __decorate([
    xtrem_core_1.decorators.nodeExtension({
        extends: () => sageX3MasterData.nodes.Product,
        externalStorageManagerExtension: new xtrem_x3_gateway_1.X3StorageManagerExtension({
            joins,
        }),
    })
], ProductExtension);
//# sourceMappingURL=product-extension.js.map