"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SalesQuoteLineExtension = void 0;
const sageX3Sales = require("@sage/x3-sales");
const sageX3System = require("@sage/x3-system");
const xtrem_core_1 = require("@sage/xtrem-core");
const xtrem_x3_gateway_1 = require("@sage/xtrem-x3-gateway");
const sageX3SalesProjectManagement = require("..");
const joins = {
    referenceJoins: {
        projectSalesDocument: {
            id: 'projectSalesDocument',
        },
        projectSalesDocumentLine: {
            projectDocument: 'projectSalesDocument',
            lineNumber: 'projectSalesDocumentLine',
        },
    },
};
let SalesQuoteLineExtension = class SalesQuoteLineExtension extends xtrem_core_1.NodeExtension {
};
exports.SalesQuoteLineExtension = SalesQuoteLineExtension;
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'SQDPSONUM',
        columnType: 'string',
        node: () => sageX3SalesProjectManagement.nodes.SalesDocument,
        serviceOptions: () => [sageX3System.serviceOptions.PjmActivityCode],
    })
], SalesQuoteLineExtension.prototype, "projectSalesDocument", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'SQDSEQNUM',
        columnType: 'integer',
        node: () => sageX3SalesProjectManagement.nodes.SalesDocumentLine,
        serviceOptions: () => [sageX3System.serviceOptions.PjmActivityCode],
    })
], SalesQuoteLineExtension.prototype, "projectSalesDocumentLine", void 0);
exports.SalesQuoteLineExtension = SalesQuoteLineExtension = __decorate([
    xtrem_core_1.decorators.nodeExtension({
        extends: () => sageX3Sales.nodes.SalesQuoteLine,
        externalStorageManagerExtension: new xtrem_x3_gateway_1.X3StorageManagerExtension({
            joins,
        }),
    })
], SalesQuoteLineExtension);
//# sourceMappingURL=sales-quote-line-extension.js.map