import { Node, Reference, decimal, TextStream } from '@sage/xtrem-core';
import * as sageX3MasterData from '..';
export declare class CustomerProduct extends Node {
    readonly product: Reference<sageX3MasterData.nodes.Product>;
    readonly customer: Reference<sageX3MasterData.nodes.BusinessPartner>;
    readonly isActive: Promise<boolean>;
    readonly customerProduct: Promise<string>;
    readonly customerProductDescription: Promise<string>;
    readonly salesTextKey: Promise<string>;
    readonly pickingTextKey: Promise<string>;
    readonly salesUnit: Reference<sageX3MasterData.nodes.UnitOfMeasure>;
    readonly salesUnitToStockUnitConversion: Promise<decimal | null>;
    readonly packingUnit1: Reference<sageX3MasterData.nodes.UnitOfMeasure | null>;
    readonly packingUnit1ToSalesUnitConversion: Promise<decimal | null>;
    readonly packingUnit2: Reference<sageX3MasterData.nodes.UnitOfMeasure | null>;
    readonly packingUnit2ToSalesUnitConversion: Promise<decimal | null>;
    readonly customerUseByDateCoefficient: Promise<decimal | null>;
    readonly journalNumberConfigurator: Promise<string>;
    readonly isVersionPreloaded: Promise<boolean>;
    readonly pickingTextRef: Reference<sageX3MasterData.nodes.CommonText | null>;
    readonly salesTextRef: Reference<sageX3MasterData.nodes.CommonText | null>;
    readonly pickingText: Promise<TextStream>;
    readonly salesText: Promise<TextStream>;
}
//# sourceMappingURL=customer-product.d.ts.map