import * as sageX3MasterData from '@sage/x3-master-data';
import * as sageX3ProjectManagementData from '@sage/x3-project-management-data';
import { Node, Reference, integer, decimal, date, TextStream } from '@sage/xtrem-core';
import * as sageX3ProjectManagement from '..';
export declare class OperationAssignment extends Node {
    readonly project: Reference<sageX3ProjectManagement.nodes.Project>;
    readonly task: Reference<sageX3ProjectManagement.nodes.Task>;
    readonly operation: Reference<sageX3ProjectManagement.nodes.Operation>;
    readonly firstOperationSplit: Promise<integer | null>;
    readonly lineNumber: Promise<integer>;
    readonly employee: Reference<sageX3ProjectManagement.nodes.ProjectUser>;
    readonly localizedDescription: Promise<string>;
    readonly unit: Reference<sageX3MasterData.nodes.UnitOfMeasure | null>;
    readonly plannedLoad: Promise<decimal | null>;
    readonly consumedLoad: Promise<decimal | null>;
    readonly remainingLoad: Promise<decimal | null>;
    readonly currency: Reference<sageX3MasterData.nodes.Currency>;
    readonly hourlyRate: Promise<decimal | null>;
    readonly laborRate: Promise<decimal | null>;
    readonly startDate: Promise<date | null>;
    readonly endDate: Promise<date | null>;
    readonly startTime: Promise<string>;
    readonly endTime: Promise<string>;
    readonly keyConcatenation: Promise<string>;
    readonly timeCategory: Reference<sageX3ProjectManagement.nodes.TimeCategory | null>;
    readonly longCommentRef: Reference<sageX3ProjectManagementData.nodes.ProjectText | null>;
    readonly longDescriptionRef: Reference<sageX3ProjectManagementData.nodes.ProjectText | null>;
    readonly longComment: Promise<TextStream>;
    readonly longDescription: Promise<TextStream>;
}
//# sourceMappingURL=operation-assignment.d.ts.map