import * as sageX3MasterData from '@sage/x3-master-data';
import * as sageX3System from '@sage/x3-system';
import { Node, Reference } from '@sage/xtrem-core';
import * as sageX3StockData from '..';
export declare class StockManagementRules extends Node {
    readonly productCategory: Reference<sageX3MasterData.nodes.ProductCategory | null>;
    readonly stockSite: Reference<sageX3System.nodes.Site | null>;
    readonly transactionType: Promise<sageX3StockData.enums.StockTransactionType>;
    readonly stockMovementCode: Reference<sageX3System.nodes.MiscellaneousTable | null>;
    readonly locationNumber: Promise<sageX3StockData.enums.TitleOfLocationForStockManagementRules | null>;
    readonly locationNumber2: Promise<sageX3StockData.enums.TitleOfLocationForStockManagementRules | null>;
    readonly locationNumber3: Promise<sageX3StockData.enums.TitleOfLocationForStockManagementRules | null>;
    readonly authorizedStatus: Promise<sageX3StockData.enums.QualityFilter1 | null>;
    readonly authorizedSubstatus: Promise<string>;
    readonly defaultStatus: Promise<string>;
    readonly formula: Promise<string>;
    readonly hasAnalysisRequest: Promise<boolean>;
    readonly lotEntry: Promise<sageX3StockData.enums.PackingSequence | null>;
    readonly lotByDefault: Promise<sageX3StockData.enums.DefaultLot | null>;
    readonly outputLot: Promise<sageX3MasterData.enums.LotIssueExpirationUbd | null>;
    readonly prototypeVersion: Promise<sageX3StockData.enums.PrototypeOrActiveVersion | null>;
    readonly activeVersion: Promise<sageX3StockData.enums.PrototypeOrActiveVersion | null>;
    readonly versionStopped: Promise<sageX3StockData.enums.VersionStopped | null>;
    readonly isExclusiveEntryVersion: Promise<boolean>;
    readonly licensePlateNumberEntry: Promise<sageX3StockData.enums.LicensePlateNumberEntry | null>;
}
//# sourceMappingURL=stock-management-rules.d.ts.map