import { integer, Node, Reference } from '@sage/xtrem-core';
import * as x3SystemUtils from '..';
/** 4GL code: EDIFNC */
export declare class SysFunction extends Node {
    /** 4GL code: MODULE */
    readonly module: Promise<x3SystemUtils.enums.SysModuleTable | null>;
    /** 4GL code: CODINT */
    readonly internal: Promise<string>;
    /** 4GL code: CODACT */
    readonly activityCode: Reference<x3SystemUtils.nodes.SysActivityCode | null>;
    /** 4GL code: CODEXT */
    readonly external: Promise<string>;
    /** 4GL code: NUMFNC */
    readonly number: Promise<integer>;
    /** 4GL code: LIBMENU */
    readonly menuTitle: Promise<integer>;
    /** 4GL code: MENU */
    readonly parentMenu: Promise<string>;
    /** 4GL code: NBOPT */
    readonly noOfOptions: Promise<integer>;
    /** 4GL code: FLAG */
    readonly options: Promise<string[]>;
    /** 4GL code: ACTOPT */
    readonly activityCode1: Promise<string>;
    /** 4GL code: OPTION */
    readonly optionTitle: Promise<integer>;
    /** 4GL code: FNCOPT */
    readonly function: Promise<string>;
    /** 4GL code: RANG */
    readonly rowInMenu: Promise<integer>;
    /** 4GL code: TRAIT */
    readonly menuProcess: Promise<string>;
    /** 4GL code: TYP */
    readonly accessTypeObject: Promise<boolean>;
    /** 4GL code: NBVAR */
    readonly numberOfVariables: Promise<integer>;
    /** 4GL code: ACTVAR */
    readonly activityCode2: Promise<string>;
    /** 4GL code: VALEUR */
    readonly value: Promise<string[]>;
    /** 4GL code: VARIA */
    readonly variable: Promise<string>;
    /** 4GL code: VALPAR */
    readonly parameterValue: Promise<string[]>;
    /** 4GL code: TRTENT */
    readonly entryPoints: Promise<string>;
    /** 4GL code: FCYAUZ */
    readonly authorizationSite: Promise<boolean>;
    /** 4GL code: MONO */
    readonly single: Promise<boolean>;
}
//# sourceMappingURL=sys-function.d.ts.map