import { BinaryStream, Node, Reference } from '@sage/xtrem-core';
import * as x3SystemUtils from '..';
/** 4GL columnName: AUTILIS */
export declare class SysUser extends Node {
    /** 4GL columnName: ENAFLG */
    readonly activeInSelec: Promise<boolean | null>;
    /** 4GL columnName: NOMUSR */
    readonly name: Promise<string>;
    /** 4GL columnName: INTUSR */
    readonly nameDescription: Promise<string>;
    /** 4GL columnName: USR */
    readonly code: Promise<string>;
    /** 4GL columnName: ALLACS */
    readonly allAccessCodes: Promise<boolean | null>;
    /** 4GL columnName: USREXT */
    readonly externalUser: Promise<boolean | null>;
    /** 4GL columnName: FNCCOD */
    readonly functions: Promise<string>;
    /** 4GL columnName: CODMET */
    readonly profession: Reference<x3SystemUtils.nodes.SysSyracusMethod | null>;
    /** 4GL columnName: PRFFCT */
    readonly functionProfile: Reference<x3SystemUtils.nodes.SysUserFunctionProfile | null>;
    /** 4GL columnName: ADDEML */
    readonly email: Promise<string>;
    readonly displayName: Promise<string>;
    /** 4GL columnName: LOGIN */
    readonly login: Promise<string>;
    readonly access: Reference<x3SystemUtils.nodes.SysAccess | null>;
    /** 4GL columnName: ARCPRF */
    readonly profile: Promise<string>;
    /** 4GL columnName: AUSPIC */
    readonly _image: Reference<x3SystemUtils.nodes.SysImage | null>;
    readonly photo: Promise<BinaryStream | null>;
}
//# sourceMappingURL=sys-user.d.ts.map