"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkCenterReplacementWorkCenterReplacementLines = void 0;
const sageX3ManufacturingData = require("@sage/x3-manufacturing-data");
const xtrem_core_1 = require("@sage/xtrem-core");
const xtrem_x3_gateway_1 = require("@sage/xtrem-x3-gateway");
const sageXtremX3SystemUtils = require("@sage/xtrem-x3-system-utils");
const sageX3Manufacturing = require("..");
const denormalized = { maxRepeat: 25 };
const joins = {
    referenceJoins: {
        _denormalizedParent: {
            workCenter: 'workCenter',
            manufacturingSite: 'manufacturingSite',
        },
        replacementworkCenter: {
            code: 'replacementworkCenter',
            manufacturingSite: 'manufacturingSite',
        },
        workCenterGroup: {
            code: 'workCenterGroup',
        },
    },
};
let WorkCenterReplacementWorkCenterReplacementLines = class WorkCenterReplacementWorkCenterReplacementLines extends xtrem_core_1.Node {
};
exports.WorkCenterReplacementWorkCenterReplacementLines = WorkCenterReplacementWorkCenterReplacementLines;
__decorate([
    xtrem_core_1.decorators.integerProperty({
        isPublished: true,
    })
], WorkCenterReplacementWorkCenterReplacementLines.prototype, "denormalizedIndex", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        isPublished: true,
        isStored: true,
        isNotEmpty: true,
        columnName: 'WST',
        dataType: () => sageXtremX3SystemUtils.datatypes.genericDataTypes.textDatatype,
    })
], WorkCenterReplacementWorkCenterReplacementLines.prototype, "workCenter", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        isPublished: true,
        isStored: true,
        isNotEmpty: true,
        columnName: 'WCRFCY',
        dataType: () => sageXtremX3SystemUtils.datatypes.genericDataTypes.textDatatype,
    })
], WorkCenterReplacementWorkCenterReplacementLines.prototype, "manufacturingSite", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isStored: true,
        isVitalParent: true,
        columnType: 'string',
        node: () => sageX3Manufacturing.nodes.WorkCenterReplacement,
    })
], WorkCenterReplacementWorkCenterReplacementLines.prototype, "_denormalizedParent", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'RPLWST',
        columnType: 'string',
        node: () => sageX3ManufacturingData.nodes.WorkCenter,
    })
], WorkCenterReplacementWorkCenterReplacementLines.prototype, "replacementworkCenter", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        isPublished: true,
        isStored: true,
        columnName: 'RPLWSTDES',
        dataType: () => sageXtremX3SystemUtils.datatypes.genericDataTypes.textDatatype,
    })
], WorkCenterReplacementWorkCenterReplacementLines.prototype, "replacementworkCenterDescription", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'WCR',
        columnType: 'string',
        node: () => sageX3ManufacturingData.nodes.WorkCenterGroup,
    })
], WorkCenterReplacementWorkCenterReplacementLines.prototype, "workCenterGroup", void 0);
__decorate([
    xtrem_core_1.decorators.enumProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'WSTTYP',
        dataType: () => sageX3ManufacturingData.enums.workCenterTypeDatatype,
    })
], WorkCenterReplacementWorkCenterReplacementLines.prototype, "workCenterType", void 0);
__decorate([
    xtrem_core_1.decorators.integerProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'PIO',
    })
], WorkCenterReplacementWorkCenterReplacementLines.prototype, "priority", void 0);
exports.WorkCenterReplacementWorkCenterReplacementLines = WorkCenterReplacementWorkCenterReplacementLines = __decorate([
    xtrem_core_1.decorators.node({
        storage: 'external',
        tableName: 'RPLWST',
        keyPropertyNames: ['denormalizedIndex', 'workCenter', 'manufacturingSite'],
        indexes: [],
        externalStorageManager: new xtrem_x3_gateway_1.X3StorageManager({
            joins,
            isDenormalized: true,
            denormalized,
        }),
        isPublished: true,
        canRead: true,
        canSearch: true,
        isVitalCollectionChild: true,
    })
], WorkCenterReplacementWorkCenterReplacementLines);
//# sourceMappingURL=work-center-replacement-work-center-replacement-lines.js.map