"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkOrderOperationTrackingLineRejections = void 0;
const xtrem_core_1 = require("@sage/xtrem-core");
const xtrem_x3_gateway_1 = require("@sage/xtrem-x3-gateway");
const sageXtremX3SystemUtils = require("@sage/xtrem-x3-system-utils");
const sageX3Manufacturing = require("..");
const denormalized = { maxRepeat: 15 };
const joins = {
    referenceJoins: {
        _denormalizedParent: {
            trackingNumber: 'trackingNumber',
            line: 'line',
        },
    },
};
let WorkOrderOperationTrackingLineRejections = class WorkOrderOperationTrackingLineRejections extends xtrem_core_1.Node {
};
exports.WorkOrderOperationTrackingLineRejections = WorkOrderOperationTrackingLineRejections;
__decorate([
    xtrem_core_1.decorators.integerProperty({
        isPublished: true,
    })
], WorkOrderOperationTrackingLineRejections.prototype, "denormalizedIndex", void 0);
__decorate([
    xtrem_core_1.decorators.stringProperty({
        isPublished: true,
        isStored: true,
        isNotEmpty: true,
        columnName: 'MFGTRKNUM',
        dataType: () => sageXtremX3SystemUtils.datatypes.genericDataTypes.textDatatype,
    })
], WorkOrderOperationTrackingLineRejections.prototype, "trackingNumber", void 0);
__decorate([
    xtrem_core_1.decorators.integerProperty({
        isPublished: true,
        isStored: true,
        columnName: 'OPETRKLIN',
    })
], WorkOrderOperationTrackingLineRejections.prototype, "line", void 0);
__decorate([
    xtrem_core_1.decorators.referenceProperty({
        isStored: true,
        isVitalParent: true,
        columnType: 'string',
        node: () => sageX3Manufacturing.nodes.WorkOrderOperationTrackingLine,
    })
], WorkOrderOperationTrackingLineRejections.prototype, "_denormalizedParent", void 0);
__decorate([
    xtrem_core_1.decorators.integerProperty({
        isPublished: true,
        isStored: true,
        isNullable: true,
        columnName: 'SCANUM',
    })
], WorkOrderOperationTrackingLineRejections.prototype, "rejection", void 0);
exports.WorkOrderOperationTrackingLineRejections = WorkOrderOperationTrackingLineRejections = __decorate([
    xtrem_core_1.decorators.node({
        storage: 'external',
        tableName: 'MFGOPETRK',
        keyPropertyNames: ['denormalizedIndex', 'trackingNumber', 'line'],
        indexes: [],
        externalStorageManager: new xtrem_x3_gateway_1.X3StorageManager({
            joins,
            isDenormalized: true,
            denormalized,
        }),
        isPublished: true,
        canRead: true,
        canSearch: true,
        isVitalCollectionChild: true,
    })
], WorkOrderOperationTrackingLineRejections);
//# sourceMappingURL=work-order-operation-tracking-line-rejections.js.map