import type { RuntimePageMetadata } from '../component/container/page/page-extension-decorator';
import type { PageDefinition } from '../service/page-definition';
import type { PageEventType } from '../component/container/page/page-types';
export interface HeaderTitles {
    subtitle: string | undefined;
    title: string;
}
export declare function getHeaderTitles({ idFieldValue, isRecordCreationPage, objectTypePlural, objectTypeSingular, subtitle, title, }: {
    idFieldValue?: string | null;
    isRecordCreationPage?: boolean;
    objectTypePlural?: string | null;
    objectTypeSingular?: string | null;
    subtitle?: string;
    title: string;
}): HeaderTitles;
export declare const getPageTitlesFromPageDefinition: (pageDefinition: PageDefinition, locale: string) => HeaderTitles;
/**
 * Mutates PageMetadata to inject the provided onLoad function to be executed after the page fragment or page extension has been loaded
 */
export declare const injectOnloadAfterIntoPageMetadata: (pageMetadata: RuntimePageMetadata, onLoad: PageEventType<any>) => void;
//# sourceMappingURL=page-utils.d.ts.map