// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/index.d.ts
declare module '@sage/x3-purchasing-data/index' {
	export * from '@sage/x3-purchasing-data/lib/index';
	//# sourceMappingURL=index.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/index.d.ts
declare module '@sage/x3-purchasing-data/lib/index' {
	export * as enums from '@sage/x3-purchasing-data/lib/enums/index';
	export * as nodeExtensions from '@sage/x3-purchasing-data/lib/node-extensions/index';
	export * as nodes from '@sage/x3-purchasing-data/lib/nodes/index';
	export * as serviceOptions from '@sage/x3-purchasing-data/lib/service-options/index';
	//# sourceMappingURL=index.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/service-options/index.d.ts
declare module '@sage/x3-purchasing-data/lib/service-options/index' {
	export type Dummy = void;
	//# sourceMappingURL=index.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/nodes/transport-lead-time.d.ts
declare module '@sage/x3-purchasing-data/lib/nodes/transport-lead-time' {
	import * as sageX3MasterData from '@sage/x3-master-data';
	import { Node, Reference, integer } from '@sage/xtrem-core';
	import * as sageX3PurchasingData from '@sage/x3-purchasing-data/lib/index';
	export class TransportLeadTime extends Node {
	    readonly placeStart: Reference<sageX3MasterData.nodes.TransitArea>;
	    readonly placeArrival: Reference<sageX3MasterData.nodes.TransitArea>;
	    readonly transportMode: Promise<sageX3PurchasingData.enums.TransportMode | null>;
	    readonly carrier: Reference<sageX3MasterData.nodes.Carrier | null>;
	    readonly releaseTime: Promise<integer>;
	}
	//# sourceMappingURL=transport-lead-time.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/nodes/shipment-logistical-tracking.d.ts
declare module '@sage/x3-purchasing-data/lib/nodes/shipment-logistical-tracking' {
	import * as sageX3StockData from '@sage/x3-stock-data';
	import * as sageX3System from '@sage/x3-system';
	import { Node, integer, Reference, date } from '@sage/xtrem-core';
	import * as sageX3PurchasingData from '@sage/x3-purchasing-data/lib/index';
	export class ShipmentLogisticalTracking extends Node {
	    readonly id: Promise<string>;
	    readonly entryType: Promise<sageX3StockData.enums.EntryTypeEnum | null>;
	    readonly trackingSequence: Promise<integer | null>;
	    readonly trackingNumber: Promise<string>;
	    readonly trackingStep: Reference<sageX3System.nodes.MiscellaneousTable | null>;
	    readonly trackingDueDate: Promise<date | null>;
	    readonly trackingEndDate: Promise<date | null>;
	    readonly isMandatory: Promise<boolean>;
	    readonly trackingDependency: Reference<sageX3System.nodes.MiscellaneousTable | null>;
	    readonly trackingUser: Promise<integer | null>;
	    readonly trackingLineComments: Promise<string>;
	    readonly trackingStepStatus: Promise<sageX3PurchasingData.enums.TrackingStepStatus | null>;
	}
	//# sourceMappingURL=shipment-logistical-tracking.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/nodes/shipment-documents.d.ts
declare module '@sage/x3-purchasing-data/lib/nodes/shipment-documents' {
	import * as sageX3MasterData from '@sage/x3-master-data';
	import * as sageX3StockData from '@sage/x3-stock-data';
	import * as sageX3System from '@sage/x3-system';
	import { Node, integer, Reference, date } from '@sage/xtrem-core';
	import * as sageX3PurchasingData from '@sage/x3-purchasing-data/lib/index';
	export class ShipmentDocuments extends Node {
	    readonly id: Promise<string>;
	    readonly entryType: Promise<sageX3StockData.enums.EntryTypeEnum | null>;
	    readonly shipmentDocumentLine: Promise<integer | null>;
	    readonly shipmentDocumentType: Reference<sageX3System.nodes.MiscellaneousTable | null>;
	    readonly shipmentDocumentOrigin: Promise<sageX3PurchasingData.enums.DocumentOrigin | null>;
	    readonly shipmentDocumentDate: Promise<date | null>;
	    readonly shipmentDocumentReference1: Promise<string>;
	    readonly shipmentDocumentReference2: Promise<string>;
	    readonly shipmentDocumentBusinessPartner: Reference<sageX3MasterData.nodes.BusinessPartner | null>;
	    readonly shipmentDocumentFileType: Reference<sageX3System.nodes.MiscellaneousTable | null>;
	    readonly shipmentDocumentFileName: Promise<string>;
	    readonly shipmentDocumentComments: Promise<string>;
	}
	//# sourceMappingURL=shipment-documents.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/nodes/purchase-price-reason.d.ts
declare module '@sage/x3-purchasing-data/lib/nodes/purchase-price-reason' {
	import { Node, integer } from '@sage/xtrem-core';
	export class PurchasePriceReason extends Node {
	    readonly code: Promise<integer | null>;
	    readonly localizedDescription: Promise<string>;
	}
	//# sourceMappingURL=purchase-price-reason.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/nodes/purchase-invoice-type.d.ts
declare module '@sage/x3-purchasing-data/lib/nodes/purchase-invoice-type' {
	import * as sageX3InvoicingData from '@sage/x3-invoicing-data';
	import * as sageX3MasterData from '@sage/x3-master-data';
	import * as sageX3System from '@sage/x3-system';
	import { Node, Reference } from '@sage/xtrem-core';
	export class PurchaseInvoiceType extends Node {
	    readonly code: Promise<string>;
	    readonly legislation: Reference<sageX3System.nodes.MiscellaneousTable | null>;
	    readonly localizedDescription: Promise<string>;
	    readonly localizedShortDescription: Promise<string>;
	    readonly purchaseInvoiceCategory: Promise<sageX3MasterData.enums.PurchaseInvoiceCategory>;
	    readonly invoiceCategory: Promise<sageX3InvoicingData.enums.InvoiceType | null>;
	}
	//# sourceMappingURL=purchase-invoice-type.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/nodes/matching-tolerance.d.ts
declare module '@sage/x3-purchasing-data/lib/nodes/matching-tolerance' {
	import { Node } from '@sage/xtrem-core';
	export class MatchingTolerance extends Node {
	    readonly code: Promise<string>;
	    readonly localizedDescription: Promise<string>;
	}
	//# sourceMappingURL=matching-tolerance.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/nodes/index.d.ts
declare module '@sage/x3-purchasing-data/lib/nodes/index' {
	export * from '@sage/x3-purchasing-data/lib/nodes/delivery-mode';
	export * from '@sage/x3-purchasing-data/lib/nodes/freight-container';
	export * from '@sage/x3-purchasing-data/lib/nodes/freight-cost-structure';
	export * from '@sage/x3-purchasing-data/lib/nodes/matching-tolerance';
	export * from '@sage/x3-purchasing-data/lib/nodes/purchase-invoice-type';
	export * from '@sage/x3-purchasing-data/lib/nodes/purchase-price-reason';
	export * from '@sage/x3-purchasing-data/lib/nodes/shipment-documents';
	export * from '@sage/x3-purchasing-data/lib/nodes/shipment-logistical-tracking';
	export * from '@sage/x3-purchasing-data/lib/nodes/transport-lead-time';
	//# sourceMappingURL=index.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/nodes/freight-cost-structure.d.ts
declare module '@sage/x3-purchasing-data/lib/nodes/freight-cost-structure' {
	import { Node } from '@sage/xtrem-core';
	export class FreightCostStructure extends Node {
	    readonly code: Promise<string>;
	    readonly localizedDescription: Promise<string>;
	    readonly isActive: Promise<boolean>;
	}
	//# sourceMappingURL=freight-cost-structure.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/nodes/freight-container.d.ts
declare module '@sage/x3-purchasing-data/lib/nodes/freight-container' {
	import * as sageX3MasterData from '@sage/x3-master-data';
	import * as sageX3System from '@sage/x3-system';
	import { Node, Reference, decimal } from '@sage/xtrem-core';
	export class FreightContainer extends Node {
	    readonly id: Promise<string>;
	    readonly containerIdentification: Promise<string>;
	    readonly site: Reference<sageX3System.nodes.Site | null>;
	    readonly supplier: Reference<sageX3MasterData.nodes.Supplier | null>;
	    readonly freightContainer: Reference<sageX3MasterData.nodes.Container>;
	    readonly isFull: Promise<boolean>;
	    readonly totalWeightOfLines: Promise<decimal | null>;
	    readonly weightUnit: Reference<sageX3MasterData.nodes.UnitOfMeasure | null>;
	    readonly totalVolumeOfLines: Promise<decimal | null>;
	    readonly volumeUnit: Reference<sageX3MasterData.nodes.UnitOfMeasure | null>;
	    readonly amountOfLinesExcludingTax: Promise<decimal | null>;
	    readonly currency: Reference<sageX3MasterData.nodes.Currency>;
	    readonly sealNumber1: Promise<string>;
	    readonly sealNumber2: Promise<string>;
	    readonly sealNumber3: Promise<string>;
	    readonly purchaseShipment: Promise<string>;
	    readonly totalWeightOfFreightContainer: Promise<decimal | null>;
	    readonly availableWeight: Promise<decimal | null>;
	    readonly availableVolume: Promise<decimal | null>;
	}
	//# sourceMappingURL=freight-container.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/nodes/delivery-mode.d.ts
declare module '@sage/x3-purchasing-data/lib/nodes/delivery-mode' {
	import { Node } from '@sage/xtrem-core';
	export class DeliveryMode extends Node {
	    readonly code: Promise<string>;
	    readonly localizedDescription: Promise<string>;
	    readonly localizedShortDescription: Promise<string>;
	}
	//# sourceMappingURL=delivery-mode.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/node-extensions/supplier-product-extension.d.ts
declare module '@sage/x3-purchasing-data/lib/node-extensions/supplier-product-extension' {
	import * as sageX3MasterData from '@sage/x3-master-data';
	import { NodeExtension, Reference } from '@sage/xtrem-core';
	import * as sageX3PurchasingData from '@sage/x3-purchasing-data/lib/index';
	export class SupplierProductExtension extends NodeExtension<sageX3MasterData.nodes.SupplierProduct> {
	    readonly costStructure: Reference<sageX3PurchasingData.nodes.FreightCostStructure | null>;
	    readonly blockingManagementMode: Promise<sageX3PurchasingData.enums.Conflict | null>;
	    readonly matchingTolerance: Reference<sageX3PurchasingData.nodes.MatchingTolerance | null>;
	}
	declare module '@sage/x3-master-data/lib/nodes/supplier-product' {
	    interface SupplierProduct extends SupplierProductExtension {
	    }
	}
	//# sourceMappingURL=supplier-product-extension.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/node-extensions/supplier-invoice-header-extension.d.ts
declare module '@sage/x3-purchasing-data/lib/node-extensions/supplier-invoice-header-extension' {
	import * as sageX3InvoicingData from '@sage/x3-invoicing-data';
	import { NodeExtension, Reference } from '@sage/xtrem-core';
	import * as sageX3PurchasingData from '@sage/x3-purchasing-data/lib/index';
	export class SupplierInvoiceHeaderExtension extends NodeExtension<sageX3InvoicingData.nodes.SupplierInvoiceHeader> {
	    readonly invoiceType: Reference<sageX3PurchasingData.nodes.PurchaseInvoiceType | null>;
	}
	declare module '@sage/x3-invoicing-data/lib/nodes/supplier-invoice-header' {
	    interface SupplierInvoiceHeader extends SupplierInvoiceHeaderExtension {
	    }
	}
	//# sourceMappingURL=supplier-invoice-header-extension.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/node-extensions/supplier-extension.d.ts
declare module '@sage/x3-purchasing-data/lib/node-extensions/supplier-extension' {
	import * as sageX3MasterData from '@sage/x3-master-data';
	import * as sageX3PurchasingData from '@sage/x3-purchasing-data/lib/index';
	import { NodeExtension } from '@sage/xtrem-core';
	export class SupplierExtension extends NodeExtension<sageX3MasterData.nodes.Supplier> {
	    readonly supplierType: Promise<sageX3PurchasingData.enums.SupplierType | null>;
	    readonly dueDateOrigin: Promise<sageX3PurchasingData.enums.DueDateCalculationBase | null>;
	    readonly currencyRateDetermination: Promise<sageX3PurchasingData.enums.CurrencyRateSearchDate | null>;
	    readonly disputeStatus: Promise<sageX3PurchasingData.enums.Conflict | null>;
	}
	declare module '@sage/x3-master-data/lib/nodes/supplier' {
	    interface Supplier extends SupplierExtension {
	    }
	}
	//# sourceMappingURL=supplier-extension.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/node-extensions/ship-to-customer-address-extension.d.ts
declare module '@sage/x3-purchasing-data/lib/node-extensions/ship-to-customer-address-extension' {
	import * as sageX3MasterData from '@sage/x3-master-data';
	import { NodeExtension, Reference } from '@sage/xtrem-core';
	import * as sageX3PurchasingData from '@sage/x3-purchasing-data/lib/index';
	export class ShipToCustomerAddressExtension extends NodeExtension<sageX3MasterData.nodes.ShipToCustomerAddress> {
	    readonly deliveryMode: Reference<sageX3PurchasingData.nodes.DeliveryMode | null>;
	}
	declare module '@sage/x3-master-data/lib/nodes/ship-to-customer-address' {
	    interface ShipToCustomerAddress extends ShipToCustomerAddressExtension {
	    }
	}
	//# sourceMappingURL=ship-to-customer-address-extension.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/node-extensions/product-extension.d.ts
declare module '@sage/x3-purchasing-data/lib/node-extensions/product-extension' {
	import * as sageX3MasterData from '@sage/x3-master-data';
	import { NodeExtension, Reference } from '@sage/xtrem-core';
	import * as sageX3PurchasingData from '@sage/x3-purchasing-data/lib/index';
	export class ProductExtension extends NodeExtension<sageX3MasterData.nodes.Product> {
	    readonly costStructure: Reference<sageX3PurchasingData.nodes.FreightCostStructure | null>;
	    readonly matchingTolerance: Reference<sageX3PurchasingData.nodes.MatchingTolerance | null>;
	}
	declare module '@sage/x3-master-data/lib/nodes/product' {
	    interface Product extends ProductExtension {
	    }
	}
	//# sourceMappingURL=product-extension.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/node-extensions/product-category-extension.d.ts
declare module '@sage/x3-purchasing-data/lib/node-extensions/product-category-extension' {
	import * as sageX3MasterData from '@sage/x3-master-data';
	import { NodeExtension, Reference } from '@sage/xtrem-core';
	import * as sageX3PurchasingData from '@sage/x3-purchasing-data/lib/index';
	export class ProductCategoryExtension extends NodeExtension<sageX3MasterData.nodes.ProductCategory> {
	    readonly costStructure: Reference<sageX3PurchasingData.nodes.FreightCostStructure | null>;
	    readonly matchingTolerance: Reference<sageX3PurchasingData.nodes.MatchingTolerance | null>;
	}
	declare module '@sage/x3-master-data/lib/nodes/product-category' {
	    interface ProductCategory extends ProductCategoryExtension {
	    }
	}
	//# sourceMappingURL=product-category-extension.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/node-extensions/index.d.ts
declare module '@sage/x3-purchasing-data/lib/node-extensions/index' {
	export * from '@sage/x3-purchasing-data/lib/node-extensions/product-category-extension';
	export * from '@sage/x3-purchasing-data/lib/node-extensions/product-extension';
	export * from '@sage/x3-purchasing-data/lib/node-extensions/ship-to-customer-address-extension';
	export * from '@sage/x3-purchasing-data/lib/node-extensions/supplier-extension';
	export * from '@sage/x3-purchasing-data/lib/node-extensions/supplier-invoice-header-extension';
	export * from '@sage/x3-purchasing-data/lib/node-extensions/supplier-product-extension';
	//# sourceMappingURL=index.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/enums/transport-mode.d.ts
declare module '@sage/x3-purchasing-data/lib/enums/transport-mode' {
	import { X3EnumDataType } from '@sage/xtrem-x3-gateway';
	export enum TransportModeEnum {
	    air = 1,
	    sea = 2,
	    road = 3,
	    rail = 4,
	    multimodal = 5,
	    notDefined = 6
	}
	export interface TransportMode$EnumInterface {
	    air: 1;
	    sea: 2;
	    road: 3;
	    rail: 4;
	    multimodal: 5;
	    notDefined: 6;
	}
	export type TransportMode = keyof TransportMode$EnumInterface;
	export const transportModeDatatype: X3EnumDataType<keyof TransportMode$EnumInterface, unknown>;
	//# sourceMappingURL=transport-mode.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/enums/tracking-step-status.d.ts
declare module '@sage/x3-purchasing-data/lib/enums/tracking-step-status' {
	import { X3EnumDataType } from '@sage/xtrem-x3-gateway';
	export enum TrackingStepStatusEnum {
	    toDo = 1,
	    inProgress = 2,
	    completed = 3
	}
	export interface TrackingStepStatus$EnumInterface {
	    toDo: 1;
	    inProgress: 2;
	    completed: 3;
	}
	export type TrackingStepStatus = keyof TrackingStepStatus$EnumInterface;
	export const trackingStepStatusDatatype: X3EnumDataType<keyof TrackingStepStatus$EnumInterface, unknown>;
	//# sourceMappingURL=tracking-step-status.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/enums/supplier-type.d.ts
declare module '@sage/x3-purchasing-data/lib/enums/supplier-type' {
	import { X3EnumDataType } from '@sage/xtrem-x3-gateway';
	export enum SupplierTypeEnum {
	    normal = 1,
	    prospect = 2,
	    miscellaneous = 3
	}
	export interface SupplierType$EnumInterface {
	    normal: 1;
	    prospect: 2;
	    miscellaneous: 3;
	}
	export type SupplierType = keyof SupplierType$EnumInterface;
	export const supplierTypeDatatype: X3EnumDataType<keyof SupplierType$EnumInterface, unknown>;
	//# sourceMappingURL=supplier-type.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/enums/index.d.ts
declare module '@sage/x3-purchasing-data/lib/enums/index' {
	export * from '@sage/x3-purchasing-data/lib/enums/conflict';
	export * from '@sage/x3-purchasing-data/lib/enums/currency-rate-search-date';
	export * from '@sage/x3-purchasing-data/lib/enums/document-origin';
	export * from '@sage/x3-purchasing-data/lib/enums/due-date-calculation-base';
	export * from '@sage/x3-purchasing-data/lib/enums/supplier-type';
	export * from '@sage/x3-purchasing-data/lib/enums/tracking-step-status';
	export * from '@sage/x3-purchasing-data/lib/enums/transport-mode';
	//# sourceMappingURL=index.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/enums/due-date-calculation-base.d.ts
declare module '@sage/x3-purchasing-data/lib/enums/due-date-calculation-base' {
	import { X3EnumDataType } from '@sage/xtrem-x3-gateway';
	export enum DueDateCalculationBaseEnum {
	    receiptDate = 1,
	    invoiceDate = 2
	}
	export interface DueDateCalculationBase$EnumInterface {
	    receiptDate: 1;
	    invoiceDate: 2;
	}
	export type DueDateCalculationBase = keyof DueDateCalculationBase$EnumInterface;
	export const dueDateCalculationBaseDatatype: X3EnumDataType<keyof DueDateCalculationBase$EnumInterface, unknown>;
	//# sourceMappingURL=due-date-calculation-base.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/enums/document-origin.d.ts
declare module '@sage/x3-purchasing-data/lib/enums/document-origin' {
	import { X3EnumDataType } from '@sage/xtrem-x3-gateway';
	export enum DocumentOriginEnum {
	    notApplicable = 1,
	    air = 2,
	    sea = 3,
	    road = 4,
	    rail = 5
	}
	export interface DocumentOrigin$EnumInterface {
	    notApplicable: 1;
	    air: 2;
	    sea: 3;
	    road: 4;
	    rail: 5;
	}
	export type DocumentOrigin = keyof DocumentOrigin$EnumInterface;
	export const documentOriginDatatype: X3EnumDataType<keyof DocumentOrigin$EnumInterface, unknown>;
	//# sourceMappingURL=document-origin.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/enums/currency-rate-search-date.d.ts
declare module '@sage/x3-purchasing-data/lib/enums/currency-rate-search-date' {
	import { X3EnumDataType } from '@sage/xtrem-x3-gateway';
	export enum CurrencyRateSearchDateEnum {
	    orderDate = 1,
	    receiptDate = 2,
	    invoiceDate = 3
	}
	export interface CurrencyRateSearchDate$EnumInterface {
	    orderDate: 1;
	    receiptDate: 2;
	    invoiceDate: 3;
	}
	export type CurrencyRateSearchDate = keyof CurrencyRateSearchDate$EnumInterface;
	export const currencyRateSearchDateDatatype: X3EnumDataType<keyof CurrencyRateSearchDate$EnumInterface, unknown>;
	//# sourceMappingURL=currency-rate-search-date.d.ts.map
}
// From file: /agent/_work/1/s/x3-services/shared/x3-purchasing-data/build/lib/enums/conflict.d.ts
declare module '@sage/x3-purchasing-data/lib/enums/conflict' {
	import { X3EnumDataType } from '@sage/xtrem-x3-gateway';
	export enum ConflictEnum {
	    no = 1,
	    warning = 2,
	    hold = 3
	}
	export interface Conflict$EnumInterface {
	    no: 1;
	    warning: 2;
	    hold: 3;
	}
	export type Conflict = keyof Conflict$EnumInterface;
	export const conflictDatatype: X3EnumDataType<keyof Conflict$EnumInterface, unknown>;
	//# sourceMappingURL=conflict.d.ts.map
}
declare module '@sage/x3-purchasing-data' {
	export * from '@sage/x3-purchasing-data/index';
}
