declare module '@sage/x3-master-data-api-partial' {
    import type { Country, Package as SageX3Structure$Package, SiteGroupings } from '@sage/x3-structure-api';
    import type {
        Access,
        Company,
        GenericPrintReport,
        Image,
        Language,
        MiscellaneousTable,
        Package as SageX3System$Package,
        Site,
        SiteInput,
        User,
    } from '@sage/x3-system-api';
    import type { Package as SageXtremAppMetadata$Package } from '@sage/xtrem-app-metadata-api';
    import type { Package as SageXtremX3SystemUtils$Package, SysUser } from '@sage/xtrem-x3-system-utils-api';
    import type {
        AggregateQueryOperation,
        AggregateReadOperation,
        BinaryStream,
        ClientCollection,
        ClientNode,
        ClientNodeInput,
        CreateOperation,
        GetDefaultsOperation,
        GetDuplicateOperation,
        Operation as Node$Operation,
        QueryOperation,
        ReadOperation,
        TextStream,
        UpdateByIdOperation,
        UpdateOperation,
        VitalClientNode,
        VitalClientNodeInput,
        decimal,
        integer,
    } from '@sage/xtrem-client';
    export interface AcceptableQualityLevel$Enum {
        substituteValue1: 1;
        substituteValue2: 2;
        substituteValue3: 3;
        substituteValue4: 4;
        substituteValue5: 5;
        substituteValue6: 6;
        substituteValue7: 7;
        substituteValue8: 8;
        substituteValue9: 9;
        substituteValue10: 10;
        substituteValue11: 11;
        substituteValue12: 12;
    }
    export type AcceptableQualityLevel = keyof AcceptableQualityLevel$Enum;
    export interface AccountingCodeType$Enum {
        product: 1;
        customer: 2;
        supplier: 3;
        salesRep: 4;
        buyer: 5;
        journal: 6;
        company: 7;
        site: 8;
        currency: 9;
        tax: 10;
        salesFooter: 11;
        discount: 12;
        bank: 13;
        payment: 14;
        fixedAssets: 15;
        purchaseFooter: 16;
        miscellaneousBusinessPartners: 17;
        costCenter: 18;
        overheads: 19;
        expensesCosts: 20;
        factor: 21;
        leaseContract: 22;
        grant: 23;
        concessionAgreement: 24;
        cost: 25;
        interface: 26;
        employee: 27;
        department: 28;
        profile: 29;
        user: 30;
        fund: 31;
        allocation: 32;
        contribution: 33;
        expenseNote: 34;
        accountingContract: 35;
        projectCostType: 36;
        project: 37;
    }
    export type AccountingCodeType = keyof AccountingCodeType$Enum;
    export interface AllocationStatus$Enum {
        notAllocated: 1;
        partlyAllocated: 2;
        allocated: 3;
    }
    export type AllocationStatus = keyof AllocationStatus$Enum;
    export interface AllocationType$Enum {
        global: 1;
        detailed: 2;
    }
    export type AllocationType = keyof AllocationType$Enum;
    export interface BomCodeType$Enum {
        salesKit: 1;
        manufacturing: 2;
        subcontracting: 3;
    }
    export type BomCodeType = keyof BomCodeType$Enum;
    export interface BomQuantityLink$Enum {
        proportional: 1;
        fixed: 2;
    }
    export type BomQuantityLink = keyof BomQuantityLink$Enum;
    export interface ChargeDiscountCalculation$Enum {
        byUnit: 1;
        byLine: 2;
        byDocument: 3;
    }
    export type ChargeDiscountCalculation = keyof ChargeDiscountCalculation$Enum;
    export interface CodeToServe$Enum {
        componentNotWeighedOnWeighingStations: 1;
        componentWeighedOnWeighingStations: 2;
        componentWeighedInProduction: 3;
        excipientPhaseOnWeighingStations: 4;
        excipientPhaseInManufacturing: 5;
        finalWorkOrderExcipientPhaseOnWeighingStations: 6;
        finalWorkOrderExcipientPhaseInManufacturing: 7;
        materialCorrectionOnWeighingStations: 8;
        materialCorrectionInManufacturing: 9;
        qsfAtEndOfManufacture: 10;
    }
    export type CodeToServe = keyof CodeToServe$Enum;
    export interface CommissionCategory$Enum {
        category1: 1;
        category2: 2;
        category3: 3;
    }
    export type CommissionCategory = keyof CommissionCategory$Enum;
    export interface ComponentRounded$Enum {
        roundToTheNearest: 1;
        greaterThan: 2;
        lessThan: 3;
    }
    export type ComponentRounded = keyof ComponentRounded$Enum;
    export interface ComponentType$Enum {
        normal: 1;
        option: 2;
        variant: 3;
        byProduct: 4;
        text: 5;
        costing: 6;
        service: 7;
        multipleOption: 8;
        normalWithFormula: 9;
    }
    export type ComponentType = keyof ComponentType$Enum;
    export interface Count$Enum {
        cycleCount: 1;
        annualCount: 2;
        noCount: 3;
    }
    export type Count = keyof Count$Enum;
    export interface CountryLocation$Enum {
        domestic: 1;
        otherEu: 2;
        outsideEu: 3;
    }
    export type CountryLocation = keyof CountryLocation$Enum;
    export interface DiscountCalculationRules$Enum {
        amount: 1;
        combined: 2;
        series: 3;
    }
    export type DiscountCalculationRules = keyof DiscountCalculationRules$Enum;
    export interface DocumentType$Enum {
        siteTaxIdNumber: 1;
        intracommunityTaxIdNumber: 2;
        passport: 3;
        officialDocument: 4;
        fiscalResidenceCertificate: 5;
        others: 6;
        notRegistered: 7;
    }
    export type DocumentType = keyof DocumentType$Enum;
    export interface ElectronicInvoiceType$Enum {
        notUsed: 1;
        xmlByMail: 2;
        pdfByMail: 3;
        eInvoiceFileByMail: 4;
        xmlByPlatform: 5;
        pdfByPlatform: 6;
        eInvoiceFileByPlatform: 7;
    }
    export type ElectronicInvoiceType = keyof ElectronicInvoiceType$Enum;
    export interface EmployeeType$Enum {
        employee: 1;
        detailedTeam: 2;
        summaryTeam: 3;
    }
    export type EmployeeType = keyof EmployeeType$Enum;
    export interface ExpirationManagement$Enum {
        notManaged: 1;
        withoutRounding: 2;
        roundingMonthEnd: 3;
        roundingBeginningMonth1: 4;
        mandatoryEntry: 5;
        manualEntry: 6;
    }
    export type ExpirationManagement = keyof ExpirationManagement$Enum;
    export interface FiscalYearPeriodStatus$Enum {
        notOpen: 1;
        open: 2;
        closed: 3;
    }
    export type FiscalYearPeriodStatus = keyof FiscalYearPeriodStatus$Enum;
    export interface Flow$Enum {
        kit: 1;
        manufacturingBom: 2;
        subContractBom: 3;
        stock: 4;
    }
    export type Flow = keyof Flow$Enum;
    export interface FunctionContact$Enum {
        ceo: 1;
        salesManager: 2;
        technicalManager: 3;
        purchasingManager: 4;
        buyer: 5;
        stockManager: 6;
        financialAndLegalManager: 7;
        importExportManager: 8;
        siteManager: 9;
        externalActor: 10;
        other: 11;
        chiefHumanResourcesOfficer: 12;
    }
    export type FunctionContact = keyof FunctionContact$Enum;
    export interface GeneralControlLevel$Enum {
        i: 1;
        ii: 2;
        iii: 3;
        undefined: 4;
    }
    export type GeneralControlLevel = keyof GeneralControlLevel$Enum;
    export interface GeneralLedgerTypes$Enum {
        legal: 1;
        analytical: 2;
        ias: 3;
        genLedger4: 4;
        genLedger5: 5;
        genLedger6: 6;
        genLedger7: 7;
        genLedger8: 8;
        genLedger9: 9;
        genLedger10: 10;
    }
    export type GeneralLedgerTypes = keyof GeneralLedgerTypes$Enum;
    export interface IncreaseDecrease$Enum {
        increase: 1;
        decrease: 2;
    }
    export type IncreaseDecrease = keyof IncreaseDecrease$Enum;
    export interface InternalContainerType$Enum {
        container: 1;
        pallet: 2;
        pack: 3;
        parcel: 4;
        other: 5;
        bigBags: 6;
        barrel: 7;
    }
    export type InternalContainerType = keyof InternalContainerType$Enum;
    export interface IntrastatTransportMode$Enum {
        bySea: 1;
        byRail: 2;
        byRoad: 3;
        byAir: 4;
        byMail: 5;
        substituteValue6: 6;
        byInlandNavigation: 7;
        internalNavigation: 8;
        selfPropelled: 9;
    }
    export type IntrastatTransportMode = keyof IntrastatTransportMode$Enum;
    export interface InvoiceStatus$Enum {
        notPosted: 1;
        notUsed: 2;
        posted: 3;
    }
    export type InvoiceStatus = keyof InvoiceStatus$Enum;
    export interface LeadTimeUnit$Enum {
        calendarDays: 1;
        workDays: 2;
        weeks: 3;
        fortnights: 4;
        months: 5;
    }
    export type LeadTimeUnit = keyof LeadTimeUnit$Enum;
    export interface LineStatus$Enum {
        pending: 1;
        late: 2;
        closed: 3;
    }
    export type LineStatus = keyof LineStatus$Enum;
    export interface LotIssueExpirationUbd$Enum {
        noExpirationDateControl: 1;
        noUseByDateControl: 2;
        yes: 3;
    }
    export type LotIssueExpirationUbd = keyof LotIssueExpirationUbd$Enum;
    export interface LowLevelType$Enum {
        business: 1;
        manufacturingSubcontracting: 2;
    }
    export type LowLevelType = keyof LowLevelType$Enum;
    export interface ManagementUnit$Enum {
        one: 1;
        perHundred: 2;
        perThousand: 3;
        percentage: 4;
        byLot: 5;
    }
    export type ManagementUnit = keyof ManagementUnit$Enum;
    export interface MaterialReplenishType$Enum {
        internal: 1;
        toBeSentToTheSubcontractor: 2;
        suppliedByTheSubcontractor: 3;
    }
    export type MaterialReplenishType = keyof MaterialReplenishType$Enum;
    export interface NoInPartInFull$Enum {
        no: 1;
        inPart: 2;
        inFull: 3;
        notManaged: 4;
        automatic: 5;
    }
    export type NoInPartInFull = keyof NoInPartInFull$Enum;
    export interface OpenItemType$Enum {
        openItem: 1;
        prepayment: 2;
        holdback: 3;
    }
    export type OpenItemType = keyof OpenItemType$Enum;
    export interface OriginType$Enum {
        manual: 1;
        generated: 2;
        synchronization: 3;
        import: 4;
    }
    export type OriginType = keyof OriginType$Enum;
    export interface PaymentApprovalType$Enum {
        pending: 1;
        conflict: 2;
        delayed: 3;
        authorizedToPay: 4;
    }
    export type PaymentApprovalType = keyof PaymentApprovalType$Enum;
    export interface PlaceType$Enum {
        harbor: 1;
        airport: 2;
        station: 3;
        warehouse: 4;
        customs: 5;
        site: 6;
        supplier: 7;
        other: 8;
    }
    export type PlaceType = keyof PlaceType$Enum;
    export interface PriceAmountTaxTax$Enum {
        excludeTax: 1;
        includeTax: 2;
    }
    export type PriceAmountTaxTax = keyof PriceAmountTaxTax$Enum;
    export interface PriceOrigin$Enum {
        entered: 1;
        purchasePrice: 2;
    }
    export type PriceOrigin = keyof PriceOrigin$Enum;
    export interface PriceUpdateMode$Enum {
        calculated: 1;
        entered: 2;
    }
    export type PriceUpdateMode = keyof PriceUpdateMode$Enum;
    export interface ProductAbcClass$Enum {
        classA: 1;
        classB: 2;
        classC: 3;
        classD: 4;
    }
    export type ProductAbcClass = keyof ProductAbcClass$Enum;
    export interface ProductCreationMode$Enum {
        direct: 1;
        withValidation: 2;
    }
    export type ProductCreationMode = keyof ProductCreationMode$Enum;
    export interface ProductSearchCriteria$Enum {
        none: 1;
        supplierUpcCode: 2;
        supplierProductCode: 3;
        x3UpcCode: 4;
        x3ProductDescription: 5;
    }
    export type ProductSearchCriteria = keyof ProductSearchCriteria$Enum;
    export interface ProductStatus$Enum {
        active: 1;
        inDevelopment: 2;
        onShortage: 3;
        notRenewed: 4;
        obsolete: 5;
        notUsable: 6;
    }
    export type ProductStatus = keyof ProductStatus$Enum;
    export interface ProductType$Enum {
        goods: 1;
        rawMaterialsSubsidiariesAndConsumables: 2;
        finishedAndIntermediateGoods: 3;
        byProductsWasteAndScrap: 4;
        productsAndWorksInProgress: 5;
        notApplicable: 6;
    }
    export type ProductType = keyof ProductType$Enum;
    export interface ProjectAllocationType$Enum {
        crm: 1;
        project: 2;
        mixedProject: 3;
        budget: 4;
        laborTask: 5;
        materialTask: 6;
        mixedTask: 7;
        miscellaneous: 8;
    }
    export type ProjectAllocationType = keyof ProjectAllocationType$Enum;
    export interface ProjectOrigins$Enum {
        manualCreation: 1;
        massMail: 2;
        callCampaign: 3;
        tradeShow: 4;
        mediaCampaign: 5;
        serviceRequest: 6;
        marketingCampaign: 7;
    }
    export type ProjectOrigins = keyof ProjectOrigins$Enum;
    export interface PurchaseInvoiceCategory$Enum {
        invoice: 1;
        additionalInvoice: 2;
        creditMemo: 3;
        creditMemoReturn: 4;
    }
    export type PurchaseInvoiceCategory = keyof PurchaseInvoiceCategory$Enum;
    export interface RelatedCompanySettings$Enum {
        notRelated: 1;
        votingRightsMoreThanOrEqual10Percent: 2;
        votingRightsLessThan10Percent: 3;
    }
    export type RelatedCompanySettings = keyof RelatedCompanySettings$Enum;
    export interface ReminderType$Enum {
        noReminder: 1;
        byInvoice: 2;
        global: 3;
        globalByLevel: 4;
        globalByDate: 5;
    }
    export type ReminderType = keyof ReminderType$Enum;
    export interface RuleFlow$Enum {
        receipt: 1;
        shipment: 2;
    }
    export type RuleFlow = keyof RuleFlow$Enum;
    export interface SafTProductType$Enum {
        none: 1;
        product: 2;
        service: 3;
        other: 4;
    }
    export type SafTProductType = keyof SafTProductType$Enum;
    export interface SamplingMode$Enum {
        global: 1;
        lot: 2;
        noManagement: 3;
    }
    export type SamplingMode = keyof SamplingMode$Enum;
    export interface SamplingType$Enum {
        none: 1;
        single: 2;
    }
    export type SamplingType = keyof SamplingType$Enum;
    export interface Sense$Enum {
        outbound: 1;
        inbound: 2;
    }
    export type Sense = keyof Sense$Enum;
    export interface SerialNumberManagement$Enum {
        notManaged: 1;
        issued: 2;
        receivedIssued: 3;
        globalReceivedIssued: 4;
    }
    export type SerialNumberManagement = keyof SerialNumberManagement$Enum;
    export interface SpanishInvoiceType$Enum {
        f1FacturaArt677Y73DelRd16192012: 1;
        f2FacturaSimplificadaTicketYFacturasArt61DRd16192012: 2;
        r1RectificativaArt801Y802YErrorFundadoEnDerecho: 3;
        r2RectificativaArt803: 4;
        r3RectificativaArt804: 5;
        r4RectificativaResto: 6;
        r5RectificativaEnFacturasSimplificadas: 7;
        f3FacturaEmitidaEnSustitucionDeSimplificadas: 8;
        f4AsientoResumenDeFacturas: 9;
        f5ImportacionesDua: 10;
        f6OtrosJustificantesContables: 11;
        lcAduanasLiquidacionComplementaria: 12;
    }
    export type SpanishInvoiceType = keyof SpanishInvoiceType$Enum;
    export interface StandardProductCode$Enum {
        notManaged: 1;
        byProject: 2;
        availableStock: 3;
        byOrder: 4;
    }
    export type StandardProductCode = keyof StandardProductCode$Enum;
    export interface StockManagement$Enum {
        notManaged: 1;
        managed: 2;
        potencyManaged: 3;
    }
    export type StockManagement = keyof StockManagement$Enum;
    export interface StockWithdrawalMode$Enum {
        immediate: 1;
        backflush: 2;
        all: 3;
    }
    export type StockWithdrawalMode = keyof StockWithdrawalMode$Enum;
    export interface StockWithdrawal$Enum {
        immediate: 1;
        backflush: 2;
        notManaged: 3;
    }
    export type StockWithdrawal = keyof StockWithdrawal$Enum;
    export interface SubjectToControl$Enum {
        noControl: 1;
        nonChangeableControl: 2;
        changeableControl: 3;
        periodicControl: 4;
    }
    export type SubjectToControl = keyof SubjectToControl$Enum;
    export interface SuggestionType$Enum {
        noSuggestion: 1;
        purchase: 2;
        manufacturing: 3;
        intersite: 4;
        subcontracting: 5;
    }
    export type SuggestionType = keyof SuggestionType$Enum;
    export interface SupplierCustomerType$Enum {
        customer: 1;
        supplier: 2;
    }
    export type SupplierCustomerType = keyof SupplierCustomerType$Enum;
    export interface Timing$Enum {
        day: 1;
        week: 2;
        month: 3;
    }
    export type Timing = keyof Timing$Enum;
    export interface ToleranceDefinitionLevel$Enum {
        substituteValue1: 1;
        shiSheetRecord: 2;
        productSite: 3;
        bom: 4;
    }
    export type ToleranceDefinitionLevel = keyof ToleranceDefinitionLevel$Enum;
    export interface Trigger$Enum {
        document: 1;
        sourceDocument: 2;
    }
    export type Trigger = keyof Trigger$Enum;
    export interface TypeOfAllocation$Enum {
        global: 1;
        detailed: 2;
        notUsed1: 3;
        detailedShortage: 4;
        globalShortage: 5;
        notUsed2: 6;
    }
    export type TypeOfAllocation = keyof TypeOfAllocation$Enum;
    export interface TypeOfProduct$Enum {
        other: 1;
        part: 2;
        labor: 3;
        expenses: 4;
        serviceContract: 5;
    }
    export type TypeOfProduct = keyof TypeOfProduct$Enum;
    export interface UnpackingRulesPac$Enum {
        unpack: 1;
        adjustCoefficientRecalcPacCoeff: 2;
        fractionCalculateDecimalPac: 3;
    }
    export type UnpackingRulesPac = keyof UnpackingRulesPac$Enum;
    export interface UseStatus$Enum {
        inDevelopment: 1;
        availableToUse: 2;
    }
    export type UseStatus = keyof UseStatus$Enum;
    export interface ValueType$Enum {
        taxExcluded: 1;
        taxIncluded: 2;
        substituteValue3: 3;
    }
    export type ValueType = keyof ValueType$Enum;
    export interface VersionStatus$Enum {
        prototypeVersion: 1;
        activeVersion: 2;
        stoppedVersion: 3;
        toActivateVersion: 4;
    }
    export type VersionStatus = keyof VersionStatus$Enum;
    export interface WorkInProgressControl$Enum {
        check: 1;
        noCheck: 2;
        hold: 3;
    }
    export type WorkInProgressControl = keyof WorkInProgressControl$Enum;
    export interface AddressAddressEmails extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        entityNumber: string;
        code: string;
        addressEmail: string;
        emailType: EmailAddressType;
    }
    export interface AddressAddressEmailsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        entityNumber?: string;
        code?: string;
        addressEmail?: string;
    }
    export interface AddressAddressEmailsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        entityNumber: string;
        code: string;
        addressEmail: string;
        emailType: EmailAddressType;
    }
    export interface AddressAddressEmails$Operations {
        query: QueryOperation<AddressAddressEmails>;
        read: ReadOperation<AddressAddressEmails>;
        aggregate: {
            read: AggregateReadOperation<AddressAddressEmails>;
            query: AggregateQueryOperation<AddressAddressEmails>;
        };
        getDefaults: GetDefaultsOperation<AddressAddressEmails>;
    }
    export interface AddressAddressLines extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        entityNumber: string;
        code: string;
        addressLine: string;
    }
    export interface AddressAddressLinesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        entityNumber?: string;
        code?: string;
        addressLine?: string;
    }
    export interface AddressAddressLinesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        entityNumber: string;
        code: string;
        addressLine: string;
    }
    export interface AddressAddressLines$Operations {
        query: QueryOperation<AddressAddressLines>;
        read: ReadOperation<AddressAddressLines>;
        aggregate: {
            read: AggregateReadOperation<AddressAddressLines>;
            query: AggregateQueryOperation<AddressAddressLines>;
        };
        getDefaults: GetDefaultsOperation<AddressAddressLines>;
    }
    export interface AddressAddressPhoneNumbers extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        entityNumber: string;
        code: string;
        addressPhoneNumber: string;
        phoneType: TelephoneType;
    }
    export interface AddressAddressPhoneNumbersInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        entityNumber?: string;
        code?: string;
        addressPhoneNumber?: string;
    }
    export interface AddressAddressPhoneNumbersBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        entityNumber: string;
        code: string;
        addressPhoneNumber: string;
        phoneType: TelephoneType;
    }
    export interface AddressAddressPhoneNumbers$Operations {
        query: QueryOperation<AddressAddressPhoneNumbers>;
        read: ReadOperation<AddressAddressPhoneNumbers>;
        aggregate: {
            read: AggregateReadOperation<AddressAddressPhoneNumbers>;
            query: AggregateQueryOperation<AddressAddressPhoneNumbers>;
        };
        getDefaults: GetDefaultsOperation<AddressAddressPhoneNumbers>;
    }
    export interface Address extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        entityNumber: string;
        code: string;
        description: string;
        defaultBankId: BankDetail;
        isDefault: boolean;
        zipCode: string;
        city: string;
        state: string;
        country: Country;
        countryName: string;
        website: string;
        externalIdentifier: string;
        isValid: boolean;
        addressEmails: ClientCollection<AddressAddressEmails>;
        addressLines: ClientCollection<AddressAddressLines>;
        addressPhoneNumbers: ClientCollection<AddressAddressPhoneNumbers>;
    }
    export interface AddressInput extends ClientNodeInput {
        entityType?: EntityType;
        entityNumber?: string;
        code?: string;
        description?: string;
        defaultBankId?: string;
        isDefault?: boolean | string;
        zipCode?: string;
        city?: string;
        state?: string;
        country?: string;
        countryName?: string;
        website?: string;
        externalIdentifier?: string;
        isValid?: boolean | string;
        addressEmails?: Partial<AddressAddressEmailsInput>[];
        addressLines?: Partial<AddressAddressLinesInput>[];
        addressPhoneNumbers?: Partial<AddressAddressPhoneNumbersInput>[];
    }
    export interface AddressBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        entityNumber: string;
        code: string;
        description: string;
        defaultBankId: BankDetail;
        isDefault: boolean;
        zipCode: string;
        city: string;
        state: string;
        country: Country;
        countryName: string;
        website: string;
        externalIdentifier: string;
        isValid: boolean;
        addressEmails: ClientCollection<AddressAddressEmailsBinding>;
        addressLines: ClientCollection<AddressAddressLinesBinding>;
        addressPhoneNumbers: ClientCollection<AddressAddressPhoneNumbersBinding>;
    }
    export interface Address$Lookups {
        defaultBankId: QueryOperation<BankDetail>;
        country: QueryOperation<Country>;
    }
    export interface Address$Operations {
        query: QueryOperation<Address>;
        read: ReadOperation<Address>;
        aggregate: {
            read: AggregateReadOperation<Address>;
            query: AggregateQueryOperation<Address>;
        };
        lookups(dataOrId: string | { data: AddressInput }): Address$Lookups;
        getDefaults: GetDefaultsOperation<Address>;
    }
    export interface BankDetail extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        entityNumber: string;
        bankId: string;
        address: Address;
        byDefault: boolean;
        beneficiary: string;
        payingBank1: string;
        payingBank2: string;
        payingBank3: string;
        payingBank4: string;
        ibanPrefix: string;
        bic: string;
        country: Country;
        currency: Currency;
        intermediaryBankName: string;
        intermediaryBankAddress1: string;
        intermediaryBankAddress2: string;
        intermediaryBankAddress3: string;
        intermediaryBankBic: string;
        intermediaryBankCountry: Country;
        nonResidentAccount: boolean;
        isrCustomerNumber: string;
    }
    export interface BankDetailInput extends ClientNodeInput {
        entityType?: EntityType;
        entityNumber?: string;
        bankId?: string;
        address?: string;
        byDefault?: boolean | string;
        beneficiary?: string;
        payingBank1?: string;
        payingBank2?: string;
        payingBank3?: string;
        payingBank4?: string;
        ibanPrefix?: string;
        bic?: string;
        country?: string;
        currency?: string;
        intermediaryBankName?: string;
        intermediaryBankAddress1?: string;
        intermediaryBankAddress2?: string;
        intermediaryBankAddress3?: string;
        intermediaryBankBic?: string;
        intermediaryBankCountry?: string;
        nonResidentAccount?: boolean | string;
        isrCustomerNumber?: string;
    }
    export interface BankDetailBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        entityNumber: string;
        bankId: string;
        address: Address;
        byDefault: boolean;
        beneficiary: string;
        payingBank1: string;
        payingBank2: string;
        payingBank3: string;
        payingBank4: string;
        ibanPrefix: string;
        bic: string;
        country: Country;
        currency: Currency;
        intermediaryBankName: string;
        intermediaryBankAddress1: string;
        intermediaryBankAddress2: string;
        intermediaryBankAddress3: string;
        intermediaryBankBic: string;
        intermediaryBankCountry: Country;
        nonResidentAccount: boolean;
        isrCustomerNumber: string;
    }
    export interface BankDetail$Lookups {
        address: QueryOperation<Address>;
        country: QueryOperation<Country>;
        currency: QueryOperation<Currency>;
        intermediaryBankCountry: QueryOperation<Country>;
    }
    export interface BankDetail$Operations {
        query: QueryOperation<BankDetail>;
        read: ReadOperation<BankDetail>;
        aggregate: {
            read: AggregateReadOperation<BankDetail>;
            query: AggregateQueryOperation<BankDetail>;
        };
        lookups(dataOrId: string | { data: BankDetailInput }): BankDetail$Lookups;
        getDefaults: GetDefaultsOperation<BankDetail>;
    }
    export interface BomCodes extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        bomType: BomCodeType;
        code: integer;
        description: string;
        shortDescription: string;
        accessCode: Access;
        site: Site;
        isProductionUtilization: boolean;
        isCostUtilization: boolean;
        isMrpUtilization: boolean;
        isMpsUtilization: boolean;
    }
    export interface BomCodesInput extends ClientNodeInput {
        bomType?: BomCodeType;
        code?: integer | string;
        description?: string;
        shortDescription?: string;
        accessCode?: string;
        site?: string;
        isProductionUtilization?: boolean | string;
        isCostUtilization?: boolean | string;
        isMrpUtilization?: boolean | string;
        isMpsUtilization?: boolean | string;
    }
    export interface BomCodesBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        bomType: BomCodeType;
        code: integer;
        description: string;
        shortDescription: string;
        accessCode: Access;
        site: Site;
        isProductionUtilization: boolean;
        isCostUtilization: boolean;
        isMrpUtilization: boolean;
        isMpsUtilization: boolean;
    }
    export interface BomCodes$Lookups {
        accessCode: QueryOperation<Access>;
        site: QueryOperation<Site>;
    }
    export interface BomCodes$Operations {
        query: QueryOperation<BomCodes>;
        read: ReadOperation<BomCodes>;
        aggregate: {
            read: AggregateReadOperation<BomCodes>;
            query: AggregateQueryOperation<BomCodes>;
        };
        lookups(dataOrId: string | { data: BomCodesInput }): BomCodes$Lookups;
        getDefaults: GetDefaultsOperation<BomCodes>;
    }
    export interface BomDetail extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        parentProduct: Product;
        bomCode: BomHeader;
        sequence: integer;
        componentProduct: Product;
        bomType: BomCodeType;
        sequenceRemainder: integer;
        componentType: ComponentType;
        linkDescription: string;
        firstValidLot: string;
        lastValidLot: string;
        validityStartDate: string;
        validityEndDate: string;
        linkQuantityCode: BomQuantityLink;
        quantityRounding: ComponentRounded;
        uom: UnitOfMeasure;
        uomStockFactor: string;
        uomLinkQuantity: string;
        linkQuantity: string;
        scrapFactorPercentage: string;
        routingOperation: integer;
        routingOperationSuffix: integer;
        operationLeadTime: integer;
        isPrintMaterialNote: boolean;
        isPrintAcknowledgment: boolean;
        isPrintPackingSlip: boolean;
        isPrintInvoice: boolean;
        linkReviewIndex: string;
        isValuation: boolean;
        pickListCode: CodeToServe;
        weighingPositiveTolerancePercentage: string;
        weighingNegativeTolerancePercentage: string;
        setupLevel: ToleranceDefinitionLevel;
        typeOfSupply: MaterialReplenishType;
        selectionFormula: string;
        quantityFormula: string;
        majorVersion: string;
        minorVersion: string;
        revisionGroup: integer;
        masterContainer: string;
    }
    export interface BomDetailInput extends ClientNodeInput {
        parentProduct?: string;
        bomCode?: integer | string;
        sequence?: integer | string;
        componentProduct?: string;
        bomType?: BomCodeType;
        sequenceRemainder?: integer | string;
        componentType?: ComponentType;
        linkDescription?: string;
        firstValidLot?: string;
        lastValidLot?: string;
        validityStartDate?: string;
        validityEndDate?: string;
        linkQuantityCode?: BomQuantityLink;
        quantityRounding?: ComponentRounded;
        uom?: string;
        uomStockFactor?: decimal | string;
        uomLinkQuantity?: decimal | string;
        linkQuantity?: decimal | string;
        scrapFactorPercentage?: decimal | string;
        routingOperation?: integer | string;
        routingOperationSuffix?: integer | string;
        operationLeadTime?: integer | string;
        isPrintMaterialNote?: boolean | string;
        isPrintAcknowledgment?: boolean | string;
        isPrintPackingSlip?: boolean | string;
        isPrintInvoice?: boolean | string;
        linkReviewIndex?: string;
        isValuation?: boolean | string;
        pickListCode?: CodeToServe;
        weighingPositiveTolerancePercentage?: decimal | string;
        weighingNegativeTolerancePercentage?: decimal | string;
        setupLevel?: ToleranceDefinitionLevel;
        typeOfSupply?: MaterialReplenishType;
        selectionFormula?: string;
        quantityFormula?: string;
        majorVersion?: string;
        minorVersion?: string;
        revisionGroup?: integer | string;
        masterContainer?: string;
    }
    export interface BomDetailBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        parentProduct: Product;
        bomCode: BomHeader;
        sequence: integer;
        componentProduct: Product;
        bomType: BomCodeType;
        sequenceRemainder: integer;
        componentType: ComponentType;
        linkDescription: string;
        firstValidLot: string;
        lastValidLot: string;
        validityStartDate: string;
        validityEndDate: string;
        linkQuantityCode: BomQuantityLink;
        quantityRounding: ComponentRounded;
        uom: UnitOfMeasure;
        uomStockFactor: string;
        uomLinkQuantity: string;
        linkQuantity: string;
        scrapFactorPercentage: string;
        routingOperation: integer;
        routingOperationSuffix: integer;
        operationLeadTime: integer;
        isPrintMaterialNote: boolean;
        isPrintAcknowledgment: boolean;
        isPrintPackingSlip: boolean;
        isPrintInvoice: boolean;
        linkReviewIndex: string;
        isValuation: boolean;
        pickListCode: CodeToServe;
        weighingPositiveTolerancePercentage: string;
        weighingNegativeTolerancePercentage: string;
        setupLevel: ToleranceDefinitionLevel;
        typeOfSupply: MaterialReplenishType;
        selectionFormula: string;
        quantityFormula: string;
        majorVersion: string;
        minorVersion: string;
        revisionGroup: integer;
        masterContainer: string;
    }
    export interface BomDetail$Lookups {
        parentProduct: QueryOperation<Product>;
        bomCode: QueryOperation<BomHeader>;
        componentProduct: QueryOperation<Product>;
        uom: QueryOperation<UnitOfMeasure>;
    }
    export interface BomDetail$Operations {
        query: QueryOperation<BomDetail>;
        read: ReadOperation<BomDetail>;
        aggregate: {
            read: AggregateReadOperation<BomDetail>;
            query: AggregateQueryOperation<BomDetail>;
        };
        lookups(dataOrId: string | { data: BomDetailInput }): BomDetail$Lookups;
        getDefaults: GetDefaultsOperation<BomDetail>;
    }
    export interface BomHeader extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        parentProduct: Product;
        bomCode: BomCodes;
        bomType: BomCodeType;
        description: string;
        useStatus: UseStatus;
        isPrototype: boolean;
        validityStartDate: string;
        validityEndDate: string;
        reviewLevel: string;
        baseQuantity: string;
        managementUnit: ManagementUnit;
        headerText: string;
        journalNumberConfig: string;
        accessCode: Access;
        linkedDocuments: string;
        details: ClientCollection<BomDetail>;
    }
    export interface BomHeaderInput extends ClientNodeInput {
        parentProduct?: string;
        bomCode?: integer | string;
        bomType?: BomCodeType;
        description?: string;
        useStatus?: UseStatus;
        isPrototype?: boolean | string;
        validityStartDate?: string;
        validityEndDate?: string;
        reviewLevel?: string;
        baseQuantity?: decimal | string;
        managementUnit?: ManagementUnit;
        headerText?: string;
        journalNumberConfig?: string;
        accessCode?: string;
        linkedDocuments?: string;
        details?: Partial<BomDetailInput>[];
    }
    export interface BomHeaderBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        parentProduct: Product;
        bomCode: BomCodes;
        bomType: BomCodeType;
        description: string;
        useStatus: UseStatus;
        isPrototype: boolean;
        validityStartDate: string;
        validityEndDate: string;
        reviewLevel: string;
        baseQuantity: string;
        managementUnit: ManagementUnit;
        headerText: string;
        journalNumberConfig: string;
        accessCode: Access;
        linkedDocuments: string;
        details: ClientCollection<BomDetail>;
    }
    export interface BomHeader$Lookups {
        parentProduct: QueryOperation<Product>;
        bomCode: QueryOperation<BomCodes>;
        accessCode: QueryOperation<Access>;
    }
    export interface BomHeader$Operations {
        query: QueryOperation<BomHeader>;
        read: ReadOperation<BomHeader>;
        aggregate: {
            read: AggregateReadOperation<BomHeader>;
            query: AggregateQueryOperation<BomHeader>;
        };
        lookups(dataOrId: string | { data: BomHeaderInput }): BomHeader$Lookups;
        getDefaults: GetDefaultsOperation<BomHeader>;
    }
    export interface BomProduct extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        bomCode: integer;
        lowestLevelCodeType: LowLevelType;
        lowestLevelCode: integer;
        isBomExistence: boolean;
        isWhereUsedExistence: boolean;
    }
    export interface BomProductInput extends ClientNodeInput {
        product?: string;
        bomCode?: integer | string;
        lowestLevelCodeType?: LowLevelType;
        lowestLevelCode?: integer | string;
        isBomExistence?: boolean | string;
        isWhereUsedExistence?: boolean | string;
    }
    export interface BomProductBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        bomCode: integer;
        lowestLevelCodeType: LowLevelType;
        lowestLevelCode: integer;
        isBomExistence: boolean;
        isWhereUsedExistence: boolean;
    }
    export interface BomProduct$Lookups {
        product: QueryOperation<Product>;
    }
    export interface BomProduct$Operations {
        query: QueryOperation<BomProduct>;
        read: ReadOperation<BomProduct>;
        aggregate: {
            read: AggregateReadOperation<BomProduct>;
            query: AggregateQueryOperation<BomProduct>;
        };
        lookups(dataOrId: string | { data: BomProductInput }): BomProduct$Lookups;
        getDefaults: GetDefaultsOperation<BomProduct>;
    }
    export interface BomRouting extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: integer;
        description: string;
        shortDescription: string;
        accessCode: Access;
        site: Site;
        isProductionUtilization: boolean;
        isCostUtilization: boolean;
        isRccpUtilization: boolean;
        bomCode1: BomCodes;
        bomCode2: BomCodes;
        bomCode3: BomCodes;
    }
    export interface BomRoutingInput extends ClientNodeInput {
        code?: integer | string;
        description?: string;
        shortDescription?: string;
        accessCode?: string;
        site?: string;
        isProductionUtilization?: boolean | string;
        isCostUtilization?: boolean | string;
        isRccpUtilization?: boolean | string;
        bomCode1?: integer | string;
        bomCode2?: integer | string;
        bomCode3?: integer | string;
    }
    export interface BomRoutingBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: integer;
        description: string;
        shortDescription: string;
        accessCode: Access;
        site: Site;
        isProductionUtilization: boolean;
        isCostUtilization: boolean;
        isRccpUtilization: boolean;
        bomCode1: BomCodes;
        bomCode2: BomCodes;
        bomCode3: BomCodes;
    }
    export interface BomRouting$Lookups {
        accessCode: QueryOperation<Access>;
        site: QueryOperation<Site>;
        bomCode1: QueryOperation<BomCodes>;
        bomCode2: QueryOperation<BomCodes>;
        bomCode3: QueryOperation<BomCodes>;
    }
    export interface BomRouting$Operations {
        query: QueryOperation<BomRouting>;
        read: ReadOperation<BomRouting>;
        aggregate: {
            read: AggregateReadOperation<BomRouting>;
            query: AggregateQueryOperation<BomRouting>;
        };
        lookups(dataOrId: string | { data: BomRoutingInput }): BomRouting$Lookups;
        getDefaults: GetDefaultsOperation<BomRouting>;
    }
    export interface BusinessPartnerAddressAddressEmails extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        businessPartner: string;
        code: string;
        addressEmail: string;
        emailType: EmailAddressType;
    }
    export interface BusinessPartnerAddressAddressEmailsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        businessPartner?: string;
        code?: string;
        addressEmail?: string;
    }
    export interface BusinessPartnerAddressAddressEmailsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        businessPartner: string;
        code: string;
        addressEmail: string;
        emailType: EmailAddressType;
    }
    export interface BusinessPartnerAddressAddressEmails$Operations {
        query: QueryOperation<BusinessPartnerAddressAddressEmails>;
        read: ReadOperation<BusinessPartnerAddressAddressEmails>;
        aggregate: {
            read: AggregateReadOperation<BusinessPartnerAddressAddressEmails>;
            query: AggregateQueryOperation<BusinessPartnerAddressAddressEmails>;
        };
        getDefaults: GetDefaultsOperation<BusinessPartnerAddressAddressEmails>;
    }
    export interface BusinessPartnerAddressAddressLines extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        businessPartner: string;
        code: string;
        addressLine: string;
    }
    export interface BusinessPartnerAddressAddressLinesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        businessPartner?: string;
        code?: string;
        addressLine?: string;
    }
    export interface BusinessPartnerAddressAddressLinesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        businessPartner: string;
        code: string;
        addressLine: string;
    }
    export interface BusinessPartnerAddressAddressLines$Operations {
        query: QueryOperation<BusinessPartnerAddressAddressLines>;
        read: ReadOperation<BusinessPartnerAddressAddressLines>;
        aggregate: {
            read: AggregateReadOperation<BusinessPartnerAddressAddressLines>;
            query: AggregateQueryOperation<BusinessPartnerAddressAddressLines>;
        };
        getDefaults: GetDefaultsOperation<BusinessPartnerAddressAddressLines>;
    }
    export interface BusinessPartnerAddressAddressPhoneNumbers extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        businessPartner: string;
        code: string;
        addressPhoneNumber: string;
        phoneType: TelephoneType;
    }
    export interface BusinessPartnerAddressAddressPhoneNumbersInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        businessPartner?: string;
        code?: string;
        addressPhoneNumber?: string;
    }
    export interface BusinessPartnerAddressAddressPhoneNumbersBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        businessPartner: string;
        code: string;
        addressPhoneNumber: string;
        phoneType: TelephoneType;
    }
    export interface BusinessPartnerAddressAddressPhoneNumbers$Operations {
        query: QueryOperation<BusinessPartnerAddressAddressPhoneNumbers>;
        read: ReadOperation<BusinessPartnerAddressAddressPhoneNumbers>;
        aggregate: {
            read: AggregateReadOperation<BusinessPartnerAddressAddressPhoneNumbers>;
            query: AggregateQueryOperation<BusinessPartnerAddressAddressPhoneNumbers>;
        };
        getDefaults: GetDefaultsOperation<BusinessPartnerAddressAddressPhoneNumbers>;
    }
    export interface BusinessPartnerAddress extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        businessPartner: BusinessPartner;
        code: string;
        description: string;
        defaultBankId: BusinessPartnerBankDetail;
        isDefault: boolean;
        zipCode: string;
        city: string;
        state: string;
        country: Country;
        countryName: string;
        website: string;
        externalIdentifier: string;
        isValid: boolean;
        addressEmails: ClientCollection<BusinessPartnerAddressAddressEmails>;
        addressLines: ClientCollection<BusinessPartnerAddressAddressLines>;
        addressPhoneNumbers: ClientCollection<BusinessPartnerAddressAddressPhoneNumbers>;
    }
    export interface BusinessPartnerAddressInput extends ClientNodeInput {
        entityType?: EntityType;
        businessPartner?: string;
        code?: string;
        description?: string;
        defaultBankId?: string;
        isDefault?: boolean | string;
        zipCode?: string;
        city?: string;
        state?: string;
        country?: string;
        countryName?: string;
        website?: string;
        externalIdentifier?: string;
        isValid?: boolean | string;
        addressEmails?: Partial<BusinessPartnerAddressAddressEmailsInput>[];
        addressLines?: Partial<BusinessPartnerAddressAddressLinesInput>[];
        addressPhoneNumbers?: Partial<BusinessPartnerAddressAddressPhoneNumbersInput>[];
    }
    export interface BusinessPartnerAddressBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        businessPartner: BusinessPartner;
        code: string;
        description: string;
        defaultBankId: BusinessPartnerBankDetail;
        isDefault: boolean;
        zipCode: string;
        city: string;
        state: string;
        country: Country;
        countryName: string;
        website: string;
        externalIdentifier: string;
        isValid: boolean;
        addressEmails: ClientCollection<BusinessPartnerAddressAddressEmailsBinding>;
        addressLines: ClientCollection<BusinessPartnerAddressAddressLinesBinding>;
        addressPhoneNumbers: ClientCollection<BusinessPartnerAddressAddressPhoneNumbersBinding>;
    }
    export interface BusinessPartnerAddress$Lookups {
        businessPartner: QueryOperation<BusinessPartner>;
        defaultBankId: QueryOperation<BusinessPartnerBankDetail>;
        country: QueryOperation<Country>;
    }
    export interface BusinessPartnerAddress$Operations {
        query: QueryOperation<BusinessPartnerAddress>;
        read: ReadOperation<BusinessPartnerAddress>;
        aggregate: {
            read: AggregateReadOperation<BusinessPartnerAddress>;
            query: AggregateQueryOperation<BusinessPartnerAddress>;
        };
        lookups(dataOrId: string | { data: BusinessPartnerAddressInput }): BusinessPartnerAddress$Lookups;
        getDefaults: GetDefaultsOperation<BusinessPartnerAddress>;
    }
    export interface BusinessPartnerBankDetail extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        businessPartner: BusinessPartner;
        bankId: string;
        address: BusinessPartnerAddress;
        byDefault: boolean;
        beneficiary: string;
        payingBank1: string;
        payingBank2: string;
        payingBank3: string;
        payingBank4: string;
        ibanPrefix: string;
        bic: string;
        country: Country;
        currency: Currency;
        intermediaryBankName: string;
        intermediaryBankAddress1: string;
        intermediaryBankAddress2: string;
        intermediaryBankAddress3: string;
        intermediaryBankBic: string;
        intermediaryBankCountry: Country;
        nonResidentAccount: boolean;
        isrCustomerNumber: string;
    }
    export interface BusinessPartnerBankDetailInput extends ClientNodeInput {
        entityType?: EntityType;
        businessPartner?: string;
        bankId?: string;
        address?: string;
        byDefault?: boolean | string;
        beneficiary?: string;
        payingBank1?: string;
        payingBank2?: string;
        payingBank3?: string;
        payingBank4?: string;
        ibanPrefix?: string;
        bic?: string;
        country?: string;
        currency?: string;
        intermediaryBankName?: string;
        intermediaryBankAddress1?: string;
        intermediaryBankAddress2?: string;
        intermediaryBankAddress3?: string;
        intermediaryBankBic?: string;
        intermediaryBankCountry?: string;
        nonResidentAccount?: boolean | string;
        isrCustomerNumber?: string;
    }
    export interface BusinessPartnerBankDetailBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        businessPartner: BusinessPartner;
        bankId: string;
        address: BusinessPartnerAddress;
        byDefault: boolean;
        beneficiary: string;
        payingBank1: string;
        payingBank2: string;
        payingBank3: string;
        payingBank4: string;
        ibanPrefix: string;
        bic: string;
        country: Country;
        currency: Currency;
        intermediaryBankName: string;
        intermediaryBankAddress1: string;
        intermediaryBankAddress2: string;
        intermediaryBankAddress3: string;
        intermediaryBankBic: string;
        intermediaryBankCountry: Country;
        nonResidentAccount: boolean;
        isrCustomerNumber: string;
    }
    export interface BusinessPartnerBankDetail$Lookups {
        businessPartner: QueryOperation<BusinessPartner>;
        address: QueryOperation<BusinessPartnerAddress>;
        country: QueryOperation<Country>;
        currency: QueryOperation<Currency>;
        intermediaryBankCountry: QueryOperation<Country>;
    }
    export interface BusinessPartnerBankDetail$Operations {
        query: QueryOperation<BusinessPartnerBankDetail>;
        read: ReadOperation<BusinessPartnerBankDetail>;
        aggregate: {
            read: AggregateReadOperation<BusinessPartnerBankDetail>;
            query: AggregateQueryOperation<BusinessPartnerBankDetail>;
        };
        lookups(dataOrId: string | { data: BusinessPartnerBankDetailInput }): BusinessPartnerBankDetail$Lookups;
        getDefaults: GetDefaultsOperation<BusinessPartnerBankDetail>;
    }
    export interface BusinessPartnerCompanyException extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        businessPartner: BusinessPartner;
        company: Company;
        isAuthorizedEntry: boolean;
        contractualPeriod: integer;
        isCashExcluded: boolean;
        electronicInvoiceType: ElectronicInvoiceType;
        mappingCode: Mapping;
        registrationAgreement: string;
    }
    export interface BusinessPartnerCompanyExceptionInput extends ClientNodeInput {
        businessPartner?: string;
        company?: string;
        isAuthorizedEntry?: boolean | string;
        contractualPeriod?: integer | string;
        isCashExcluded?: boolean | string;
        electronicInvoiceType?: ElectronicInvoiceType;
        mappingCode?: string;
        registrationAgreement?: string;
    }
    export interface BusinessPartnerCompanyExceptionBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        businessPartner: BusinessPartner;
        company: Company;
        isAuthorizedEntry: boolean;
        contractualPeriod: integer;
        isCashExcluded: boolean;
        electronicInvoiceType: ElectronicInvoiceType;
        mappingCode: Mapping;
        registrationAgreement: string;
    }
    export interface BusinessPartnerCompanyException$Lookups {
        businessPartner: QueryOperation<BusinessPartner>;
        company: QueryOperation<Company>;
        mappingCode: QueryOperation<Mapping>;
    }
    export interface BusinessPartnerCompanyException$Operations {
        query: QueryOperation<BusinessPartnerCompanyException>;
        read: ReadOperation<BusinessPartnerCompanyException>;
        aggregate: {
            read: AggregateReadOperation<BusinessPartnerCompanyException>;
            query: AggregateQueryOperation<BusinessPartnerCompanyException>;
        };
        lookups(
            dataOrId: string | { data: BusinessPartnerCompanyExceptionInput },
        ): BusinessPartnerCompanyException$Lookups;
        getDefaults: GetDefaultsOperation<BusinessPartnerCompanyException>;
    }
    export interface BusinessPartnerCompanyNames extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        companyName: string;
    }
    export interface BusinessPartnerCompanyNamesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        companyName?: string;
    }
    export interface BusinessPartnerCompanyNamesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        companyName: string;
    }
    export interface BusinessPartnerCompanyNames$Operations {
        query: QueryOperation<BusinessPartnerCompanyNames>;
        read: ReadOperation<BusinessPartnerCompanyNames>;
        aggregate: {
            read: AggregateReadOperation<BusinessPartnerCompanyNames>;
            query: AggregateQueryOperation<BusinessPartnerCompanyNames>;
        };
        getDefaults: GetDefaultsOperation<BusinessPartnerCompanyNames>;
    }
    export interface BusinessPartnerContact extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        businessPartner: BusinessPartner;
        code: ContactRelationship;
        position: FunctionContact;
        department: string;
        role: MiscellaneousTable;
        defaultAddress: string;
        landline: string;
        fax: string;
        email: string;
        cellPhone: string;
        isDataProtectionOfficer: boolean;
        contactRelationship: ContactRelationship;
        addressLines: ClientCollection<ContactRelationshipAddressLines>;
        relationshipCellPhone: string;
        relationshipCity: string;
        relationshipCountry: Country;
        relationshipCountryName: string;
        relationshipDateOfBirth: string;
        relationshipEmail: string;
        relationshipFax: string;
        relationshipFirstName: string;
        relationshipFullNameSearchKey: string;
        relationshipIsMailingProhibited: boolean;
        relationshipLandline: string;
        relationshipLanguage: Language;
        relationshipLastName: string;
        relationshipProfessionalCategory: MiscellaneousTable;
        relationshipState: string;
        relationshipTitle: Title;
        relationshipType: ContactType;
        relationshipZipCode: string;
    }
    export interface BusinessPartnerContactInput extends ClientNodeInput {
        entityType?: EntityType;
        businessPartner?: string;
        code?: string;
        position?: FunctionContact;
        department?: string;
        role?: string;
        defaultAddress?: string;
        landline?: string;
        fax?: string;
        email?: string;
        cellPhone?: string;
        isDataProtectionOfficer?: boolean | string;
        contactRelationship?: string;
        addressLines?: Partial<ContactRelationshipAddressLinesInput>[];
        relationshipCellPhone?: string;
        relationshipCity?: string;
        relationshipCountry?: string;
        relationshipCountryName?: string;
        relationshipDateOfBirth?: string;
        relationshipEmail?: string;
        relationshipFax?: string;
        relationshipFirstName?: string;
        relationshipFullNameSearchKey?: string;
        relationshipIsMailingProhibited?: boolean | string;
        relationshipLandline?: string;
        relationshipLanguage?: string;
        relationshipLastName?: string;
        relationshipProfessionalCategory?: string;
        relationshipState?: string;
        relationshipTitle?: Title;
        relationshipType?: ContactType;
        relationshipZipCode?: string;
    }
    export interface BusinessPartnerContactBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        businessPartner: BusinessPartner;
        code: ContactRelationship;
        position: FunctionContact;
        department: string;
        role: MiscellaneousTable;
        defaultAddress: string;
        landline: string;
        fax: string;
        email: string;
        cellPhone: string;
        isDataProtectionOfficer: boolean;
        contactRelationship: ContactRelationship;
        addressLines: ClientCollection<ContactRelationshipAddressLines>;
        relationshipCellPhone: string;
        relationshipCity: string;
        relationshipCountry: Country;
        relationshipCountryName: string;
        relationshipDateOfBirth: string;
        relationshipEmail: string;
        relationshipFax: string;
        relationshipFirstName: string;
        relationshipFullNameSearchKey: string;
        relationshipIsMailingProhibited: boolean;
        relationshipLandline: string;
        relationshipLanguage: Language;
        relationshipLastName: string;
        relationshipProfessionalCategory: MiscellaneousTable;
        relationshipState: string;
        relationshipTitle: Title;
        relationshipType: ContactType;
        relationshipZipCode: string;
    }
    export interface BusinessPartnerContact$Lookups {
        businessPartner: QueryOperation<BusinessPartner>;
        code: QueryOperation<ContactRelationship>;
        role: QueryOperation<MiscellaneousTable>;
        contactRelationship: QueryOperation<ContactRelationship>;
        relationshipCountry: QueryOperation<Country>;
        relationshipLanguage: QueryOperation<Language>;
        relationshipProfessionalCategory: QueryOperation<MiscellaneousTable>;
    }
    export interface BusinessPartnerContact$Operations {
        query: QueryOperation<BusinessPartnerContact>;
        read: ReadOperation<BusinessPartnerContact>;
        aggregate: {
            read: AggregateReadOperation<BusinessPartnerContact>;
            query: AggregateQueryOperation<BusinessPartnerContact>;
        };
        lookups(dataOrId: string | { data: BusinessPartnerContactInput }): BusinessPartnerContact$Lookups;
        getDefaults: GetDefaultsOperation<BusinessPartnerContact>;
    }
    export interface BusinessPartner extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        isActive: boolean;
        category: CustomerCategory;
        customerOrSupplierOriginCategory: string;
        companyName1: string;
        companyName2: string;
        shortCompanyName: string;
        europeanUnionVatNumber: string;
        isIntersite: boolean;
        businessPartnerSite: Site;
        country: Country;
        siteIdentificationNumber: string;
        standardIndustrialClassificationCode: string;
        currency: Currency;
        language: Language;
        acronym: string;
        italianTaxNumber: string;
        fiscalCode: string;
        consolidationGroup: SiteGroupings;
        consolidationCode: string;
        isCustomer: boolean;
        isSupplier: boolean;
        isGrantor: boolean;
        isCarrier: boolean;
        isFactor: boolean;
        isSalesRep: boolean;
        isMiscellaneousBusinessPartner: boolean;
        isProspect: boolean;
        isServiceSupplier: boolean;
        isServiceCaller: boolean;
        defaultAddress: BusinessPartnerAddress;
        defaultContact: BusinessPartnerContact;
        defaultBankId: BusinessPartnerBankDetail;
        bankIdCountry: Country;
        reportAccessCode: Access;
        isMailingProhibited: boolean;
        cfonbPaymentMethod: MiscellaneousTable;
        nonResidentAccount: BusinessPartnerAddress;
        isPhysicalPerson: boolean;
        isCashExcluded: boolean;
        documentType: DocumentType;
        isPublicSector: boolean;
        relatedCompany: RelatedCompanySettings;
        consolidationPartner: BusinessPartner;
        registrationNumber: string;
        vatNumber: string;
        economicOperatorRegistrationAndIdNumber: string;
        serviceCode: string;
        routingCode: string;
        electronicInvoiceType: ElectronicInvoiceType;
        mappingCode: Mapping;
        electronicAddress: string;
        addresses: ClientCollection<BusinessPartnerAddress>;
        contacts: ClientCollection<BusinessPartnerContact>;
        bankDetails: ClientCollection<BusinessPartnerBankDetail>;
        companyException: ClientCollection<BusinessPartnerCompanyException>;
        companyNames: ClientCollection<BusinessPartnerCompanyNames>;
    }
    export interface BusinessPartnerInput extends ClientNodeInput {
        code?: string;
        isActive?: boolean | string;
        category?: string;
        customerOrSupplierOriginCategory?: string;
        companyName1?: string;
        companyName2?: string;
        shortCompanyName?: string;
        europeanUnionVatNumber?: string;
        isIntersite?: boolean | string;
        businessPartnerSite?: string;
        country?: string;
        siteIdentificationNumber?: string;
        standardIndustrialClassificationCode?: string;
        currency?: string;
        language?: string;
        acronym?: string;
        italianTaxNumber?: string;
        fiscalCode?: string;
        consolidationGroup?: string;
        consolidationCode?: string;
        isCustomer?: boolean | string;
        isSupplier?: boolean | string;
        isGrantor?: boolean | string;
        isCarrier?: boolean | string;
        isFactor?: boolean | string;
        isSalesRep?: boolean | string;
        isMiscellaneousBusinessPartner?: boolean | string;
        isProspect?: boolean | string;
        isServiceSupplier?: boolean | string;
        isServiceCaller?: boolean | string;
        defaultAddress?: string;
        defaultContact?: string;
        defaultBankId?: string;
        bankIdCountry?: string;
        reportAccessCode?: string;
        isMailingProhibited?: boolean | string;
        cfonbPaymentMethod?: string;
        nonResidentAccount?: string;
        isPhysicalPerson?: boolean | string;
        isCashExcluded?: boolean | string;
        documentType?: DocumentType;
        isPublicSector?: boolean | string;
        relatedCompany?: RelatedCompanySettings;
        consolidationPartner?: string;
        registrationNumber?: string;
        vatNumber?: string;
        economicOperatorRegistrationAndIdNumber?: string;
        serviceCode?: string;
        routingCode?: string;
        electronicInvoiceType?: ElectronicInvoiceType;
        mappingCode?: string;
        electronicAddress?: string;
        addresses?: Partial<BusinessPartnerAddressInput>[];
        contacts?: Partial<BusinessPartnerContactInput>[];
        bankDetails?: Partial<BusinessPartnerBankDetailInput>[];
        companyException?: Partial<BusinessPartnerCompanyExceptionInput>[];
        companyNames?: Partial<BusinessPartnerCompanyNamesInput>[];
    }
    export interface BusinessPartnerBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        isActive: boolean;
        category: CustomerCategory;
        customerOrSupplierOriginCategory: string;
        companyName1: string;
        companyName2: string;
        shortCompanyName: string;
        europeanUnionVatNumber: string;
        isIntersite: boolean;
        businessPartnerSite: Site;
        country: Country;
        siteIdentificationNumber: string;
        standardIndustrialClassificationCode: string;
        currency: Currency;
        language: Language;
        acronym: string;
        italianTaxNumber: string;
        fiscalCode: string;
        consolidationGroup: SiteGroupings;
        consolidationCode: string;
        isCustomer: boolean;
        isSupplier: boolean;
        isGrantor: boolean;
        isCarrier: boolean;
        isFactor: boolean;
        isSalesRep: boolean;
        isMiscellaneousBusinessPartner: boolean;
        isProspect: boolean;
        isServiceSupplier: boolean;
        isServiceCaller: boolean;
        defaultAddress: BusinessPartnerAddress;
        defaultContact: BusinessPartnerContact;
        defaultBankId: BusinessPartnerBankDetail;
        bankIdCountry: Country;
        reportAccessCode: Access;
        isMailingProhibited: boolean;
        cfonbPaymentMethod: MiscellaneousTable;
        nonResidentAccount: BusinessPartnerAddress;
        isPhysicalPerson: boolean;
        isCashExcluded: boolean;
        documentType: DocumentType;
        isPublicSector: boolean;
        relatedCompany: RelatedCompanySettings;
        consolidationPartner: BusinessPartner;
        registrationNumber: string;
        vatNumber: string;
        economicOperatorRegistrationAndIdNumber: string;
        serviceCode: string;
        routingCode: string;
        electronicInvoiceType: ElectronicInvoiceType;
        mappingCode: Mapping;
        electronicAddress: string;
        addresses: ClientCollection<BusinessPartnerAddress>;
        contacts: ClientCollection<BusinessPartnerContact>;
        bankDetails: ClientCollection<BusinessPartnerBankDetail>;
        companyException: ClientCollection<BusinessPartnerCompanyException>;
        companyNames: ClientCollection<BusinessPartnerCompanyNamesBinding>;
    }
    export interface BusinessPartner$Lookups {
        category: QueryOperation<CustomerCategory>;
        businessPartnerSite: QueryOperation<Site>;
        country: QueryOperation<Country>;
        currency: QueryOperation<Currency>;
        language: QueryOperation<Language>;
        consolidationGroup: QueryOperation<SiteGroupings>;
        defaultAddress: QueryOperation<BusinessPartnerAddress>;
        defaultContact: QueryOperation<BusinessPartnerContact>;
        defaultBankId: QueryOperation<BusinessPartnerBankDetail>;
        bankIdCountry: QueryOperation<Country>;
        reportAccessCode: QueryOperation<Access>;
        cfonbPaymentMethod: QueryOperation<MiscellaneousTable>;
        nonResidentAccount: QueryOperation<BusinessPartnerAddress>;
        consolidationPartner: QueryOperation<BusinessPartner>;
        mappingCode: QueryOperation<Mapping>;
    }
    export interface BusinessPartner$Operations {
        query: QueryOperation<BusinessPartner>;
        read: ReadOperation<BusinessPartner>;
        aggregate: {
            read: AggregateReadOperation<BusinessPartner>;
            query: AggregateQueryOperation<BusinessPartner>;
        };
        lookups(dataOrId: string | { data: BusinessPartnerInput }): BusinessPartner$Lookups;
        getDefaults: GetDefaultsOperation<BusinessPartner>;
    }
    export interface Carrier extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: BusinessPartner;
        companyName: string;
        shortCompanyName: string;
        priceListManagement: boolean;
        weightUnit: UnitOfMeasure;
        volumeUnit: UnitOfMeasure;
        coefficient: string;
        printTransportNote: boolean;
        noOfPriceColumns: integer;
        currency: Currency;
        defaultAddress: Address;
    }
    export interface CarrierInput extends ClientNodeInput {
        code?: string;
        companyName?: string;
        shortCompanyName?: string;
        priceListManagement?: boolean | string;
        weightUnit?: string;
        volumeUnit?: string;
        coefficient?: decimal | string;
        printTransportNote?: boolean | string;
        noOfPriceColumns?: integer | string;
        currency?: string;
        defaultAddress?: string;
    }
    export interface CarrierBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: BusinessPartner;
        companyName: string;
        shortCompanyName: string;
        priceListManagement: boolean;
        weightUnit: UnitOfMeasure;
        volumeUnit: UnitOfMeasure;
        coefficient: string;
        printTransportNote: boolean;
        noOfPriceColumns: integer;
        currency: Currency;
        defaultAddress: Address;
    }
    export interface Carrier$Lookups {
        code: QueryOperation<BusinessPartner>;
        weightUnit: QueryOperation<UnitOfMeasure>;
        volumeUnit: QueryOperation<UnitOfMeasure>;
        currency: QueryOperation<Currency>;
        defaultAddress: QueryOperation<Address>;
    }
    export interface Carrier$Operations {
        query: QueryOperation<Carrier>;
        read: ReadOperation<Carrier>;
        aggregate: {
            read: AggregateReadOperation<Carrier>;
            query: AggregateQueryOperation<Carrier>;
        };
        lookups(dataOrId: string | { data: CarrierInput }): Carrier$Lookups;
        getDefaults: GetDefaultsOperation<Carrier>;
    }
    export interface CommonImage extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        identifier1: string;
        identifier2: string;
        fileName: string;
        data: BinaryStream;
        specialFileType: TypeOfNonStandardFile;
    }
    export interface CommonImageInput extends ClientNodeInput {
        code?: string;
        identifier1?: string;
        identifier2?: string;
        fileName?: string;
        data?: BinaryStream;
        specialFileType?: TypeOfNonStandardFile;
    }
    export interface CommonImageBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        identifier1: string;
        identifier2: string;
        fileName: string;
        data: BinaryStream;
        specialFileType: TypeOfNonStandardFile;
    }
    export interface CommonImage$Operations {
        query: QueryOperation<CommonImage>;
        read: ReadOperation<CommonImage>;
        aggregate: {
            read: AggregateReadOperation<CommonImage>;
            query: AggregateQueryOperation<CommonImage>;
        };
        getDefaults: GetDefaultsOperation<CommonImage>;
    }
    export interface CommonText extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        text: TextStream;
        identifier1: string;
        identifier2: string;
        identifier3: string;
    }
    export interface CommonTextInput extends ClientNodeInput {
        code?: string;
        text?: TextStream;
        identifier1?: string;
        identifier2?: string;
        identifier3?: string;
    }
    export interface CommonTextBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        text: TextStream;
        identifier1: string;
        identifier2: string;
        identifier3: string;
    }
    export interface CommonText$Operations {
        query: QueryOperation<CommonText>;
        read: ReadOperation<CommonText>;
        aggregate: {
            read: AggregateReadOperation<CommonText>;
            query: AggregateQueryOperation<CommonText>;
        };
        getDefaults: GetDefaultsOperation<CommonText>;
    }
    export interface CompanyAddressAddressEmails extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        company: string;
        code: string;
        addressEmail: string;
        emailType: EmailAddressType;
    }
    export interface CompanyAddressAddressEmailsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        company?: string;
        code?: string;
        addressEmail?: string;
    }
    export interface CompanyAddressAddressEmailsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        company: string;
        code: string;
        addressEmail: string;
        emailType: EmailAddressType;
    }
    export interface CompanyAddressAddressEmails$Operations {
        query: QueryOperation<CompanyAddressAddressEmails>;
        read: ReadOperation<CompanyAddressAddressEmails>;
        aggregate: {
            read: AggregateReadOperation<CompanyAddressAddressEmails>;
            query: AggregateQueryOperation<CompanyAddressAddressEmails>;
        };
        getDefaults: GetDefaultsOperation<CompanyAddressAddressEmails>;
    }
    export interface CompanyAddressAddressLines extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        company: string;
        code: string;
        addressLine: string;
    }
    export interface CompanyAddressAddressLinesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        company?: string;
        code?: string;
        addressLine?: string;
    }
    export interface CompanyAddressAddressLinesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        company: string;
        code: string;
        addressLine: string;
    }
    export interface CompanyAddressAddressLines$Operations {
        query: QueryOperation<CompanyAddressAddressLines>;
        read: ReadOperation<CompanyAddressAddressLines>;
        aggregate: {
            read: AggregateReadOperation<CompanyAddressAddressLines>;
            query: AggregateQueryOperation<CompanyAddressAddressLines>;
        };
        getDefaults: GetDefaultsOperation<CompanyAddressAddressLines>;
    }
    export interface CompanyAddressAddressPhoneNumbers extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        company: string;
        code: string;
        addressPhoneNumber: string;
        phoneType: TelephoneType;
    }
    export interface CompanyAddressAddressPhoneNumbersInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        company?: string;
        code?: string;
        addressPhoneNumber?: string;
    }
    export interface CompanyAddressAddressPhoneNumbersBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        company: string;
        code: string;
        addressPhoneNumber: string;
        phoneType: TelephoneType;
    }
    export interface CompanyAddressAddressPhoneNumbers$Operations {
        query: QueryOperation<CompanyAddressAddressPhoneNumbers>;
        read: ReadOperation<CompanyAddressAddressPhoneNumbers>;
        aggregate: {
            read: AggregateReadOperation<CompanyAddressAddressPhoneNumbers>;
            query: AggregateQueryOperation<CompanyAddressAddressPhoneNumbers>;
        };
        getDefaults: GetDefaultsOperation<CompanyAddressAddressPhoneNumbers>;
    }
    export interface CompanyAddress extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        company: Company;
        code: string;
        description: string;
        defaultBankId: CompanyBankDetail;
        isDefault: boolean;
        zipCode: string;
        city: string;
        state: string;
        country: Country;
        countryName: string;
        website: string;
        externalIdentifier: string;
        isValid: boolean;
        addressEmails: ClientCollection<CompanyAddressAddressEmails>;
        addressLines: ClientCollection<CompanyAddressAddressLines>;
        addressPhoneNumbers: ClientCollection<CompanyAddressAddressPhoneNumbers>;
    }
    export interface CompanyAddressInput extends ClientNodeInput {
        entityType?: EntityType;
        company?: string;
        code?: string;
        description?: string;
        defaultBankId?: string;
        isDefault?: boolean | string;
        zipCode?: string;
        city?: string;
        state?: string;
        country?: string;
        countryName?: string;
        website?: string;
        externalIdentifier?: string;
        isValid?: boolean | string;
        addressEmails?: Partial<CompanyAddressAddressEmailsInput>[];
        addressLines?: Partial<CompanyAddressAddressLinesInput>[];
        addressPhoneNumbers?: Partial<CompanyAddressAddressPhoneNumbersInput>[];
    }
    export interface CompanyAddressBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        company: Company;
        code: string;
        description: string;
        defaultBankId: CompanyBankDetail;
        isDefault: boolean;
        zipCode: string;
        city: string;
        state: string;
        country: Country;
        countryName: string;
        website: string;
        externalIdentifier: string;
        isValid: boolean;
        addressEmails: ClientCollection<CompanyAddressAddressEmailsBinding>;
        addressLines: ClientCollection<CompanyAddressAddressLinesBinding>;
        addressPhoneNumbers: ClientCollection<CompanyAddressAddressPhoneNumbersBinding>;
    }
    export interface CompanyAddress$Lookups {
        company: QueryOperation<Company>;
        defaultBankId: QueryOperation<CompanyBankDetail>;
        country: QueryOperation<Country>;
    }
    export interface CompanyAddress$Operations {
        query: QueryOperation<CompanyAddress>;
        read: ReadOperation<CompanyAddress>;
        aggregate: {
            read: AggregateReadOperation<CompanyAddress>;
            query: AggregateQueryOperation<CompanyAddress>;
        };
        lookups(dataOrId: string | { data: CompanyAddressInput }): CompanyAddress$Lookups;
        getDefaults: GetDefaultsOperation<CompanyAddress>;
    }
    export interface CompanyBankDetail extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        company: Company;
        bankId: string;
        address: CompanyAddress;
        byDefault: boolean;
        beneficiary: string;
        payingBank1: string;
        payingBank2: string;
        payingBank3: string;
        payingBank4: string;
        ibanPrefix: string;
        bic: string;
        country: Country;
        currency: Currency;
        intermediaryBankName: string;
        intermediaryBankAddress1: string;
        intermediaryBankAddress2: string;
        intermediaryBankAddress3: string;
        intermediaryBankBic: string;
        intermediaryBankCountry: Country;
        nonResidentAccount: boolean;
        isrCustomerNumber: string;
    }
    export interface CompanyBankDetailInput extends ClientNodeInput {
        entityType?: EntityType;
        company?: string;
        bankId?: string;
        address?: string;
        byDefault?: boolean | string;
        beneficiary?: string;
        payingBank1?: string;
        payingBank2?: string;
        payingBank3?: string;
        payingBank4?: string;
        ibanPrefix?: string;
        bic?: string;
        country?: string;
        currency?: string;
        intermediaryBankName?: string;
        intermediaryBankAddress1?: string;
        intermediaryBankAddress2?: string;
        intermediaryBankAddress3?: string;
        intermediaryBankBic?: string;
        intermediaryBankCountry?: string;
        nonResidentAccount?: boolean | string;
        isrCustomerNumber?: string;
    }
    export interface CompanyBankDetailBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        company: Company;
        bankId: string;
        address: CompanyAddress;
        byDefault: boolean;
        beneficiary: string;
        payingBank1: string;
        payingBank2: string;
        payingBank3: string;
        payingBank4: string;
        ibanPrefix: string;
        bic: string;
        country: Country;
        currency: Currency;
        intermediaryBankName: string;
        intermediaryBankAddress1: string;
        intermediaryBankAddress2: string;
        intermediaryBankAddress3: string;
        intermediaryBankBic: string;
        intermediaryBankCountry: Country;
        nonResidentAccount: boolean;
        isrCustomerNumber: string;
    }
    export interface CompanyBankDetail$Lookups {
        company: QueryOperation<Company>;
        address: QueryOperation<CompanyAddress>;
        country: QueryOperation<Country>;
        currency: QueryOperation<Currency>;
        intermediaryBankCountry: QueryOperation<Country>;
    }
    export interface CompanyBankDetail$Operations {
        query: QueryOperation<CompanyBankDetail>;
        read: ReadOperation<CompanyBankDetail>;
        aggregate: {
            read: AggregateReadOperation<CompanyBankDetail>;
            query: AggregateQueryOperation<CompanyBankDetail>;
        };
        lookups(dataOrId: string | { data: CompanyBankDetailInput }): CompanyBankDetail$Lookups;
        getDefaults: GetDefaultsOperation<CompanyBankDetail>;
    }
    export interface CompanyContact extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        company: Company;
        code: ContactRelationship;
        position: FunctionContact;
        department: string;
        role: MiscellaneousTable;
        defaultAddress: string;
        landline: string;
        fax: string;
        email: string;
        cellPhone: string;
        isDataProtectionOfficer: boolean;
        contactRelationship: ContactRelationship;
        addressLines: ClientCollection<ContactRelationshipAddressLines>;
        relationshipCellPhone: string;
        relationshipCity: string;
        relationshipCountry: Country;
        relationshipCountryName: string;
        relationshipDateOfBirth: string;
        relationshipEmail: string;
        relationshipFax: string;
        relationshipFirstName: string;
        relationshipFullNameSearchKey: string;
        relationshipIsMailingProhibited: boolean;
        relationshipLandline: string;
        relationshipLanguage: Language;
        relationshipLastName: string;
        relationshipProfessionalCategory: MiscellaneousTable;
        relationshipState: string;
        relationshipTitle: Title;
        relationshipType: ContactType;
        relationshipZipCode: string;
    }
    export interface CompanyContactInput extends ClientNodeInput {
        entityType?: EntityType;
        company?: string;
        code?: string;
        position?: FunctionContact;
        department?: string;
        role?: string;
        defaultAddress?: string;
        landline?: string;
        fax?: string;
        email?: string;
        cellPhone?: string;
        isDataProtectionOfficer?: boolean | string;
        contactRelationship?: string;
        addressLines?: Partial<ContactRelationshipAddressLinesInput>[];
        relationshipCellPhone?: string;
        relationshipCity?: string;
        relationshipCountry?: string;
        relationshipCountryName?: string;
        relationshipDateOfBirth?: string;
        relationshipEmail?: string;
        relationshipFax?: string;
        relationshipFirstName?: string;
        relationshipFullNameSearchKey?: string;
        relationshipIsMailingProhibited?: boolean | string;
        relationshipLandline?: string;
        relationshipLanguage?: string;
        relationshipLastName?: string;
        relationshipProfessionalCategory?: string;
        relationshipState?: string;
        relationshipTitle?: Title;
        relationshipType?: ContactType;
        relationshipZipCode?: string;
    }
    export interface CompanyContactBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        company: Company;
        code: ContactRelationship;
        position: FunctionContact;
        department: string;
        role: MiscellaneousTable;
        defaultAddress: string;
        landline: string;
        fax: string;
        email: string;
        cellPhone: string;
        isDataProtectionOfficer: boolean;
        contactRelationship: ContactRelationship;
        addressLines: ClientCollection<ContactRelationshipAddressLines>;
        relationshipCellPhone: string;
        relationshipCity: string;
        relationshipCountry: Country;
        relationshipCountryName: string;
        relationshipDateOfBirth: string;
        relationshipEmail: string;
        relationshipFax: string;
        relationshipFirstName: string;
        relationshipFullNameSearchKey: string;
        relationshipIsMailingProhibited: boolean;
        relationshipLandline: string;
        relationshipLanguage: Language;
        relationshipLastName: string;
        relationshipProfessionalCategory: MiscellaneousTable;
        relationshipState: string;
        relationshipTitle: Title;
        relationshipType: ContactType;
        relationshipZipCode: string;
    }
    export interface CompanyContact$Lookups {
        company: QueryOperation<Company>;
        code: QueryOperation<ContactRelationship>;
        role: QueryOperation<MiscellaneousTable>;
        contactRelationship: QueryOperation<ContactRelationship>;
        relationshipCountry: QueryOperation<Country>;
        relationshipLanguage: QueryOperation<Language>;
        relationshipProfessionalCategory: QueryOperation<MiscellaneousTable>;
    }
    export interface CompanyContact$Operations {
        query: QueryOperation<CompanyContact>;
        read: ReadOperation<CompanyContact>;
        aggregate: {
            read: AggregateReadOperation<CompanyContact>;
            query: AggregateQueryOperation<CompanyContact>;
        };
        lookups(dataOrId: string | { data: CompanyContactInput }): CompanyContact$Lookups;
        getDefaults: GetDefaultsOperation<CompanyContact>;
    }
    export interface ContactRelationshipAddressLines extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        line: string;
    }
    export interface ContactRelationshipAddressLinesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        line?: string;
    }
    export interface ContactRelationshipAddressLinesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        line: string;
    }
    export interface ContactRelationshipAddressLines$Operations {
        query: QueryOperation<ContactRelationshipAddressLines>;
        read: ReadOperation<ContactRelationshipAddressLines>;
        aggregate: {
            read: AggregateReadOperation<ContactRelationshipAddressLines>;
            query: AggregateQueryOperation<ContactRelationshipAddressLines>;
        };
        getDefaults: GetDefaultsOperation<ContactRelationshipAddressLines>;
    }
    export interface ContactRelationship extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        fullNameSearchKey: string;
        title: Title;
        type: ContactType;
        lastName: string;
        firstName: string;
        dateOfBirth: string;
        language: Language;
        professionalCategory: MiscellaneousTable;
        country: Country;
        countryName: string;
        zipCode: string;
        city: string;
        state: string;
        landline: string;
        fax: string;
        cellPhone: string;
        email: string;
        isMailingProhibited: boolean;
        addressLines: ClientCollection<ContactRelationshipAddressLines>;
    }
    export interface ContactRelationshipInput extends ClientNodeInput {
        code?: string;
        fullNameSearchKey?: string;
        title?: Title;
        type?: ContactType;
        lastName?: string;
        firstName?: string;
        dateOfBirth?: string;
        language?: string;
        professionalCategory?: string;
        country?: string;
        countryName?: string;
        zipCode?: string;
        city?: string;
        state?: string;
        landline?: string;
        fax?: string;
        cellPhone?: string;
        email?: string;
        isMailingProhibited?: boolean | string;
        addressLines?: Partial<ContactRelationshipAddressLinesInput>[];
    }
    export interface ContactRelationshipBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        fullNameSearchKey: string;
        title: Title;
        type: ContactType;
        lastName: string;
        firstName: string;
        dateOfBirth: string;
        language: Language;
        professionalCategory: MiscellaneousTable;
        country: Country;
        countryName: string;
        zipCode: string;
        city: string;
        state: string;
        landline: string;
        fax: string;
        cellPhone: string;
        email: string;
        isMailingProhibited: boolean;
        addressLines: ClientCollection<ContactRelationshipAddressLinesBinding>;
    }
    export interface ContactRelationship$Lookups {
        language: QueryOperation<Language>;
        professionalCategory: QueryOperation<MiscellaneousTable>;
        country: QueryOperation<Country>;
    }
    export interface ContactRelationship$Operations {
        query: QueryOperation<ContactRelationship>;
        read: ReadOperation<ContactRelationship>;
        aggregate: {
            read: AggregateReadOperation<ContactRelationship>;
            query: AggregateQueryOperation<ContactRelationship>;
        };
        lookups(dataOrId: string | { data: ContactRelationshipInput }): ContactRelationship$Lookups;
        getDefaults: GetDefaultsOperation<ContactRelationship>;
    }
    export interface Contact extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        entityNumber: string;
        code: ContactRelationship;
        position: FunctionContact;
        department: string;
        role: MiscellaneousTable;
        defaultAddress: string;
        landline: string;
        fax: string;
        email: string;
        cellPhone: string;
        isDataProtectionOfficer: boolean;
        contactRelationship: ContactRelationship;
        addressLines: ClientCollection<ContactRelationshipAddressLines>;
        relationshipCellPhone: string;
        relationshipCity: string;
        relationshipCountry: Country;
        relationshipCountryName: string;
        relationshipDateOfBirth: string;
        relationshipEmail: string;
        relationshipFax: string;
        relationshipFirstName: string;
        relationshipFullNameSearchKey: string;
        relationshipIsMailingProhibited: boolean;
        relationshipLandline: string;
        relationshipLanguage: Language;
        relationshipLastName: string;
        relationshipProfessionalCategory: MiscellaneousTable;
        relationshipState: string;
        relationshipTitle: Title;
        relationshipType: ContactType;
        relationshipZipCode: string;
    }
    export interface ContactInput extends ClientNodeInput {
        entityType?: EntityType;
        entityNumber?: string;
        code?: string;
        position?: FunctionContact;
        department?: string;
        role?: string;
        defaultAddress?: string;
        landline?: string;
        fax?: string;
        email?: string;
        cellPhone?: string;
        isDataProtectionOfficer?: boolean | string;
        contactRelationship?: string;
        addressLines?: Partial<ContactRelationshipAddressLinesInput>[];
        relationshipCellPhone?: string;
        relationshipCity?: string;
        relationshipCountry?: string;
        relationshipCountryName?: string;
        relationshipDateOfBirth?: string;
        relationshipEmail?: string;
        relationshipFax?: string;
        relationshipFirstName?: string;
        relationshipFullNameSearchKey?: string;
        relationshipIsMailingProhibited?: boolean | string;
        relationshipLandline?: string;
        relationshipLanguage?: string;
        relationshipLastName?: string;
        relationshipProfessionalCategory?: string;
        relationshipState?: string;
        relationshipTitle?: Title;
        relationshipType?: ContactType;
        relationshipZipCode?: string;
    }
    export interface ContactBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        entityNumber: string;
        code: ContactRelationship;
        position: FunctionContact;
        department: string;
        role: MiscellaneousTable;
        defaultAddress: string;
        landline: string;
        fax: string;
        email: string;
        cellPhone: string;
        isDataProtectionOfficer: boolean;
        contactRelationship: ContactRelationship;
        addressLines: ClientCollection<ContactRelationshipAddressLines>;
        relationshipCellPhone: string;
        relationshipCity: string;
        relationshipCountry: Country;
        relationshipCountryName: string;
        relationshipDateOfBirth: string;
        relationshipEmail: string;
        relationshipFax: string;
        relationshipFirstName: string;
        relationshipFullNameSearchKey: string;
        relationshipIsMailingProhibited: boolean;
        relationshipLandline: string;
        relationshipLanguage: Language;
        relationshipLastName: string;
        relationshipProfessionalCategory: MiscellaneousTable;
        relationshipState: string;
        relationshipTitle: Title;
        relationshipType: ContactType;
        relationshipZipCode: string;
    }
    export interface Contact$Lookups {
        code: QueryOperation<ContactRelationship>;
        role: QueryOperation<MiscellaneousTable>;
        contactRelationship: QueryOperation<ContactRelationship>;
        relationshipCountry: QueryOperation<Country>;
        relationshipLanguage: QueryOperation<Language>;
        relationshipProfessionalCategory: QueryOperation<MiscellaneousTable>;
    }
    export interface Contact$Operations {
        query: QueryOperation<Contact>;
        read: ReadOperation<Contact>;
        aggregate: {
            read: AggregateReadOperation<Contact>;
            query: AggregateQueryOperation<Contact>;
        };
        lookups(dataOrId: string | { data: ContactInput }): Contact$Lookups;
        getDefaults: GetDefaultsOperation<Contact>;
    }
    export interface Container extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        containerType: InternalContainerType;
        isActive: boolean;
        description: string;
        shortDescription: string;
        sizeUnit: UnitOfMeasure;
        weightUnit: UnitOfMeasure;
        tareWeight: string;
        maxWeight: string;
        length: string;
        width: string;
        height: string;
        volumeUnit: UnitOfMeasure;
        volume: string;
        usableVolume: string;
        twentyFootEquivalentUnit: integer;
        isRefrigerated: boolean;
        isInternal: boolean;
        isFreight: boolean;
        isSingleProduct: boolean;
        isSingleLot: boolean;
        labelFormat: GenericPrintReport;
    }
    export interface ContainerInput extends ClientNodeInput {
        code?: string;
        containerType?: InternalContainerType;
        isActive?: boolean | string;
        description?: string;
        shortDescription?: string;
        sizeUnit?: string;
        weightUnit?: string;
        tareWeight?: decimal | string;
        maxWeight?: decimal | string;
        length?: decimal | string;
        width?: decimal | string;
        height?: decimal | string;
        volumeUnit?: string;
        volume?: decimal | string;
        usableVolume?: decimal | string;
        twentyFootEquivalentUnit?: integer | string;
        isRefrigerated?: boolean | string;
        isInternal?: boolean | string;
        isFreight?: boolean | string;
        isSingleProduct?: boolean | string;
        isSingleLot?: boolean | string;
        labelFormat?: string;
    }
    export interface ContainerBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        containerType: InternalContainerType;
        isActive: boolean;
        description: string;
        shortDescription: string;
        sizeUnit: UnitOfMeasure;
        weightUnit: UnitOfMeasure;
        tareWeight: string;
        maxWeight: string;
        length: string;
        width: string;
        height: string;
        volumeUnit: UnitOfMeasure;
        volume: string;
        usableVolume: string;
        twentyFootEquivalentUnit: integer;
        isRefrigerated: boolean;
        isInternal: boolean;
        isFreight: boolean;
        isSingleProduct: boolean;
        isSingleLot: boolean;
        labelFormat: GenericPrintReport;
    }
    export interface Container$Lookups {
        sizeUnit: QueryOperation<UnitOfMeasure>;
        weightUnit: QueryOperation<UnitOfMeasure>;
        volumeUnit: QueryOperation<UnitOfMeasure>;
        labelFormat: QueryOperation<GenericPrintReport>;
    }
    export interface Container$Operations {
        query: QueryOperation<Container>;
        read: ReadOperation<Container>;
        aggregate: {
            read: AggregateReadOperation<Container>;
            query: AggregateQueryOperation<Container>;
        };
        lookups(dataOrId: string | { data: ContainerInput }): Container$Lookups;
        getDefaults: GetDefaultsOperation<Container>;
    }
    export interface CurrencyRate extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        rateType: ExchangeRateType;
        sourceCurrency: Currency;
        destinationCurrency: Currency;
        rateDate: string;
        inverseRate: string;
        rate: string;
        divisor: string;
    }
    export interface CurrencyRateInput extends ClientNodeInput {
        rateType?: ExchangeRateType;
        sourceCurrency?: string;
        destinationCurrency?: string;
        rateDate?: string;
        inverseRate?: decimal | string;
        rate?: decimal | string;
        divisor?: decimal | string;
    }
    export interface CurrencyRateBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        rateType: ExchangeRateType;
        sourceCurrency: Currency;
        destinationCurrency: Currency;
        rateDate: string;
        inverseRate: string;
        rate: string;
        divisor: string;
    }
    export interface CurrencyRate$Lookups {
        sourceCurrency: QueryOperation<Currency>;
        destinationCurrency: QueryOperation<Currency>;
    }
    export interface CurrencyRate$Operations {
        query: QueryOperation<CurrencyRate>;
        read: ReadOperation<CurrencyRate>;
        aggregate: {
            read: AggregateReadOperation<CurrencyRate>;
            query: AggregateQueryOperation<CurrencyRate>;
        };
        lookups(dataOrId: string | { data: CurrencyRateInput }): CurrencyRate$Lookups;
        getDefaults: GetDefaultsOperation<CurrencyRate>;
    }
    export interface Currency extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
        isEuro: boolean;
        euroDate: string;
        currencyRates: ClientCollection<CurrencyRate>;
    }
    export interface CurrencyInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
        isEuro?: boolean | string;
        euroDate?: string;
        currencyRates?: Partial<CurrencyRateInput>[];
    }
    export interface CurrencyBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
        isEuro: boolean;
        euroDate: string;
        currencyRates: ClientCollection<CurrencyRate>;
    }
    export interface Currency$Operations {
        query: QueryOperation<Currency>;
        read: ReadOperation<Currency>;
        aggregate: {
            read: AggregateReadOperation<Currency>;
            query: AggregateQueryOperation<Currency>;
        };
        getDefaults: GetDefaultsOperation<Currency>;
    }
    export interface CustomerAddressAddressEmails extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        customer: string;
        code: string;
        addressEmail: string;
        emailType: EmailAddressType;
    }
    export interface CustomerAddressAddressEmailsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        customer?: string;
        code?: string;
        addressEmail?: string;
    }
    export interface CustomerAddressAddressEmailsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        customer: string;
        code: string;
        addressEmail: string;
        emailType: EmailAddressType;
    }
    export interface CustomerAddressAddressEmails$Operations {
        query: QueryOperation<CustomerAddressAddressEmails>;
        read: ReadOperation<CustomerAddressAddressEmails>;
        aggregate: {
            read: AggregateReadOperation<CustomerAddressAddressEmails>;
            query: AggregateQueryOperation<CustomerAddressAddressEmails>;
        };
        getDefaults: GetDefaultsOperation<CustomerAddressAddressEmails>;
    }
    export interface CustomerAddressAddressLines extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        customer: string;
        code: string;
        addressLine: string;
    }
    export interface CustomerAddressAddressLinesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        customer?: string;
        code?: string;
        addressLine?: string;
    }
    export interface CustomerAddressAddressLinesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        customer: string;
        code: string;
        addressLine: string;
    }
    export interface CustomerAddressAddressLines$Operations {
        query: QueryOperation<CustomerAddressAddressLines>;
        read: ReadOperation<CustomerAddressAddressLines>;
        aggregate: {
            read: AggregateReadOperation<CustomerAddressAddressLines>;
            query: AggregateQueryOperation<CustomerAddressAddressLines>;
        };
        getDefaults: GetDefaultsOperation<CustomerAddressAddressLines>;
    }
    export interface CustomerAddressAddressPhoneNumbers extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        customer: string;
        code: string;
        addressPhoneNumber: string;
        phoneType: TelephoneType;
    }
    export interface CustomerAddressAddressPhoneNumbersInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        customer?: string;
        code?: string;
        addressPhoneNumber?: string;
    }
    export interface CustomerAddressAddressPhoneNumbersBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        customer: string;
        code: string;
        addressPhoneNumber: string;
        phoneType: TelephoneType;
    }
    export interface CustomerAddressAddressPhoneNumbers$Operations {
        query: QueryOperation<CustomerAddressAddressPhoneNumbers>;
        read: ReadOperation<CustomerAddressAddressPhoneNumbers>;
        aggregate: {
            read: AggregateReadOperation<CustomerAddressAddressPhoneNumbers>;
            query: AggregateQueryOperation<CustomerAddressAddressPhoneNumbers>;
        };
        getDefaults: GetDefaultsOperation<CustomerAddressAddressPhoneNumbers>;
    }
    export interface CustomerAddress extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        customer: Customer;
        code: string;
        description: string;
        defaultBankId: CustomerBankDetail;
        isDefault: boolean;
        zipCode: string;
        city: string;
        state: string;
        country: Country;
        countryName: string;
        website: string;
        externalIdentifier: string;
        isValid: boolean;
        addressEmails: ClientCollection<CustomerAddressAddressEmails>;
        addressLines: ClientCollection<CustomerAddressAddressLines>;
        addressPhoneNumbers: ClientCollection<CustomerAddressAddressPhoneNumbers>;
    }
    export interface CustomerAddressInput extends ClientNodeInput {
        entityType?: EntityType;
        customer?: string;
        code?: string;
        description?: string;
        defaultBankId?: string;
        isDefault?: boolean | string;
        zipCode?: string;
        city?: string;
        state?: string;
        country?: string;
        countryName?: string;
        website?: string;
        externalIdentifier?: string;
        isValid?: boolean | string;
        addressEmails?: Partial<CustomerAddressAddressEmailsInput>[];
        addressLines?: Partial<CustomerAddressAddressLinesInput>[];
        addressPhoneNumbers?: Partial<CustomerAddressAddressPhoneNumbersInput>[];
    }
    export interface CustomerAddressBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        customer: Customer;
        code: string;
        description: string;
        defaultBankId: CustomerBankDetail;
        isDefault: boolean;
        zipCode: string;
        city: string;
        state: string;
        country: Country;
        countryName: string;
        website: string;
        externalIdentifier: string;
        isValid: boolean;
        addressEmails: ClientCollection<CustomerAddressAddressEmailsBinding>;
        addressLines: ClientCollection<CustomerAddressAddressLinesBinding>;
        addressPhoneNumbers: ClientCollection<CustomerAddressAddressPhoneNumbersBinding>;
    }
    export interface CustomerAddress$Lookups {
        customer: QueryOperation<Customer>;
        defaultBankId: QueryOperation<CustomerBankDetail>;
        country: QueryOperation<Country>;
    }
    export interface CustomerAddress$Operations {
        query: QueryOperation<CustomerAddress>;
        read: ReadOperation<CustomerAddress>;
        aggregate: {
            read: AggregateReadOperation<CustomerAddress>;
            query: AggregateQueryOperation<CustomerAddress>;
        };
        lookups(dataOrId: string | { data: CustomerAddressInput }): CustomerAddress$Lookups;
        getDefaults: GetDefaultsOperation<CustomerAddress>;
    }
    export interface CustomerBankDetail extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        customer: Customer;
        bankId: string;
        address: CustomerAddress;
        byDefault: boolean;
        beneficiary: string;
        payingBank1: string;
        payingBank2: string;
        payingBank3: string;
        payingBank4: string;
        ibanPrefix: string;
        bic: string;
        country: Country;
        currency: Currency;
        intermediaryBankName: string;
        intermediaryBankAddress1: string;
        intermediaryBankAddress2: string;
        intermediaryBankAddress3: string;
        intermediaryBankBic: string;
        intermediaryBankCountry: Country;
        nonResidentAccount: boolean;
        isrCustomerNumber: string;
    }
    export interface CustomerBankDetailInput extends ClientNodeInput {
        entityType?: EntityType;
        customer?: string;
        bankId?: string;
        address?: string;
        byDefault?: boolean | string;
        beneficiary?: string;
        payingBank1?: string;
        payingBank2?: string;
        payingBank3?: string;
        payingBank4?: string;
        ibanPrefix?: string;
        bic?: string;
        country?: string;
        currency?: string;
        intermediaryBankName?: string;
        intermediaryBankAddress1?: string;
        intermediaryBankAddress2?: string;
        intermediaryBankAddress3?: string;
        intermediaryBankBic?: string;
        intermediaryBankCountry?: string;
        nonResidentAccount?: boolean | string;
        isrCustomerNumber?: string;
    }
    export interface CustomerBankDetailBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        customer: Customer;
        bankId: string;
        address: CustomerAddress;
        byDefault: boolean;
        beneficiary: string;
        payingBank1: string;
        payingBank2: string;
        payingBank3: string;
        payingBank4: string;
        ibanPrefix: string;
        bic: string;
        country: Country;
        currency: Currency;
        intermediaryBankName: string;
        intermediaryBankAddress1: string;
        intermediaryBankAddress2: string;
        intermediaryBankAddress3: string;
        intermediaryBankBic: string;
        intermediaryBankCountry: Country;
        nonResidentAccount: boolean;
        isrCustomerNumber: string;
    }
    export interface CustomerBankDetail$Lookups {
        customer: QueryOperation<Customer>;
        address: QueryOperation<CustomerAddress>;
        country: QueryOperation<Country>;
        currency: QueryOperation<Currency>;
        intermediaryBankCountry: QueryOperation<Country>;
    }
    export interface CustomerBankDetail$Operations {
        query: QueryOperation<CustomerBankDetail>;
        read: ReadOperation<CustomerBankDetail>;
        aggregate: {
            read: AggregateReadOperation<CustomerBankDetail>;
            query: AggregateQueryOperation<CustomerBankDetail>;
        };
        lookups(dataOrId: string | { data: CustomerBankDetailInput }): CustomerBankDetail$Lookups;
        getDefaults: GetDefaultsOperation<CustomerBankDetail>;
    }
    export interface CustomerCashTaxRules extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        isActive: boolean;
        startDate: string;
        endDate: string;
    }
    export interface CustomerCashTaxRulesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        isActive?: boolean | string;
        startDate?: string;
        endDate?: string;
    }
    export interface CustomerCashTaxRulesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        isActive: boolean;
        startDate: string;
        endDate: string;
    }
    export interface CustomerCashTaxRules$Operations {
        query: QueryOperation<CustomerCashTaxRules>;
        read: ReadOperation<CustomerCashTaxRules>;
        aggregate: {
            read: AggregateReadOperation<CustomerCashTaxRules>;
            query: AggregateQueryOperation<CustomerCashTaxRules>;
        };
        getDefaults: GetDefaultsOperation<CustomerCashTaxRules>;
    }
    export interface CustomerCategory extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        shortDescription: string;
        currency: Currency;
    }
    export interface CustomerCategoryInput extends ClientNodeInput {
        code?: string;
        description?: string;
        shortDescription?: string;
        currency?: string;
    }
    export interface CustomerCategoryBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        shortDescription: string;
        currency: Currency;
    }
    export interface CustomerCategory$Lookups {
        currency: QueryOperation<Currency>;
    }
    export interface CustomerCategory$Operations {
        query: QueryOperation<CustomerCategory>;
        read: ReadOperation<CustomerCategory>;
        aggregate: {
            read: AggregateReadOperation<CustomerCategory>;
            query: AggregateQueryOperation<CustomerCategory>;
        };
        lookups(dataOrId: string | { data: CustomerCategoryInput }): CustomerCategory$Lookups;
        getDefaults: GetDefaultsOperation<CustomerCategory>;
    }
    export interface CustomerContact extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        customer: Customer;
        code: ContactRelationship;
        position: FunctionContact;
        department: string;
        role: MiscellaneousTable;
        defaultAddress: string;
        landline: string;
        fax: string;
        email: string;
        cellPhone: string;
        isDataProtectionOfficer: boolean;
        contactRelationship: ContactRelationship;
        addressLines: ClientCollection<ContactRelationshipAddressLines>;
        relationshipCellPhone: string;
        relationshipCity: string;
        relationshipCountry: Country;
        relationshipCountryName: string;
        relationshipDateOfBirth: string;
        relationshipEmail: string;
        relationshipFax: string;
        relationshipFirstName: string;
        relationshipFullNameSearchKey: string;
        relationshipIsMailingProhibited: boolean;
        relationshipLandline: string;
        relationshipLanguage: Language;
        relationshipLastName: string;
        relationshipProfessionalCategory: MiscellaneousTable;
        relationshipState: string;
        relationshipTitle: Title;
        relationshipType: ContactType;
        relationshipZipCode: string;
    }
    export interface CustomerContactInput extends ClientNodeInput {
        entityType?: EntityType;
        customer?: string;
        code?: string;
        position?: FunctionContact;
        department?: string;
        role?: string;
        defaultAddress?: string;
        landline?: string;
        fax?: string;
        email?: string;
        cellPhone?: string;
        isDataProtectionOfficer?: boolean | string;
        contactRelationship?: string;
        addressLines?: Partial<ContactRelationshipAddressLinesInput>[];
        relationshipCellPhone?: string;
        relationshipCity?: string;
        relationshipCountry?: string;
        relationshipCountryName?: string;
        relationshipDateOfBirth?: string;
        relationshipEmail?: string;
        relationshipFax?: string;
        relationshipFirstName?: string;
        relationshipFullNameSearchKey?: string;
        relationshipIsMailingProhibited?: boolean | string;
        relationshipLandline?: string;
        relationshipLanguage?: string;
        relationshipLastName?: string;
        relationshipProfessionalCategory?: string;
        relationshipState?: string;
        relationshipTitle?: Title;
        relationshipType?: ContactType;
        relationshipZipCode?: string;
    }
    export interface CustomerContactBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        customer: Customer;
        code: ContactRelationship;
        position: FunctionContact;
        department: string;
        role: MiscellaneousTable;
        defaultAddress: string;
        landline: string;
        fax: string;
        email: string;
        cellPhone: string;
        isDataProtectionOfficer: boolean;
        contactRelationship: ContactRelationship;
        addressLines: ClientCollection<ContactRelationshipAddressLines>;
        relationshipCellPhone: string;
        relationshipCity: string;
        relationshipCountry: Country;
        relationshipCountryName: string;
        relationshipDateOfBirth: string;
        relationshipEmail: string;
        relationshipFax: string;
        relationshipFirstName: string;
        relationshipFullNameSearchKey: string;
        relationshipIsMailingProhibited: boolean;
        relationshipLandline: string;
        relationshipLanguage: Language;
        relationshipLastName: string;
        relationshipProfessionalCategory: MiscellaneousTable;
        relationshipState: string;
        relationshipTitle: Title;
        relationshipType: ContactType;
        relationshipZipCode: string;
    }
    export interface CustomerContact$Lookups {
        customer: QueryOperation<Customer>;
        code: QueryOperation<ContactRelationship>;
        role: QueryOperation<MiscellaneousTable>;
        contactRelationship: QueryOperation<ContactRelationship>;
        relationshipCountry: QueryOperation<Country>;
        relationshipLanguage: QueryOperation<Language>;
        relationshipProfessionalCategory: QueryOperation<MiscellaneousTable>;
    }
    export interface CustomerContact$Operations {
        query: QueryOperation<CustomerContact>;
        read: ReadOperation<CustomerContact>;
        aggregate: {
            read: AggregateReadOperation<CustomerContact>;
            query: AggregateQueryOperation<CustomerContact>;
        };
        lookups(dataOrId: string | { data: CustomerContactInput }): CustomerContact$Lookups;
        getDefaults: GetDefaultsOperation<CustomerContact>;
    }
    export interface CustomerPaymentDays extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        paymentDay: integer;
    }
    export interface CustomerPaymentDaysInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        paymentDay?: integer | string;
    }
    export interface CustomerPaymentDaysBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        paymentDay: integer;
    }
    export interface CustomerPaymentDays$Operations {
        query: QueryOperation<CustomerPaymentDays>;
        read: ReadOperation<CustomerPaymentDays>;
        aggregate: {
            read: AggregateReadOperation<CustomerPaymentDays>;
            query: AggregateQueryOperation<CustomerPaymentDays>;
        };
        getDefaults: GetDefaultsOperation<CustomerPaymentDays>;
    }
    export interface CustomerProduct extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        customer: BusinessPartner;
        isActive: boolean;
        customerProduct: string;
        customerProductDescription: string;
        salesUnit: UnitOfMeasure;
        salesUnitToStockUnitConversion: string;
        packingUnit1: UnitOfMeasure;
        packingUnit1ToSalesUnitConversion: string;
        packingUnit2: UnitOfMeasure;
        packingUnit2ToSalesUnitConversion: string;
        customerUseByDateCoefficient: string;
        journalNumberConfigurator: string;
        isVersionPreloaded: boolean;
        pickingText: TextStream;
        salesText: TextStream;
    }
    export interface CustomerProductInput extends ClientNodeInput {
        product?: string;
        customer?: string;
        isActive?: boolean | string;
        customerProduct?: string;
        customerProductDescription?: string;
        salesUnit?: string;
        salesUnitToStockUnitConversion?: decimal | string;
        packingUnit1?: string;
        packingUnit1ToSalesUnitConversion?: decimal | string;
        packingUnit2?: string;
        packingUnit2ToSalesUnitConversion?: decimal | string;
        customerUseByDateCoefficient?: decimal | string;
        journalNumberConfigurator?: string;
        isVersionPreloaded?: boolean | string;
        pickingText?: TextStream;
        salesText?: TextStream;
    }
    export interface CustomerProductBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        customer: BusinessPartner;
        isActive: boolean;
        customerProduct: string;
        customerProductDescription: string;
        salesUnit: UnitOfMeasure;
        salesUnitToStockUnitConversion: string;
        packingUnit1: UnitOfMeasure;
        packingUnit1ToSalesUnitConversion: string;
        packingUnit2: UnitOfMeasure;
        packingUnit2ToSalesUnitConversion: string;
        customerUseByDateCoefficient: string;
        journalNumberConfigurator: string;
        isVersionPreloaded: boolean;
        pickingText: TextStream;
        salesText: TextStream;
    }
    export interface CustomerProduct$Lookups {
        product: QueryOperation<Product>;
        customer: QueryOperation<BusinessPartner>;
        salesUnit: QueryOperation<UnitOfMeasure>;
        packingUnit1: QueryOperation<UnitOfMeasure>;
        packingUnit2: QueryOperation<UnitOfMeasure>;
    }
    export interface CustomerProduct$Operations {
        query: QueryOperation<CustomerProduct>;
        read: ReadOperation<CustomerProduct>;
        aggregate: {
            read: AggregateReadOperation<CustomerProduct>;
            query: AggregateQueryOperation<CustomerProduct>;
        };
        lookups(dataOrId: string | { data: CustomerProductInput }): CustomerProduct$Lookups;
        getDefaults: GetDefaultsOperation<CustomerProduct>;
    }
    export interface CustomerSalesReps extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        salesRep: SalesRep;
    }
    export interface CustomerSalesRepsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        salesRep?: string;
    }
    export interface CustomerSalesRepsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        salesRep: SalesRep;
    }
    export interface CustomerSalesReps$Lookups {
        salesRep: QueryOperation<SalesRep>;
    }
    export interface CustomerSalesReps$Operations {
        query: QueryOperation<CustomerSalesReps>;
        read: ReadOperation<CustomerSalesReps>;
        aggregate: {
            read: AggregateReadOperation<CustomerSalesReps>;
            query: AggregateQueryOperation<CustomerSalesReps>;
        };
        lookups(dataOrId: string | { data: CustomerSalesRepsInput }): CustomerSalesReps$Lookups;
        getDefaults: GetDefaultsOperation<CustomerSalesReps>;
    }
    export interface CustomerStatisticalGroups extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        value: MiscellaneousTable;
    }
    export interface CustomerStatisticalGroupsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        value?: string;
    }
    export interface CustomerStatisticalGroupsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        value: MiscellaneousTable;
    }
    export interface CustomerStatisticalGroups$Lookups {
        value: QueryOperation<MiscellaneousTable>;
    }
    export interface CustomerStatisticalGroups$Operations {
        query: QueryOperation<CustomerStatisticalGroups>;
        read: ReadOperation<CustomerStatisticalGroups>;
        aggregate: {
            read: AggregateReadOperation<CustomerStatisticalGroups>;
            query: AggregateQueryOperation<CustomerStatisticalGroups>;
        };
        lookups(dataOrId: string | { data: CustomerStatisticalGroupsInput }): CustomerStatisticalGroups$Lookups;
        getDefaults: GetDefaultsOperation<CustomerStatisticalGroups>;
    }
    export interface Customer extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: BusinessPartner;
        customerCategory: CustomerCategory;
        billToCustomer: Customer;
        billToCustomerAddress: CustomerAddress;
        payByCustomer: BusinessPartner;
        payByCustomerAddress: BusinessPartnerAddress;
        groupCustomer: Customer;
        riskCustomer: Customer;
        defaultAddress: CustomerAddress;
        defaultShipToAddress: ShipToCustomerAddress;
        defaultContact: CustomerContact;
        isActive: boolean;
        ourSupplierCode: string;
        currency: Currency;
        rateType: ExchangeRateType;
        commissionCategory: CommissionCategory;
        exemptionTaxNumber: string;
        priceOrAmountType: PriceAmountTaxTax;
        creditControl: WorkInProgressControl;
        authorizedCreditAmount: string;
        minimumOrderAmount: string;
        creditInsuranceAmount: string;
        insuranceDate: string;
        insuranceCompany: BusinessPartner;
        reminderType: ReminderType;
        minimumReminderAmount: string;
        canBeMatched: boolean;
        isLoanAllowed: boolean;
        mustPrintAcknowledgment: boolean;
        isOrderClosingAllowed: boolean;
        mustContainOneOrderPerDelivery: boolean;
        businessSector: MiscellaneousTable;
        prospectOrigin: MiscellaneousTable;
        tokenCredit: integer;
        manualAdditionalToken: integer;
        totalTokenCredit: integer;
        necessaryTokensForServiceContract: integer;
        firstContactDate: string;
        firstOrderDate: string;
        lastQuoteDate: string;
        lastContactDate: string;
        nextContactDate: string;
        customerAbcClass: ProductAbcClass;
        printTemplate: PrintTemplate;
        initialDateSinceCustomer: string;
        unavailablePaymentPeriod: UnavailablePeriods;
        isSubjectToTax: boolean;
        isEfatElectronicInvoicingAllowed: boolean;
        contact: CustomerContact;
        startDateforElectronicInvoice: string;
        isElectronicInvoiceAllowed: boolean;
        addresses: ClientCollection<CustomerAddress>;
        contacts: ClientCollection<CustomerContact>;
        bankDetails: ClientCollection<CustomerBankDetail>;
        businessPartner: BusinessPartner;
        shipToCustomers: ClientCollection<ShipToCustomerAddress>;
        acronym: string;
        businessPartnerSite: Site;
        cfonbPaymentMethod: MiscellaneousTable;
        companyName1: string;
        companyName2: string;
        companyNames: ClientCollection<BusinessPartnerCompanyNames>;
        consolidationCode: string;
        consolidationGroup: SiteGroupings;
        consolidationPartner: BusinessPartner;
        country: Country;
        customerOrSupplierOriginCategory: string;
        documentType: DocumentType;
        economicOperatorRegistrationAndIdNumber: string;
        electronicAddress: string;
        electronicInvoiceType: ElectronicInvoiceType;
        europeanUnionVatNumber: string;
        fiscalCode: string;
        invoiceHeaderText: TextStream;
        isCashExcluded: boolean;
        isIntersite: boolean;
        isMailingProhibited: boolean;
        isPhysicalPerson: boolean;
        isPublicSector: boolean;
        isServiceCaller: boolean;
        isServiceSupplier: boolean;
        italianTaxNumber: string;
        language: Language;
        nonResidentAccount: BusinessPartnerAddress;
        orderHeaderText: TextStream;
        registrationNumber: string;
        relatedCompany: RelatedCompanySettings;
        reportAccessCode: Access;
        routingCode: string;
        serviceCode: string;
        shortCompanyName: string;
        siteIdentificationNumber: string;
        standardIndustrialClassificationCode: string;
        vatNumber: string;
        cashTaxRules: ClientCollection<CustomerCashTaxRules>;
        paymentDays: ClientCollection<CustomerPaymentDays>;
        salesReps: ClientCollection<CustomerSalesReps>;
        statisticalGroups: ClientCollection<CustomerStatisticalGroups>;
    }
    export interface CustomerInput extends ClientNodeInput {
        code?: string;
        customerCategory?: string;
        billToCustomer?: string;
        billToCustomerAddress?: string;
        payByCustomer?: string;
        payByCustomerAddress?: string;
        groupCustomer?: string;
        riskCustomer?: string;
        defaultAddress?: string;
        defaultShipToAddress?: string;
        defaultContact?: string;
        isActive?: boolean | string;
        ourSupplierCode?: string;
        currency?: string;
        rateType?: ExchangeRateType;
        commissionCategory?: CommissionCategory;
        exemptionTaxNumber?: string;
        priceOrAmountType?: PriceAmountTaxTax;
        creditControl?: WorkInProgressControl;
        authorizedCreditAmount?: decimal | string;
        minimumOrderAmount?: decimal | string;
        creditInsuranceAmount?: decimal | string;
        insuranceDate?: string;
        insuranceCompany?: string;
        reminderType?: ReminderType;
        minimumReminderAmount?: decimal | string;
        canBeMatched?: boolean | string;
        isLoanAllowed?: boolean | string;
        mustPrintAcknowledgment?: boolean | string;
        isOrderClosingAllowed?: boolean | string;
        mustContainOneOrderPerDelivery?: boolean | string;
        businessSector?: string;
        prospectOrigin?: string;
        tokenCredit?: integer | string;
        manualAdditionalToken?: integer | string;
        totalTokenCredit?: integer | string;
        necessaryTokensForServiceContract?: integer | string;
        firstContactDate?: string;
        firstOrderDate?: string;
        lastQuoteDate?: string;
        lastContactDate?: string;
        nextContactDate?: string;
        customerAbcClass?: ProductAbcClass;
        printTemplate?: string;
        initialDateSinceCustomer?: string;
        unavailablePaymentPeriod?: string;
        isSubjectToTax?: boolean | string;
        isEfatElectronicInvoicingAllowed?: boolean | string;
        contact?: string;
        startDateforElectronicInvoice?: string;
        isElectronicInvoiceAllowed?: boolean | string;
        addresses?: Partial<CustomerAddressInput>[];
        contacts?: Partial<CustomerContactInput>[];
        bankDetails?: Partial<CustomerBankDetailInput>[];
        businessPartner?: string;
        shipToCustomers?: Partial<ShipToCustomerAddressInput>[];
        acronym?: string;
        businessPartnerSite?: string;
        cfonbPaymentMethod?: string;
        companyName1?: string;
        companyName2?: string;
        companyNames?: Partial<BusinessPartnerCompanyNamesInput>[];
        consolidationCode?: string;
        consolidationGroup?: string;
        consolidationPartner?: string;
        country?: string;
        customerOrSupplierOriginCategory?: string;
        documentType?: DocumentType;
        economicOperatorRegistrationAndIdNumber?: string;
        electronicAddress?: string;
        electronicInvoiceType?: ElectronicInvoiceType;
        europeanUnionVatNumber?: string;
        fiscalCode?: string;
        invoiceHeaderText?: TextStream;
        isCashExcluded?: boolean | string;
        isIntersite?: boolean | string;
        isMailingProhibited?: boolean | string;
        isPhysicalPerson?: boolean | string;
        isPublicSector?: boolean | string;
        isServiceCaller?: boolean | string;
        isServiceSupplier?: boolean | string;
        italianTaxNumber?: string;
        language?: string;
        nonResidentAccount?: string;
        orderHeaderText?: TextStream;
        registrationNumber?: string;
        relatedCompany?: RelatedCompanySettings;
        reportAccessCode?: string;
        routingCode?: string;
        serviceCode?: string;
        shortCompanyName?: string;
        siteIdentificationNumber?: string;
        standardIndustrialClassificationCode?: string;
        vatNumber?: string;
        cashTaxRules?: Partial<CustomerCashTaxRulesInput>[];
        paymentDays?: Partial<CustomerPaymentDaysInput>[];
        salesReps?: Partial<CustomerSalesRepsInput>[];
        statisticalGroups?: Partial<CustomerStatisticalGroupsInput>[];
    }
    export interface CustomerBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: BusinessPartner;
        customerCategory: CustomerCategory;
        billToCustomer: Customer;
        billToCustomerAddress: CustomerAddress;
        payByCustomer: BusinessPartner;
        payByCustomerAddress: BusinessPartnerAddress;
        groupCustomer: Customer;
        riskCustomer: Customer;
        defaultAddress: CustomerAddress;
        defaultShipToAddress: ShipToCustomerAddress;
        defaultContact: CustomerContact;
        isActive: boolean;
        ourSupplierCode: string;
        currency: Currency;
        rateType: ExchangeRateType;
        commissionCategory: CommissionCategory;
        exemptionTaxNumber: string;
        priceOrAmountType: PriceAmountTaxTax;
        creditControl: WorkInProgressControl;
        authorizedCreditAmount: string;
        minimumOrderAmount: string;
        creditInsuranceAmount: string;
        insuranceDate: string;
        insuranceCompany: BusinessPartner;
        reminderType: ReminderType;
        minimumReminderAmount: string;
        canBeMatched: boolean;
        isLoanAllowed: boolean;
        mustPrintAcknowledgment: boolean;
        isOrderClosingAllowed: boolean;
        mustContainOneOrderPerDelivery: boolean;
        businessSector: MiscellaneousTable;
        prospectOrigin: MiscellaneousTable;
        tokenCredit: integer;
        manualAdditionalToken: integer;
        totalTokenCredit: integer;
        necessaryTokensForServiceContract: integer;
        firstContactDate: string;
        firstOrderDate: string;
        lastQuoteDate: string;
        lastContactDate: string;
        nextContactDate: string;
        customerAbcClass: ProductAbcClass;
        printTemplate: PrintTemplate;
        initialDateSinceCustomer: string;
        unavailablePaymentPeriod: UnavailablePeriods;
        isSubjectToTax: boolean;
        isEfatElectronicInvoicingAllowed: boolean;
        contact: CustomerContact;
        startDateforElectronicInvoice: string;
        isElectronicInvoiceAllowed: boolean;
        addresses: ClientCollection<CustomerAddress>;
        contacts: ClientCollection<CustomerContact>;
        bankDetails: ClientCollection<CustomerBankDetail>;
        businessPartner: BusinessPartner;
        shipToCustomers: ClientCollection<ShipToCustomerAddress>;
        acronym: string;
        businessPartnerSite: Site;
        cfonbPaymentMethod: MiscellaneousTable;
        companyName1: string;
        companyName2: string;
        companyNames: ClientCollection<BusinessPartnerCompanyNames>;
        consolidationCode: string;
        consolidationGroup: SiteGroupings;
        consolidationPartner: BusinessPartner;
        country: Country;
        customerOrSupplierOriginCategory: string;
        documentType: DocumentType;
        economicOperatorRegistrationAndIdNumber: string;
        electronicAddress: string;
        electronicInvoiceType: ElectronicInvoiceType;
        europeanUnionVatNumber: string;
        fiscalCode: string;
        invoiceHeaderText: TextStream;
        isCashExcluded: boolean;
        isIntersite: boolean;
        isMailingProhibited: boolean;
        isPhysicalPerson: boolean;
        isPublicSector: boolean;
        isServiceCaller: boolean;
        isServiceSupplier: boolean;
        italianTaxNumber: string;
        language: Language;
        nonResidentAccount: BusinessPartnerAddress;
        orderHeaderText: TextStream;
        registrationNumber: string;
        relatedCompany: RelatedCompanySettings;
        reportAccessCode: Access;
        routingCode: string;
        serviceCode: string;
        shortCompanyName: string;
        siteIdentificationNumber: string;
        standardIndustrialClassificationCode: string;
        vatNumber: string;
        cashTaxRules: ClientCollection<CustomerCashTaxRulesBinding>;
        paymentDays: ClientCollection<CustomerPaymentDaysBinding>;
        salesReps: ClientCollection<CustomerSalesRepsBinding>;
        statisticalGroups: ClientCollection<CustomerStatisticalGroupsBinding>;
    }
    export interface Customer$Lookups {
        code: QueryOperation<BusinessPartner>;
        customerCategory: QueryOperation<CustomerCategory>;
        billToCustomer: QueryOperation<Customer>;
        billToCustomerAddress: QueryOperation<CustomerAddress>;
        payByCustomer: QueryOperation<BusinessPartner>;
        payByCustomerAddress: QueryOperation<BusinessPartnerAddress>;
        groupCustomer: QueryOperation<Customer>;
        riskCustomer: QueryOperation<Customer>;
        defaultAddress: QueryOperation<CustomerAddress>;
        defaultShipToAddress: QueryOperation<ShipToCustomerAddress>;
        defaultContact: QueryOperation<CustomerContact>;
        currency: QueryOperation<Currency>;
        insuranceCompany: QueryOperation<BusinessPartner>;
        businessSector: QueryOperation<MiscellaneousTable>;
        prospectOrigin: QueryOperation<MiscellaneousTable>;
        printTemplate: QueryOperation<PrintTemplate>;
        unavailablePaymentPeriod: QueryOperation<UnavailablePeriods>;
        contact: QueryOperation<CustomerContact>;
        businessPartner: QueryOperation<BusinessPartner>;
        businessPartnerSite: QueryOperation<Site>;
        cfonbPaymentMethod: QueryOperation<MiscellaneousTable>;
        consolidationGroup: QueryOperation<SiteGroupings>;
        consolidationPartner: QueryOperation<BusinessPartner>;
        country: QueryOperation<Country>;
        language: QueryOperation<Language>;
        nonResidentAccount: QueryOperation<BusinessPartnerAddress>;
        reportAccessCode: QueryOperation<Access>;
    }
    export interface Customer$Operations {
        query: QueryOperation<Customer>;
        read: ReadOperation<Customer>;
        aggregate: {
            read: AggregateReadOperation<Customer>;
            query: AggregateQueryOperation<Customer>;
        };
        create: CreateOperation<CustomerInput, Customer>;
        getDuplicate: GetDuplicateOperation<Customer>;
        update: UpdateOperation<CustomerInput, Customer>;
        updateById: UpdateByIdOperation<CustomerInput, Customer>;
        lookups(dataOrId: string | { data: CustomerInput }): Customer$Lookups;
        getDefaults: GetDefaultsOperation<Customer>;
    }
    export interface Incoterm extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        isActive: boolean;
    }
    export interface IncotermInput extends ClientNodeInput {
        code?: string;
        description?: string;
        isActive?: boolean | string;
    }
    export interface IncotermBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        isActive: boolean;
    }
    export interface Incoterm$Operations {
        query: QueryOperation<Incoterm>;
        read: ReadOperation<Incoterm>;
        aggregate: {
            read: AggregateReadOperation<Incoterm>;
            query: AggregateQueryOperation<Incoterm>;
        };
        getDefaults: GetDefaultsOperation<Incoterm>;
    }
    export interface Mapping extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        mappingCode: string;
        localizedDescription: string;
        company: Company;
        site: Site;
        legislation: MiscellaneousTable;
        version: string;
        direction: Sense;
    }
    export interface MappingInput extends ClientNodeInput {
        code?: string;
        mappingCode?: string;
        localizedDescription?: string;
        company?: string;
        site?: string;
        legislation?: string;
        version?: string;
        direction?: Sense;
    }
    export interface MappingBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        mappingCode: string;
        localizedDescription: string;
        company: Company;
        site: Site;
        legislation: MiscellaneousTable;
        version: string;
        direction: Sense;
    }
    export interface Mapping$Lookups {
        company: QueryOperation<Company>;
        site: QueryOperation<Site>;
        legislation: QueryOperation<MiscellaneousTable>;
    }
    export interface Mapping$Operations {
        query: QueryOperation<Mapping>;
        read: ReadOperation<Mapping>;
        aggregate: {
            read: AggregateReadOperation<Mapping>;
            query: AggregateQueryOperation<Mapping>;
        };
        lookups(dataOrId: string | { data: MappingInput }): Mapping$Lookups;
        getDefaults: GetDefaultsOperation<Mapping>;
    }
    export interface MobileAutomationSetup extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        site: Site;
        criteria1: ProductSearchCriteria;
        criteria2: ProductSearchCriteria;
        stockLabel: GenericPrintReport;
        productionLabel: GenericPrintReport;
        isAlwaysLabelDestination: boolean;
        isTheoreticalQuantityDisplayed: boolean;
        isLocationPreloaded: boolean;
    }
    export interface MobileAutomationSetupInput extends ClientNodeInput {
        site?: string;
        criteria1?: ProductSearchCriteria;
        criteria2?: ProductSearchCriteria;
        stockLabel?: string;
        productionLabel?: string;
        isAlwaysLabelDestination?: boolean | string;
        isTheoreticalQuantityDisplayed?: boolean | string;
        isLocationPreloaded?: boolean | string;
    }
    export interface MobileAutomationSetupBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        site: Site;
        criteria1: ProductSearchCriteria;
        criteria2: ProductSearchCriteria;
        stockLabel: GenericPrintReport;
        productionLabel: GenericPrintReport;
        isAlwaysLabelDestination: boolean;
        isTheoreticalQuantityDisplayed: boolean;
        isLocationPreloaded: boolean;
    }
    export interface MobileAutomationSetup$Lookups {
        site: QueryOperation<Site>;
        stockLabel: QueryOperation<GenericPrintReport>;
        productionLabel: QueryOperation<GenericPrintReport>;
    }
    export interface MobileAutomationSetup$Operations {
        query: QueryOperation<MobileAutomationSetup>;
        read: ReadOperation<MobileAutomationSetup>;
        aggregate: {
            read: AggregateReadOperation<MobileAutomationSetup>;
            query: AggregateQueryOperation<MobileAutomationSetup>;
        };
        lookups(dataOrId: string | { data: MobileAutomationSetupInput }): MobileAutomationSetup$Lookups;
        getDefaults: GetDefaultsOperation<MobileAutomationSetup>;
    }
    export interface PrintTemplate extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface PrintTemplateInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
    }
    export interface PrintTemplateBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
    }
    export interface PrintTemplate$Operations {
        query: QueryOperation<PrintTemplate>;
        read: ReadOperation<PrintTemplate>;
        aggregate: {
            read: AggregateReadOperation<PrintTemplate>;
            query: AggregateQueryOperation<PrintTemplate>;
        };
        getDefaults: GetDefaultsOperation<PrintTemplate>;
    }
    export interface ProductCategoryStatisticalGroups extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        stockSite: string;
        code: string;
        statisticalGroup: MiscellaneousTable;
    }
    export interface ProductCategoryStatisticalGroupsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        stockSite?: string;
        code?: string;
        statisticalGroup?: string;
    }
    export interface ProductCategoryStatisticalGroupsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        stockSite: string;
        code: string;
        statisticalGroup: MiscellaneousTable;
    }
    export interface ProductCategoryStatisticalGroups$Lookups {
        statisticalGroup: QueryOperation<MiscellaneousTable>;
    }
    export interface ProductCategoryStatisticalGroups$Operations {
        query: QueryOperation<ProductCategoryStatisticalGroups>;
        read: ReadOperation<ProductCategoryStatisticalGroups>;
        aggregate: {
            read: AggregateReadOperation<ProductCategoryStatisticalGroups>;
            query: AggregateQueryOperation<ProductCategoryStatisticalGroups>;
        };
        lookups(
            dataOrId: string | { data: ProductCategoryStatisticalGroupsInput },
        ): ProductCategoryStatisticalGroups$Lookups;
        getDefaults: GetDefaultsOperation<ProductCategoryStatisticalGroups>;
    }
    export interface ProductCategory extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        stockSite: Site;
        code: string;
        description: string;
        localizedDescription: string;
        shortDescription: string;
        localizedShortDescription: string;
        isSold: boolean;
        productSequenceNumber: string;
        creationMethod: ProductCreationMode;
        qualityControlManagementMode: SubjectToControl;
        qualityControlAccessCode: string;
        stockUnit: UnitOfMeasure;
        purchaseUnit: UnitOfMeasure;
        salesUnit: UnitOfMeasure;
        statisticUnit: UnitOfMeasure;
        euUnit: UnitOfMeasure;
        purchaseUnitToStockUnitConversionFactor: string;
        salesUnitToStockUnitConversionFactor: string;
        statisticalUnitToStockUnitConversionFactor: string;
        euUnitToStockUnitConversionFactor: string;
        isPurchaseConversionFactorEntryAllowed: boolean;
        isSalesConversionFactorEntryAllowed: boolean;
        weightUnit: UnitOfMeasure;
        stockUnitWeight: string;
        volumeUnit: UnitOfMeasure;
        stockUnitVolume: string;
        labelFormatForStockUnit: GenericPrintReport;
        stockManagementMode: StockManagement;
        managementMode: StandardProductCode;
        isNegativeStockAuthorized: boolean;
        lotSequenceNumber: string;
        serialNumberManagementMode: SerialNumberManagement;
        serialSequenceNumber: string;
        valuationMethod: string;
        expirationManagementMode: ExpirationManagement;
        expirationStockStatus: string;
        userAccessCode: string;
        purchasingPlanningHorizonTimeUnit: LeadTimeUnit;
        purchasingPlanningHorizon: integer;
        purchasingFirmHorizon: integer;
        purchasingFirmHorizonTimeUnit: LeadTimeUnit;
        reorderLeadTime: string;
        buyer: User;
        planner: User;
        purchaseDeliveryTolerance: string;
        isReceived: boolean;
        isMandatoryPurchaseOrderRequest: boolean;
        landedCostCoefficient: string;
        fixedLandedCostPerUnit: string;
        salesPriceOrigin: PriceOrigin;
        percentagePricePurchaseApplied: string;
        configuratorProductLine: string;
        isLocationManaged: boolean;
        salesOrderAllocationRule: string;
        workOrderAllocationRule: string;
        shipmentAllocationRule: string;
        materialConsumptionAllocationRule: string;
        transferAllocationRule: string;
        subcontractReplenishmentAllocationRule: string;
        subcontractConsumptionAllocationRule: string;
        afterSalesAllocationRule: string;
        isStatusAAuthorizedInGlobalAllocation: boolean;
        isStatusQAuthorizedInGlobalAllocation: boolean;
        isStatusRAuthorizedInGlobalAllocation: boolean;
        abcClass: ProductAbcClass;
        stockWithdrawalMode: StockWithdrawal;
        countManagementMode: Count;
        trendProfile: string;
        shrinkagePercent: string;
        planningFirmHorizon: integer;
        planningFirmHorizonTimeUnit: LeadTimeUnit;
        planningRequestHorizon: integer;
        planningRequestHorizonTimeUnit: LeadTimeUnit;
        reorderingPeriodicity: integer;
        reorderingSuggestionType: SuggestionType;
        reorderingSite: Site;
        reorderingPolicy: string;
        stockCoverageInWeeks: integer;
        safetyStock: string;
        reorderingThreshold: string;
        reorderingMaximumStock: string;
        economicOrderQuantity: string;
        technicalLotQuantity: string;
        standardCostUpdate: PriceUpdateMode;
        revisedStandardCostUpdate: PriceUpdateMode;
        budgetStandardCostUpdate: PriceUpdateMode;
        simulatedCostUpdate: PriceUpdateMode;
        isReleasedIfShortage: boolean;
        automaticClosingPercentage: string;
        salesDeliveryTolerance: string;
        salesMinimumQuantity: string;
        salesMaximumQuantity: string;
        isLoanAuthorized: boolean;
        isBackToBackOrderManaged: boolean;
        directBackToBackOrderQuantity: string;
        isPurchased: boolean;
        isManufactured: boolean;
        isSubcontracted: boolean;
        isService: boolean;
        isPhantom: boolean;
        isGeneric: boolean;
        isTool: boolean;
        isDeliverable: boolean;
        isIntermediary: boolean;
        isMaintenance: boolean;
        packagingCapacity: string;
        assignmentRules: string;
        isStockDetailedInPacking: boolean;
        technicalSheet: TechnicalSheet;
        orderWarehouse: string;
        workOrderWarehouse: string;
        shippingWarehouse: string;
        materialConsumptionWarehouse: string;
        internalMovementWarehouse: string;
        subcontractShipmentWarehouse: string;
        subcontractConsumptionWarehouse: string;
        afterSalesWarehouse: string;
        canBeCapitalized: boolean;
        isPackingManaged: boolean;
        sageSalesTax: MiscellaneousTable;
        saftProductType: SafTProductType;
        freightClass: string;
        freightCommodityCode: string;
        isVersionManaged: boolean;
        minorVersionSequence: string;
        majorVersionSequence: string;
        isVersionPreloaded: boolean;
        inventoryProductType: ProductType;
        containerManagement: boolean;
        statisticalGroups: ClientCollection<ProductCategoryStatisticalGroups>;
    }
    export interface ProductCategoryInput extends ClientNodeInput {
        stockSite?: string;
        code?: string;
        description?: string;
        localizedDescription?: string;
        shortDescription?: string;
        localizedShortDescription?: string;
        isSold?: boolean | string;
        productSequenceNumber?: string;
        creationMethod?: ProductCreationMode;
        qualityControlManagementMode?: SubjectToControl;
        qualityControlAccessCode?: string;
        stockUnit?: string;
        purchaseUnit?: string;
        salesUnit?: string;
        statisticUnit?: string;
        euUnit?: string;
        purchaseUnitToStockUnitConversionFactor?: decimal | string;
        salesUnitToStockUnitConversionFactor?: decimal | string;
        statisticalUnitToStockUnitConversionFactor?: decimal | string;
        euUnitToStockUnitConversionFactor?: decimal | string;
        isPurchaseConversionFactorEntryAllowed?: boolean | string;
        isSalesConversionFactorEntryAllowed?: boolean | string;
        weightUnit?: string;
        stockUnitWeight?: decimal | string;
        volumeUnit?: string;
        stockUnitVolume?: decimal | string;
        labelFormatForStockUnit?: string;
        stockManagementMode?: StockManagement;
        managementMode?: StandardProductCode;
        isNegativeStockAuthorized?: boolean | string;
        lotSequenceNumber?: string;
        serialNumberManagementMode?: SerialNumberManagement;
        serialSequenceNumber?: string;
        valuationMethod?: string;
        expirationManagementMode?: ExpirationManagement;
        expirationStockStatus?: string;
        userAccessCode?: string;
        purchasingPlanningHorizonTimeUnit?: LeadTimeUnit;
        purchasingPlanningHorizon?: integer | string;
        purchasingFirmHorizon?: integer | string;
        purchasingFirmHorizonTimeUnit?: LeadTimeUnit;
        reorderLeadTime?: decimal | string;
        buyer?: string;
        planner?: string;
        purchaseDeliveryTolerance?: decimal | string;
        isReceived?: boolean | string;
        isMandatoryPurchaseOrderRequest?: boolean | string;
        landedCostCoefficient?: decimal | string;
        fixedLandedCostPerUnit?: decimal | string;
        salesPriceOrigin?: PriceOrigin;
        percentagePricePurchaseApplied?: decimal | string;
        configuratorProductLine?: string;
        isLocationManaged?: boolean | string;
        salesOrderAllocationRule?: string;
        workOrderAllocationRule?: string;
        shipmentAllocationRule?: string;
        materialConsumptionAllocationRule?: string;
        transferAllocationRule?: string;
        subcontractReplenishmentAllocationRule?: string;
        subcontractConsumptionAllocationRule?: string;
        afterSalesAllocationRule?: string;
        isStatusAAuthorizedInGlobalAllocation?: boolean | string;
        isStatusQAuthorizedInGlobalAllocation?: boolean | string;
        isStatusRAuthorizedInGlobalAllocation?: boolean | string;
        abcClass?: ProductAbcClass;
        stockWithdrawalMode?: StockWithdrawal;
        countManagementMode?: Count;
        trendProfile?: string;
        shrinkagePercent?: decimal | string;
        planningFirmHorizon?: integer | string;
        planningFirmHorizonTimeUnit?: LeadTimeUnit;
        planningRequestHorizon?: integer | string;
        planningRequestHorizonTimeUnit?: LeadTimeUnit;
        reorderingPeriodicity?: integer | string;
        reorderingSuggestionType?: SuggestionType;
        reorderingSite?: string;
        reorderingPolicy?: string;
        stockCoverageInWeeks?: integer | string;
        safetyStock?: decimal | string;
        reorderingThreshold?: decimal | string;
        reorderingMaximumStock?: decimal | string;
        economicOrderQuantity?: decimal | string;
        technicalLotQuantity?: decimal | string;
        standardCostUpdate?: PriceUpdateMode;
        revisedStandardCostUpdate?: PriceUpdateMode;
        budgetStandardCostUpdate?: PriceUpdateMode;
        simulatedCostUpdate?: PriceUpdateMode;
        isReleasedIfShortage?: boolean | string;
        automaticClosingPercentage?: decimal | string;
        salesDeliveryTolerance?: decimal | string;
        salesMinimumQuantity?: decimal | string;
        salesMaximumQuantity?: decimal | string;
        isLoanAuthorized?: boolean | string;
        isBackToBackOrderManaged?: boolean | string;
        directBackToBackOrderQuantity?: decimal | string;
        isPurchased?: boolean | string;
        isManufactured?: boolean | string;
        isSubcontracted?: boolean | string;
        isService?: boolean | string;
        isPhantom?: boolean | string;
        isGeneric?: boolean | string;
        isTool?: boolean | string;
        isDeliverable?: boolean | string;
        isIntermediary?: boolean | string;
        isMaintenance?: boolean | string;
        packagingCapacity?: decimal | string;
        assignmentRules?: string;
        isStockDetailedInPacking?: boolean | string;
        technicalSheet?: string;
        orderWarehouse?: string;
        workOrderWarehouse?: string;
        shippingWarehouse?: string;
        materialConsumptionWarehouse?: string;
        internalMovementWarehouse?: string;
        subcontractShipmentWarehouse?: string;
        subcontractConsumptionWarehouse?: string;
        afterSalesWarehouse?: string;
        canBeCapitalized?: boolean | string;
        isPackingManaged?: boolean | string;
        sageSalesTax?: string;
        saftProductType?: SafTProductType;
        freightClass?: string;
        freightCommodityCode?: string;
        isVersionManaged?: boolean | string;
        minorVersionSequence?: string;
        majorVersionSequence?: string;
        isVersionPreloaded?: boolean | string;
        inventoryProductType?: ProductType;
        containerManagement?: boolean | string;
        statisticalGroups?: Partial<ProductCategoryStatisticalGroupsInput>[];
    }
    export interface ProductCategoryBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        stockSite: Site;
        code: string;
        description: string;
        localizedDescription: string;
        shortDescription: string;
        localizedShortDescription: string;
        isSold: boolean;
        productSequenceNumber: string;
        creationMethod: ProductCreationMode;
        qualityControlManagementMode: SubjectToControl;
        qualityControlAccessCode: string;
        stockUnit: UnitOfMeasure;
        purchaseUnit: UnitOfMeasure;
        salesUnit: UnitOfMeasure;
        statisticUnit: UnitOfMeasure;
        euUnit: UnitOfMeasure;
        purchaseUnitToStockUnitConversionFactor: string;
        salesUnitToStockUnitConversionFactor: string;
        statisticalUnitToStockUnitConversionFactor: string;
        euUnitToStockUnitConversionFactor: string;
        isPurchaseConversionFactorEntryAllowed: boolean;
        isSalesConversionFactorEntryAllowed: boolean;
        weightUnit: UnitOfMeasure;
        stockUnitWeight: string;
        volumeUnit: UnitOfMeasure;
        stockUnitVolume: string;
        labelFormatForStockUnit: GenericPrintReport;
        stockManagementMode: StockManagement;
        managementMode: StandardProductCode;
        isNegativeStockAuthorized: boolean;
        lotSequenceNumber: string;
        serialNumberManagementMode: SerialNumberManagement;
        serialSequenceNumber: string;
        valuationMethod: string;
        expirationManagementMode: ExpirationManagement;
        expirationStockStatus: string;
        userAccessCode: string;
        purchasingPlanningHorizonTimeUnit: LeadTimeUnit;
        purchasingPlanningHorizon: integer;
        purchasingFirmHorizon: integer;
        purchasingFirmHorizonTimeUnit: LeadTimeUnit;
        reorderLeadTime: string;
        buyer: User;
        planner: User;
        purchaseDeliveryTolerance: string;
        isReceived: boolean;
        isMandatoryPurchaseOrderRequest: boolean;
        landedCostCoefficient: string;
        fixedLandedCostPerUnit: string;
        salesPriceOrigin: PriceOrigin;
        percentagePricePurchaseApplied: string;
        configuratorProductLine: string;
        isLocationManaged: boolean;
        salesOrderAllocationRule: string;
        workOrderAllocationRule: string;
        shipmentAllocationRule: string;
        materialConsumptionAllocationRule: string;
        transferAllocationRule: string;
        subcontractReplenishmentAllocationRule: string;
        subcontractConsumptionAllocationRule: string;
        afterSalesAllocationRule: string;
        isStatusAAuthorizedInGlobalAllocation: boolean;
        isStatusQAuthorizedInGlobalAllocation: boolean;
        isStatusRAuthorizedInGlobalAllocation: boolean;
        abcClass: ProductAbcClass;
        stockWithdrawalMode: StockWithdrawal;
        countManagementMode: Count;
        trendProfile: string;
        shrinkagePercent: string;
        planningFirmHorizon: integer;
        planningFirmHorizonTimeUnit: LeadTimeUnit;
        planningRequestHorizon: integer;
        planningRequestHorizonTimeUnit: LeadTimeUnit;
        reorderingPeriodicity: integer;
        reorderingSuggestionType: SuggestionType;
        reorderingSite: Site;
        reorderingPolicy: string;
        stockCoverageInWeeks: integer;
        safetyStock: string;
        reorderingThreshold: string;
        reorderingMaximumStock: string;
        economicOrderQuantity: string;
        technicalLotQuantity: string;
        standardCostUpdate: PriceUpdateMode;
        revisedStandardCostUpdate: PriceUpdateMode;
        budgetStandardCostUpdate: PriceUpdateMode;
        simulatedCostUpdate: PriceUpdateMode;
        isReleasedIfShortage: boolean;
        automaticClosingPercentage: string;
        salesDeliveryTolerance: string;
        salesMinimumQuantity: string;
        salesMaximumQuantity: string;
        isLoanAuthorized: boolean;
        isBackToBackOrderManaged: boolean;
        directBackToBackOrderQuantity: string;
        isPurchased: boolean;
        isManufactured: boolean;
        isSubcontracted: boolean;
        isService: boolean;
        isPhantom: boolean;
        isGeneric: boolean;
        isTool: boolean;
        isDeliverable: boolean;
        isIntermediary: boolean;
        isMaintenance: boolean;
        packagingCapacity: string;
        assignmentRules: string;
        isStockDetailedInPacking: boolean;
        technicalSheet: TechnicalSheet;
        orderWarehouse: string;
        workOrderWarehouse: string;
        shippingWarehouse: string;
        materialConsumptionWarehouse: string;
        internalMovementWarehouse: string;
        subcontractShipmentWarehouse: string;
        subcontractConsumptionWarehouse: string;
        afterSalesWarehouse: string;
        canBeCapitalized: boolean;
        isPackingManaged: boolean;
        sageSalesTax: MiscellaneousTable;
        saftProductType: SafTProductType;
        freightClass: string;
        freightCommodityCode: string;
        isVersionManaged: boolean;
        minorVersionSequence: string;
        majorVersionSequence: string;
        isVersionPreloaded: boolean;
        inventoryProductType: ProductType;
        containerManagement: boolean;
        statisticalGroups: ClientCollection<ProductCategoryStatisticalGroupsBinding>;
    }
    export interface ProductCategory$Lookups {
        stockSite: QueryOperation<Site>;
        stockUnit: QueryOperation<UnitOfMeasure>;
        purchaseUnit: QueryOperation<UnitOfMeasure>;
        salesUnit: QueryOperation<UnitOfMeasure>;
        statisticUnit: QueryOperation<UnitOfMeasure>;
        euUnit: QueryOperation<UnitOfMeasure>;
        weightUnit: QueryOperation<UnitOfMeasure>;
        volumeUnit: QueryOperation<UnitOfMeasure>;
        labelFormatForStockUnit: QueryOperation<GenericPrintReport>;
        buyer: QueryOperation<User>;
        planner: QueryOperation<User>;
        reorderingSite: QueryOperation<Site>;
        technicalSheet: QueryOperation<TechnicalSheet>;
        sageSalesTax: QueryOperation<MiscellaneousTable>;
    }
    export interface ProductCategory$Operations {
        query: QueryOperation<ProductCategory>;
        read: ReadOperation<ProductCategory>;
        aggregate: {
            read: AggregateReadOperation<ProductCategory>;
            query: AggregateQueryOperation<ProductCategory>;
        };
        create: CreateOperation<ProductCategoryInput, ProductCategory>;
        getDuplicate: GetDuplicateOperation<ProductCategory>;
        lookups(dataOrId: string | { data: ProductCategoryInput }): ProductCategory$Lookups;
        getDefaults: GetDefaultsOperation<ProductCategory>;
    }
    export interface ProductPackingUnits extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        packingUnit: UnitOfMeasure;
        packingUnitToStockUnitConversionFactor: string;
        isPackingFactorEntryAllowed: boolean;
        issuingPackingRule: UnpackingRulesPac;
        labelFormat: GenericPrintReport;
    }
    export interface ProductPackingUnitsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        packingUnit?: string;
        packingUnitToStockUnitConversionFactor?: decimal | string;
        isPackingFactorEntryAllowed?: boolean | string;
        issuingPackingRule?: UnpackingRulesPac;
        labelFormat?: string;
    }
    export interface ProductPackingUnitsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        packingUnit: UnitOfMeasure;
        packingUnitToStockUnitConversionFactor: string;
        isPackingFactorEntryAllowed: boolean;
        issuingPackingRule: UnpackingRulesPac;
        labelFormat: GenericPrintReport;
    }
    export interface ProductPackingUnits$Lookups {
        packingUnit: QueryOperation<UnitOfMeasure>;
        labelFormat: QueryOperation<GenericPrintReport>;
    }
    export interface ProductPackingUnits$Operations {
        query: QueryOperation<ProductPackingUnits>;
        read: ReadOperation<ProductPackingUnits>;
        aggregate: {
            read: AggregateReadOperation<ProductPackingUnits>;
            query: AggregateQueryOperation<ProductPackingUnits>;
        };
        lookups(dataOrId: string | { data: ProductPackingUnitsInput }): ProductPackingUnits$Lookups;
        getDefaults: GetDefaultsOperation<ProductPackingUnits>;
    }
    export interface ProductSite extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        stockSite: Site;
        isBeingCounted: boolean;
        countWorksheet: string;
        abcClass: ProductAbcClass;
        isLocationManaged: boolean;
        stockWithdrawalMode: StockWithdrawal;
        countManagementMode: Count;
        trendProfile: string;
        numberOfStockCoverageWeeks: integer;
        multilevelLeadTime: string;
        qualityControlLeadTime: string;
        planningFirmHorizon: integer;
        planningFirmHorizonTimeUnit: LeadTimeUnit;
        planningDemandHorizon: integer;
        planningDemandHorizonTimeUnit: LeadTimeUnit;
        reorderLeadTime: string;
        productionLeadTime: string;
        pickingLeadTime: string;
        reductionFactor: integer;
        reorderingPeriodicity: integer;
        reorderingSuggestionType: SuggestionType;
        reorderingSite: Site;
        reorderingPolicy: string;
        safetyStock: string;
        calculatedSafetyStock: string;
        reorderingThreshold: string;
        calculatedReorderingThreshold: string;
        reorderingMaximumStock: string;
        calculatedReorderingMaximumStock: string;
        economicOrderQuantity: string;
        calculatedEconomicOrderQuantity: string;
        technicalLotQuantity: string;
        shrinkagePercentage: string;
        planner: User;
        buyer: User;
        standardCostUpdate: PriceUpdateMode;
        revisedStandardCostUpdate: PriceUpdateMode;
        budgetStandardCostUpdate: PriceUpdateMode;
        simulatedCostUpdate: PriceUpdateMode;
        productionRouting: string;
        costRouting: string;
        roughCut: string;
        productionRoutingCode: BomRouting;
        costRoutingCode: BomRouting;
        roughCutCapacityPlanningRoutingCode: BomRouting;
        isReleasedIfShortage: boolean;
        isShrinkedWithRelease: boolean;
        yearOfLastMonthlyUpdate: integer;
        monthOfLastMonthlyUpdate: integer;
        lastAnnualUpdate: integer;
        automaticClosingPercentage: string;
        configurationCode: string;
        storageHandling: string;
        weighingAccessCode: string;
        weighingTolerance: string;
        productTolerance: string;
        valuationMethod: string;
        prorataQuantityAdjustment: string;
        protectionWip: boolean;
        packagingCapacity: string;
        stockManagementMode: StockManagement;
        assignmentRule: string;
        isStockDetailedInPacking: boolean;
        qualityControlManagementMode: SubjectToControl;
        qualityControlAccessCode: string;
        qualityControlFrequency: integer;
        numberOfEntriesSinceLastQualityControl: integer;
        sampling: SamplingType;
        samplingMode: SamplingMode;
        samplingGeneralCheckLevel: GeneralControlLevel;
        samplingAcceptableQualityLevel: AcceptableQualityLevel;
        qualityControlFrequencyToReview: integer;
        qualityEntriesProcess: integer;
        recontrolLeadTime: integer;
        newStockStatusAfterRecontrol: string;
        useByDateCoefficient: string;
        orderWarehouse: string;
        workOrderWarehouse: string;
        shippingWarehouse: string;
        materialConsumptionsWarehouse: string;
        internalMovementWarehouse: string;
        subcontractShipmentWarehouse: string;
        subcontractConsumptionWarehouse: string;
        isPackingManaged: boolean;
        freightClass: string;
        freightCommodityCode: string;
        isLicensePlateNumberManaged: boolean;
        products: ClientCollection<Product>;
    }
    export interface ProductSiteInput extends ClientNodeInput {
        product?: string;
        stockSite?: string;
        isBeingCounted?: boolean | string;
        countWorksheet?: string;
        abcClass?: ProductAbcClass;
        isLocationManaged?: boolean | string;
        stockWithdrawalMode?: StockWithdrawal;
        countManagementMode?: Count;
        trendProfile?: string;
        numberOfStockCoverageWeeks?: integer | string;
        multilevelLeadTime?: decimal | string;
        qualityControlLeadTime?: decimal | string;
        planningFirmHorizon?: integer | string;
        planningFirmHorizonTimeUnit?: LeadTimeUnit;
        planningDemandHorizon?: integer | string;
        planningDemandHorizonTimeUnit?: LeadTimeUnit;
        reorderLeadTime?: decimal | string;
        productionLeadTime?: decimal | string;
        pickingLeadTime?: decimal | string;
        reductionFactor?: integer | string;
        reorderingPeriodicity?: integer | string;
        reorderingSuggestionType?: SuggestionType;
        reorderingSite?: string;
        reorderingPolicy?: string;
        safetyStock?: decimal | string;
        calculatedSafetyStock?: decimal | string;
        reorderingThreshold?: decimal | string;
        calculatedReorderingThreshold?: decimal | string;
        reorderingMaximumStock?: decimal | string;
        calculatedReorderingMaximumStock?: decimal | string;
        economicOrderQuantity?: decimal | string;
        calculatedEconomicOrderQuantity?: decimal | string;
        technicalLotQuantity?: decimal | string;
        shrinkagePercentage?: decimal | string;
        planner?: string;
        buyer?: string;
        standardCostUpdate?: PriceUpdateMode;
        revisedStandardCostUpdate?: PriceUpdateMode;
        budgetStandardCostUpdate?: PriceUpdateMode;
        simulatedCostUpdate?: PriceUpdateMode;
        productionRouting?: string;
        costRouting?: string;
        roughCut?: string;
        productionRoutingCode?: integer | string;
        costRoutingCode?: integer | string;
        roughCutCapacityPlanningRoutingCode?: integer | string;
        isReleasedIfShortage?: boolean | string;
        isShrinkedWithRelease?: boolean | string;
        yearOfLastMonthlyUpdate?: integer | string;
        monthOfLastMonthlyUpdate?: integer | string;
        lastAnnualUpdate?: integer | string;
        automaticClosingPercentage?: decimal | string;
        configurationCode?: string;
        storageHandling?: string;
        weighingAccessCode?: string;
        weighingTolerance?: decimal | string;
        productTolerance?: decimal | string;
        valuationMethod?: string;
        prorataQuantityAdjustment?: decimal | string;
        protectionWip?: boolean | string;
        packagingCapacity?: decimal | string;
        stockManagementMode?: StockManagement;
        assignmentRule?: string;
        isStockDetailedInPacking?: boolean | string;
        qualityControlManagementMode?: SubjectToControl;
        qualityControlAccessCode?: string;
        qualityControlFrequency?: integer | string;
        numberOfEntriesSinceLastQualityControl?: integer | string;
        sampling?: SamplingType;
        samplingMode?: SamplingMode;
        samplingGeneralCheckLevel?: GeneralControlLevel;
        samplingAcceptableQualityLevel?: AcceptableQualityLevel;
        qualityControlFrequencyToReview?: integer | string;
        qualityEntriesProcess?: integer | string;
        recontrolLeadTime?: integer | string;
        newStockStatusAfterRecontrol?: string;
        useByDateCoefficient?: decimal | string;
        orderWarehouse?: string;
        workOrderWarehouse?: string;
        shippingWarehouse?: string;
        materialConsumptionsWarehouse?: string;
        internalMovementWarehouse?: string;
        subcontractShipmentWarehouse?: string;
        subcontractConsumptionWarehouse?: string;
        isPackingManaged?: boolean | string;
        freightClass?: string;
        freightCommodityCode?: string;
        isLicensePlateNumberManaged?: boolean | string;
    }
    export interface ProductSiteBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        stockSite: Site;
        isBeingCounted: boolean;
        countWorksheet: string;
        abcClass: ProductAbcClass;
        isLocationManaged: boolean;
        stockWithdrawalMode: StockWithdrawal;
        countManagementMode: Count;
        trendProfile: string;
        numberOfStockCoverageWeeks: integer;
        multilevelLeadTime: string;
        qualityControlLeadTime: string;
        planningFirmHorizon: integer;
        planningFirmHorizonTimeUnit: LeadTimeUnit;
        planningDemandHorizon: integer;
        planningDemandHorizonTimeUnit: LeadTimeUnit;
        reorderLeadTime: string;
        productionLeadTime: string;
        pickingLeadTime: string;
        reductionFactor: integer;
        reorderingPeriodicity: integer;
        reorderingSuggestionType: SuggestionType;
        reorderingSite: Site;
        reorderingPolicy: string;
        safetyStock: string;
        calculatedSafetyStock: string;
        reorderingThreshold: string;
        calculatedReorderingThreshold: string;
        reorderingMaximumStock: string;
        calculatedReorderingMaximumStock: string;
        economicOrderQuantity: string;
        calculatedEconomicOrderQuantity: string;
        technicalLotQuantity: string;
        shrinkagePercentage: string;
        planner: User;
        buyer: User;
        standardCostUpdate: PriceUpdateMode;
        revisedStandardCostUpdate: PriceUpdateMode;
        budgetStandardCostUpdate: PriceUpdateMode;
        simulatedCostUpdate: PriceUpdateMode;
        productionRouting: string;
        costRouting: string;
        roughCut: string;
        productionRoutingCode: BomRouting;
        costRoutingCode: BomRouting;
        roughCutCapacityPlanningRoutingCode: BomRouting;
        isReleasedIfShortage: boolean;
        isShrinkedWithRelease: boolean;
        yearOfLastMonthlyUpdate: integer;
        monthOfLastMonthlyUpdate: integer;
        lastAnnualUpdate: integer;
        automaticClosingPercentage: string;
        configurationCode: string;
        storageHandling: string;
        weighingAccessCode: string;
        weighingTolerance: string;
        productTolerance: string;
        valuationMethod: string;
        prorataQuantityAdjustment: string;
        protectionWip: boolean;
        packagingCapacity: string;
        stockManagementMode: StockManagement;
        assignmentRule: string;
        isStockDetailedInPacking: boolean;
        qualityControlManagementMode: SubjectToControl;
        qualityControlAccessCode: string;
        qualityControlFrequency: integer;
        numberOfEntriesSinceLastQualityControl: integer;
        sampling: SamplingType;
        samplingMode: SamplingMode;
        samplingGeneralCheckLevel: GeneralControlLevel;
        samplingAcceptableQualityLevel: AcceptableQualityLevel;
        qualityControlFrequencyToReview: integer;
        qualityEntriesProcess: integer;
        recontrolLeadTime: integer;
        newStockStatusAfterRecontrol: string;
        useByDateCoefficient: string;
        orderWarehouse: string;
        workOrderWarehouse: string;
        shippingWarehouse: string;
        materialConsumptionsWarehouse: string;
        internalMovementWarehouse: string;
        subcontractShipmentWarehouse: string;
        subcontractConsumptionWarehouse: string;
        isPackingManaged: boolean;
        freightClass: string;
        freightCommodityCode: string;
        isLicensePlateNumberManaged: boolean;
        products: ClientCollection<Product>;
    }
    export interface ProductSite$Lookups {
        product: QueryOperation<Product>;
        stockSite: QueryOperation<Site>;
        reorderingSite: QueryOperation<Site>;
        planner: QueryOperation<User>;
        buyer: QueryOperation<User>;
        productionRoutingCode: QueryOperation<BomRouting>;
        costRoutingCode: QueryOperation<BomRouting>;
        roughCutCapacityPlanningRoutingCode: QueryOperation<BomRouting>;
    }
    export interface ProductSite$Operations {
        query: QueryOperation<ProductSite>;
        read: ReadOperation<ProductSite>;
        aggregate: {
            read: AggregateReadOperation<ProductSite>;
            query: AggregateQueryOperation<ProductSite>;
        };
        lookups(dataOrId: string | { data: ProductSiteInput }): ProductSite$Lookups;
        getDefaults: GetDefaultsOperation<ProductSite>;
    }
    export interface ProductStatisticalGroups extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        statisticalGroup: MiscellaneousTable;
    }
    export interface ProductStatisticalGroupsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        statisticalGroup?: string;
    }
    export interface ProductStatisticalGroupsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        statisticalGroup: MiscellaneousTable;
    }
    export interface ProductStatisticalGroups$Lookups {
        statisticalGroup: QueryOperation<MiscellaneousTable>;
    }
    export interface ProductStatisticalGroups$Operations {
        query: QueryOperation<ProductStatisticalGroups>;
        read: ReadOperation<ProductStatisticalGroups>;
        aggregate: {
            read: AggregateReadOperation<ProductStatisticalGroups>;
            query: AggregateQueryOperation<ProductStatisticalGroups>;
        };
        lookups(dataOrId: string | { data: ProductStatisticalGroupsInput }): ProductStatisticalGroups$Lookups;
        getDefaults: GetDefaultsOperation<ProductStatisticalGroups>;
    }
    export interface ProductVersion extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        majorVersion: string;
        minorVersion: string;
        type: Flow;
        sequence: integer;
        useStatus: UseStatus;
        startDate: string;
        endDate: string;
        isSubjectToException: boolean;
        exceptionDate: string;
    }
    export interface ProductVersionInput extends ClientNodeInput {
        product?: string;
        majorVersion?: string;
        minorVersion?: string;
        type?: Flow;
        sequence?: integer | string;
        useStatus?: UseStatus;
        startDate?: string;
        endDate?: string;
        isSubjectToException?: boolean | string;
        exceptionDate?: string;
    }
    export interface ProductVersionBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        majorVersion: string;
        minorVersion: string;
        type: Flow;
        sequence: integer;
        useStatus: UseStatus;
        startDate: string;
        endDate: string;
        isSubjectToException: boolean;
        exceptionDate: string;
    }
    export interface ProductVersion$Lookups {
        product: QueryOperation<Product>;
    }
    export interface ProductVersion$Operations {
        query: QueryOperation<ProductVersion>;
        read: ReadOperation<ProductVersion>;
        aggregate: {
            read: AggregateReadOperation<ProductVersion>;
            query: AggregateQueryOperation<ProductVersion>;
        };
        lookups(dataOrId: string | { data: ProductVersionInput }): ProductVersion$Lookups;
        getDefaults: GetDefaultsOperation<ProductVersion>;
    }
    export interface Product extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        company: Company;
        productCategory: ProductCategory;
        searchKey: string;
        description1: string;
        description2: string;
        description3: string;
        localizedDescription1: string;
        localizedDescription2: string;
        localizedDescription3: string;
        managementMode: StandardProductCode;
        standard: string;
        upc: string;
        productStatus: ProductStatus;
        isPrototype: boolean;
        defaultPotencyInPercentage: string;
        defaultPotencyInInternationalUnit: string;
        serviceLifeStartDate: string;
        serviceLifeEndDate: string;
        storageSheet: string;
        stockUnit: UnitOfMeasure;
        purchaseUnit: UnitOfMeasure;
        salesUnit: UnitOfMeasure;
        statisticalUnit: UnitOfMeasure;
        eeUnit: UnitOfMeasure;
        purchaseUnitToStockUnitConversionFactor: string;
        isPurchaseFactorEntryAllowed: boolean;
        salesUnitToStockUnitConversionFactor: string;
        isSalesFactorEntryAllowed: boolean;
        statisticalUnitToStockUnitConversionFactor: string;
        eeUnitToStockUnitConversionFactor: string;
        weightUnit: UnitOfMeasure;
        productWeight: string;
        volumeUnit: UnitOfMeasure;
        productVolume: string;
        lotSequenceNumber: string;
        serialSequenceNumber: string;
        serialNumberManagementMode: SerialNumberManagement;
        expirationManagementMode: ExpirationManagement;
        expirationStockStatus: string;
        expirationLeadTime: integer;
        checkLeadTime: integer;
        isNegativeStockAuthorized: boolean;
        costGroup: string;
        userAccessCode: Access;
        alternateProduct: Product;
        isIntrastatDeclarationSubmitted: boolean;
        intrastatCommodity: string;
        purchasingPlanningHorizonTimeUnit: LeadTimeUnit;
        purchasingPlanningHorizon: integer;
        purchasingFirmHorizon: integer;
        purchasingFirmHorizonTimeUnit: LeadTimeUnit;
        buyer: User;
        planner: User;
        reorderLeadTime: integer;
        purchaseBasePrice: string;
        landedCostCoefficient: string;
        fixedLandedCostPerUnit: string;
        purchaseDeliveryTolerance: string;
        isReceived: boolean;
        isMandatoryPurchaseOrderRequest: boolean;
        exemptionFlag: string;
        taxFlagStatusLocal: string;
        configuratorProductLine: string;
        configuratorNumericField1: string;
        configuratorNumericField2: string;
        configuratorNumericField3: string;
        configuratorNumericField4: string;
        configuratorNumericField5: string;
        configuratorNumericField6: string;
        configuratorAlphaField1: string;
        configuratorAlphaField2: string;
        configuratorAlphaField3: string;
        configuratorAlphaField4: string;
        configuratorAlphaField5: string;
        configuratorAlphaField6: string;
        configurationJournal: string;
        configuratorBusinessPartner: BusinessPartner;
        configuratorBusinessPartnerReference: string;
        configuratorReferenceProduct: Product;
        configuratorPurgeDate: string;
        isInstalledBaseCreated: boolean;
        voucherCategory: MiscellaneousTable;
        tokensToBeCredited: integer;
        creditUnit: UnitOfMeasure;
        labelFormatForStockUnit: GenericPrintReport;
        bomCodeForAfterSales: BomCodes;
        productTypeForAfterSales: TypeOfProduct;
        isAfterSalesProductIssuedByDefault: boolean;
        daysUnit: UnitOfMeasure;
        hourUnit: UnitOfMeasure;
        minuteUnit: UnitOfMeasure;
        productDensity: string;
        isPurchased: boolean;
        isManufactured: boolean;
        isSubcontracted: boolean;
        isService: boolean;
        isPhantom: boolean;
        isGeneric: boolean;
        isTools: boolean;
        isDeliverable: boolean;
        isSold: boolean;
        isIntermediary: boolean;
        isCapitalized: boolean;
        newStockStatusAfterRecontrol: string;
        useByDateCoefficient: string;
        intrastatFederalStateOrRegion: MiscellaneousTable;
        plmProductReference: string;
        plmLinkedDocuments: string;
        plmProductHistory: string;
        sageSalesTax: MiscellaneousTable;
        allergens: string;
        allergenChangeDate: string;
        allergenBomCode: integer;
        saftProductType: SafTProductType;
        isVersionManaged: boolean;
        minorVersionSequence: string;
        majorVersionSequence: string;
        isVersionPreloaded: boolean;
        productType: ProductType;
        globalTradeItemNumber: string;
        productSites: ClientCollection<ProductSite>;
        supplierProduct: ClientCollection<SupplierProduct>;
        customerProduct: ClientCollection<CustomerProduct>;
        manufacturingText: TextStream;
        picture: BinaryStream;
        purchasingText: TextStream;
        packingUnits: ClientCollection<ProductPackingUnits>;
        statisticalGroups: ClientCollection<ProductStatisticalGroups>;
    }
    export interface ProductInput extends ClientNodeInput {
        code?: string;
        company?: string;
        productCategory?: string;
        searchKey?: string;
        description1?: string;
        description2?: string;
        description3?: string;
        localizedDescription1?: string;
        localizedDescription2?: string;
        localizedDescription3?: string;
        managementMode?: StandardProductCode;
        standard?: string;
        upc?: string;
        productStatus?: ProductStatus;
        isPrototype?: boolean | string;
        defaultPotencyInPercentage?: decimal | string;
        defaultPotencyInInternationalUnit?: decimal | string;
        serviceLifeStartDate?: string;
        serviceLifeEndDate?: string;
        storageSheet?: string;
        stockUnit?: string;
        purchaseUnit?: string;
        salesUnit?: string;
        statisticalUnit?: string;
        eeUnit?: string;
        purchaseUnitToStockUnitConversionFactor?: decimal | string;
        isPurchaseFactorEntryAllowed?: boolean | string;
        salesUnitToStockUnitConversionFactor?: decimal | string;
        isSalesFactorEntryAllowed?: boolean | string;
        statisticalUnitToStockUnitConversionFactor?: decimal | string;
        eeUnitToStockUnitConversionFactor?: decimal | string;
        weightUnit?: string;
        productWeight?: decimal | string;
        volumeUnit?: string;
        productVolume?: decimal | string;
        lotSequenceNumber?: string;
        serialSequenceNumber?: string;
        serialNumberManagementMode?: SerialNumberManagement;
        expirationManagementMode?: ExpirationManagement;
        expirationStockStatus?: string;
        expirationLeadTime?: integer | string;
        checkLeadTime?: integer | string;
        isNegativeStockAuthorized?: boolean | string;
        costGroup?: string;
        userAccessCode?: string;
        alternateProduct?: string;
        isIntrastatDeclarationSubmitted?: boolean | string;
        intrastatCommodity?: string;
        purchasingPlanningHorizonTimeUnit?: LeadTimeUnit;
        purchasingPlanningHorizon?: integer | string;
        purchasingFirmHorizon?: integer | string;
        purchasingFirmHorizonTimeUnit?: LeadTimeUnit;
        buyer?: string;
        planner?: string;
        reorderLeadTime?: integer | string;
        purchaseBasePrice?: decimal | string;
        landedCostCoefficient?: decimal | string;
        fixedLandedCostPerUnit?: decimal | string;
        purchaseDeliveryTolerance?: decimal | string;
        isReceived?: boolean | string;
        isMandatoryPurchaseOrderRequest?: boolean | string;
        exemptionFlag?: string;
        taxFlagStatusLocal?: string;
        configuratorProductLine?: string;
        configuratorNumericField1?: decimal | string;
        configuratorNumericField2?: decimal | string;
        configuratorNumericField3?: decimal | string;
        configuratorNumericField4?: decimal | string;
        configuratorNumericField5?: decimal | string;
        configuratorNumericField6?: decimal | string;
        configuratorAlphaField1?: string;
        configuratorAlphaField2?: string;
        configuratorAlphaField3?: string;
        configuratorAlphaField4?: string;
        configuratorAlphaField5?: string;
        configuratorAlphaField6?: string;
        configurationJournal?: string;
        configuratorBusinessPartner?: string;
        configuratorBusinessPartnerReference?: string;
        configuratorReferenceProduct?: string;
        configuratorPurgeDate?: string;
        isInstalledBaseCreated?: boolean | string;
        voucherCategory?: string;
        tokensToBeCredited?: integer | string;
        creditUnit?: string;
        labelFormatForStockUnit?: string;
        bomCodeForAfterSales?: integer | string;
        productTypeForAfterSales?: TypeOfProduct;
        isAfterSalesProductIssuedByDefault?: boolean | string;
        daysUnit?: string;
        hourUnit?: string;
        minuteUnit?: string;
        productDensity?: decimal | string;
        isPurchased?: boolean | string;
        isManufactured?: boolean | string;
        isSubcontracted?: boolean | string;
        isService?: boolean | string;
        isPhantom?: boolean | string;
        isGeneric?: boolean | string;
        isTools?: boolean | string;
        isDeliverable?: boolean | string;
        isSold?: boolean | string;
        isIntermediary?: boolean | string;
        isCapitalized?: boolean | string;
        newStockStatusAfterRecontrol?: string;
        useByDateCoefficient?: decimal | string;
        intrastatFederalStateOrRegion?: string;
        plmProductReference?: string;
        plmLinkedDocuments?: string;
        plmProductHistory?: string;
        sageSalesTax?: string;
        allergens?: string;
        allergenChangeDate?: string;
        allergenBomCode?: integer | string;
        saftProductType?: SafTProductType;
        isVersionManaged?: boolean | string;
        minorVersionSequence?: string;
        majorVersionSequence?: string;
        isVersionPreloaded?: boolean | string;
        productType?: ProductType;
        globalTradeItemNumber?: string;
        supplierProduct?: Partial<SupplierProductInput>[];
        customerProduct?: Partial<CustomerProductInput>[];
        manufacturingText?: TextStream;
        picture?: BinaryStream;
        purchasingText?: TextStream;
        packingUnits?: Partial<ProductPackingUnitsInput>[];
        statisticalGroups?: Partial<ProductStatisticalGroupsInput>[];
    }
    export interface ProductBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        company: Company;
        productCategory: ProductCategory;
        searchKey: string;
        description1: string;
        description2: string;
        description3: string;
        localizedDescription1: string;
        localizedDescription2: string;
        localizedDescription3: string;
        managementMode: StandardProductCode;
        standard: string;
        upc: string;
        productStatus: ProductStatus;
        isPrototype: boolean;
        defaultPotencyInPercentage: string;
        defaultPotencyInInternationalUnit: string;
        serviceLifeStartDate: string;
        serviceLifeEndDate: string;
        storageSheet: string;
        stockUnit: UnitOfMeasure;
        purchaseUnit: UnitOfMeasure;
        salesUnit: UnitOfMeasure;
        statisticalUnit: UnitOfMeasure;
        eeUnit: UnitOfMeasure;
        purchaseUnitToStockUnitConversionFactor: string;
        isPurchaseFactorEntryAllowed: boolean;
        salesUnitToStockUnitConversionFactor: string;
        isSalesFactorEntryAllowed: boolean;
        statisticalUnitToStockUnitConversionFactor: string;
        eeUnitToStockUnitConversionFactor: string;
        weightUnit: UnitOfMeasure;
        productWeight: string;
        volumeUnit: UnitOfMeasure;
        productVolume: string;
        lotSequenceNumber: string;
        serialSequenceNumber: string;
        serialNumberManagementMode: SerialNumberManagement;
        expirationManagementMode: ExpirationManagement;
        expirationStockStatus: string;
        expirationLeadTime: integer;
        checkLeadTime: integer;
        isNegativeStockAuthorized: boolean;
        costGroup: string;
        userAccessCode: Access;
        alternateProduct: Product;
        isIntrastatDeclarationSubmitted: boolean;
        intrastatCommodity: string;
        purchasingPlanningHorizonTimeUnit: LeadTimeUnit;
        purchasingPlanningHorizon: integer;
        purchasingFirmHorizon: integer;
        purchasingFirmHorizonTimeUnit: LeadTimeUnit;
        buyer: User;
        planner: User;
        reorderLeadTime: integer;
        purchaseBasePrice: string;
        landedCostCoefficient: string;
        fixedLandedCostPerUnit: string;
        purchaseDeliveryTolerance: string;
        isReceived: boolean;
        isMandatoryPurchaseOrderRequest: boolean;
        exemptionFlag: string;
        taxFlagStatusLocal: string;
        configuratorProductLine: string;
        configuratorNumericField1: string;
        configuratorNumericField2: string;
        configuratorNumericField3: string;
        configuratorNumericField4: string;
        configuratorNumericField5: string;
        configuratorNumericField6: string;
        configuratorAlphaField1: string;
        configuratorAlphaField2: string;
        configuratorAlphaField3: string;
        configuratorAlphaField4: string;
        configuratorAlphaField5: string;
        configuratorAlphaField6: string;
        configurationJournal: string;
        configuratorBusinessPartner: BusinessPartner;
        configuratorBusinessPartnerReference: string;
        configuratorReferenceProduct: Product;
        configuratorPurgeDate: string;
        isInstalledBaseCreated: boolean;
        voucherCategory: MiscellaneousTable;
        tokensToBeCredited: integer;
        creditUnit: UnitOfMeasure;
        labelFormatForStockUnit: GenericPrintReport;
        bomCodeForAfterSales: BomCodes;
        productTypeForAfterSales: TypeOfProduct;
        isAfterSalesProductIssuedByDefault: boolean;
        daysUnit: UnitOfMeasure;
        hourUnit: UnitOfMeasure;
        minuteUnit: UnitOfMeasure;
        productDensity: string;
        isPurchased: boolean;
        isManufactured: boolean;
        isSubcontracted: boolean;
        isService: boolean;
        isPhantom: boolean;
        isGeneric: boolean;
        isTools: boolean;
        isDeliverable: boolean;
        isSold: boolean;
        isIntermediary: boolean;
        isCapitalized: boolean;
        newStockStatusAfterRecontrol: string;
        useByDateCoefficient: string;
        intrastatFederalStateOrRegion: MiscellaneousTable;
        plmProductReference: string;
        plmLinkedDocuments: string;
        plmProductHistory: string;
        sageSalesTax: MiscellaneousTable;
        allergens: string;
        allergenChangeDate: string;
        allergenBomCode: integer;
        saftProductType: SafTProductType;
        isVersionManaged: boolean;
        minorVersionSequence: string;
        majorVersionSequence: string;
        isVersionPreloaded: boolean;
        productType: ProductType;
        globalTradeItemNumber: string;
        productSites: ClientCollection<ProductSite>;
        supplierProduct: ClientCollection<SupplierProduct>;
        customerProduct: ClientCollection<CustomerProduct>;
        manufacturingText: TextStream;
        picture: BinaryStream;
        purchasingText: TextStream;
        packingUnits: ClientCollection<ProductPackingUnitsBinding>;
        statisticalGroups: ClientCollection<ProductStatisticalGroupsBinding>;
    }
    export interface Product$Lookups {
        company: QueryOperation<Company>;
        productCategory: QueryOperation<ProductCategory>;
        stockUnit: QueryOperation<UnitOfMeasure>;
        purchaseUnit: QueryOperation<UnitOfMeasure>;
        salesUnit: QueryOperation<UnitOfMeasure>;
        statisticalUnit: QueryOperation<UnitOfMeasure>;
        eeUnit: QueryOperation<UnitOfMeasure>;
        weightUnit: QueryOperation<UnitOfMeasure>;
        volumeUnit: QueryOperation<UnitOfMeasure>;
        userAccessCode: QueryOperation<Access>;
        alternateProduct: QueryOperation<Product>;
        buyer: QueryOperation<User>;
        planner: QueryOperation<User>;
        configuratorBusinessPartner: QueryOperation<BusinessPartner>;
        configuratorReferenceProduct: QueryOperation<Product>;
        voucherCategory: QueryOperation<MiscellaneousTable>;
        creditUnit: QueryOperation<UnitOfMeasure>;
        labelFormatForStockUnit: QueryOperation<GenericPrintReport>;
        bomCodeForAfterSales: QueryOperation<BomCodes>;
        daysUnit: QueryOperation<UnitOfMeasure>;
        hourUnit: QueryOperation<UnitOfMeasure>;
        minuteUnit: QueryOperation<UnitOfMeasure>;
        intrastatFederalStateOrRegion: QueryOperation<MiscellaneousTable>;
        sageSalesTax: QueryOperation<MiscellaneousTable>;
    }
    export interface Product$Operations {
        query: QueryOperation<Product>;
        read: ReadOperation<Product>;
        aggregate: {
            read: AggregateReadOperation<Product>;
            query: AggregateQueryOperation<Product>;
        };
        lookups(dataOrId: string | { data: ProductInput }): Product$Lookups;
        getDefaults: GetDefaultsOperation<Product>;
    }
    export interface ProspectAddressAddressEmails extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        prospect: string;
        code: string;
        addressEmail: string;
        emailType: EmailAddressType;
    }
    export interface ProspectAddressAddressEmailsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        prospect?: string;
        code?: string;
        addressEmail?: string;
    }
    export interface ProspectAddressAddressEmailsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        prospect: string;
        code: string;
        addressEmail: string;
        emailType: EmailAddressType;
    }
    export interface ProspectAddressAddressEmails$Operations {
        query: QueryOperation<ProspectAddressAddressEmails>;
        read: ReadOperation<ProspectAddressAddressEmails>;
        aggregate: {
            read: AggregateReadOperation<ProspectAddressAddressEmails>;
            query: AggregateQueryOperation<ProspectAddressAddressEmails>;
        };
        getDefaults: GetDefaultsOperation<ProspectAddressAddressEmails>;
    }
    export interface ProspectAddressAddressLines extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        prospect: string;
        code: string;
        addressLine: string;
    }
    export interface ProspectAddressAddressLinesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        prospect?: string;
        code?: string;
        addressLine?: string;
    }
    export interface ProspectAddressAddressLinesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        prospect: string;
        code: string;
        addressLine: string;
    }
    export interface ProspectAddressAddressLines$Operations {
        query: QueryOperation<ProspectAddressAddressLines>;
        read: ReadOperation<ProspectAddressAddressLines>;
        aggregate: {
            read: AggregateReadOperation<ProspectAddressAddressLines>;
            query: AggregateQueryOperation<ProspectAddressAddressLines>;
        };
        getDefaults: GetDefaultsOperation<ProspectAddressAddressLines>;
    }
    export interface ProspectAddressAddressPhoneNumbers extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        prospect: string;
        code: string;
        addressPhoneNumber: string;
        phoneType: TelephoneType;
    }
    export interface ProspectAddressAddressPhoneNumbersInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        prospect?: string;
        code?: string;
        addressPhoneNumber?: string;
    }
    export interface ProspectAddressAddressPhoneNumbersBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        prospect: string;
        code: string;
        addressPhoneNumber: string;
        phoneType: TelephoneType;
    }
    export interface ProspectAddressAddressPhoneNumbers$Operations {
        query: QueryOperation<ProspectAddressAddressPhoneNumbers>;
        read: ReadOperation<ProspectAddressAddressPhoneNumbers>;
        aggregate: {
            read: AggregateReadOperation<ProspectAddressAddressPhoneNumbers>;
            query: AggregateQueryOperation<ProspectAddressAddressPhoneNumbers>;
        };
        getDefaults: GetDefaultsOperation<ProspectAddressAddressPhoneNumbers>;
    }
    export interface ProspectAddress extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        prospect: Prospect;
        code: string;
        description: string;
        isDefault: boolean;
        zipCode: string;
        city: string;
        state: string;
        country: Country;
        countryName: string;
        website: string;
        addressEmails: ClientCollection<ProspectAddressAddressEmails>;
        addressLines: ClientCollection<ProspectAddressAddressLines>;
        addressPhoneNumbers: ClientCollection<ProspectAddressAddressPhoneNumbers>;
    }
    export interface ProspectAddressInput extends ClientNodeInput {
        entityType?: EntityType;
        prospect?: string;
        code?: string;
        description?: string;
        isDefault?: boolean | string;
        zipCode?: string;
        city?: string;
        state?: string;
        country?: string;
        countryName?: string;
        website?: string;
        addressEmails?: Partial<ProspectAddressAddressEmailsInput>[];
        addressLines?: Partial<ProspectAddressAddressLinesInput>[];
        addressPhoneNumbers?: Partial<ProspectAddressAddressPhoneNumbersInput>[];
    }
    export interface ProspectAddressBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        prospect: Prospect;
        code: string;
        description: string;
        isDefault: boolean;
        zipCode: string;
        city: string;
        state: string;
        country: Country;
        countryName: string;
        website: string;
        addressEmails: ClientCollection<ProspectAddressAddressEmailsBinding>;
        addressLines: ClientCollection<ProspectAddressAddressLinesBinding>;
        addressPhoneNumbers: ClientCollection<ProspectAddressAddressPhoneNumbersBinding>;
    }
    export interface ProspectAddress$Lookups {
        prospect: QueryOperation<Prospect>;
        country: QueryOperation<Country>;
    }
    export interface ProspectAddress$Operations {
        query: QueryOperation<ProspectAddress>;
        read: ReadOperation<ProspectAddress>;
        aggregate: {
            read: AggregateReadOperation<ProspectAddress>;
            query: AggregateQueryOperation<ProspectAddress>;
        };
        lookups(dataOrId: string | { data: ProspectAddressInput }): ProspectAddress$Lookups;
        getDefaults: GetDefaultsOperation<ProspectAddress>;
    }
    export interface ProspectContact extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        prospect: Prospect;
        code: ContactRelationship;
        position: FunctionContact;
        department: string;
        role: MiscellaneousTable;
        defaultAddress: string;
        landline: string;
        fax: string;
        email: string;
        cellPhone: string;
        isDataProtectionOfficer: boolean;
        contactRelationship: ContactRelationship;
        addressLines: ClientCollection<ContactRelationshipAddressLines>;
        relationshipCellPhone: string;
        relationshipCity: string;
        relationshipCountry: Country;
        relationshipCountryName: string;
        relationshipDateOfBirth: string;
        relationshipEmail: string;
        relationshipFax: string;
        relationshipFirstName: string;
        relationshipFullNameSearchKey: string;
        relationshipIsMailingProhibited: boolean;
        relationshipLandline: string;
        relationshipLanguage: Language;
        relationshipLastName: string;
        relationshipProfessionalCategory: MiscellaneousTable;
        relationshipState: string;
        relationshipTitle: Title;
        relationshipType: ContactType;
        relationshipZipCode: string;
    }
    export interface ProspectContactInput extends ClientNodeInput {
        entityType?: EntityType;
        prospect?: string;
        code?: string;
        position?: FunctionContact;
        department?: string;
        role?: string;
        defaultAddress?: string;
        landline?: string;
        fax?: string;
        email?: string;
        cellPhone?: string;
        isDataProtectionOfficer?: boolean | string;
        contactRelationship?: string;
        addressLines?: Partial<ContactRelationshipAddressLinesInput>[];
        relationshipCellPhone?: string;
        relationshipCity?: string;
        relationshipCountry?: string;
        relationshipCountryName?: string;
        relationshipDateOfBirth?: string;
        relationshipEmail?: string;
        relationshipFax?: string;
        relationshipFirstName?: string;
        relationshipFullNameSearchKey?: string;
        relationshipIsMailingProhibited?: boolean | string;
        relationshipLandline?: string;
        relationshipLanguage?: string;
        relationshipLastName?: string;
        relationshipProfessionalCategory?: string;
        relationshipState?: string;
        relationshipTitle?: Title;
        relationshipType?: ContactType;
        relationshipZipCode?: string;
    }
    export interface ProspectContactBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        prospect: Prospect;
        code: ContactRelationship;
        position: FunctionContact;
        department: string;
        role: MiscellaneousTable;
        defaultAddress: string;
        landline: string;
        fax: string;
        email: string;
        cellPhone: string;
        isDataProtectionOfficer: boolean;
        contactRelationship: ContactRelationship;
        addressLines: ClientCollection<ContactRelationshipAddressLines>;
        relationshipCellPhone: string;
        relationshipCity: string;
        relationshipCountry: Country;
        relationshipCountryName: string;
        relationshipDateOfBirth: string;
        relationshipEmail: string;
        relationshipFax: string;
        relationshipFirstName: string;
        relationshipFullNameSearchKey: string;
        relationshipIsMailingProhibited: boolean;
        relationshipLandline: string;
        relationshipLanguage: Language;
        relationshipLastName: string;
        relationshipProfessionalCategory: MiscellaneousTable;
        relationshipState: string;
        relationshipTitle: Title;
        relationshipType: ContactType;
        relationshipZipCode: string;
    }
    export interface ProspectContact$Lookups {
        prospect: QueryOperation<Prospect>;
        code: QueryOperation<ContactRelationship>;
        role: QueryOperation<MiscellaneousTable>;
        contactRelationship: QueryOperation<ContactRelationship>;
        relationshipCountry: QueryOperation<Country>;
        relationshipLanguage: QueryOperation<Language>;
        relationshipProfessionalCategory: QueryOperation<MiscellaneousTable>;
    }
    export interface ProspectContact$Operations {
        query: QueryOperation<ProspectContact>;
        read: ReadOperation<ProspectContact>;
        aggregate: {
            read: AggregateReadOperation<ProspectContact>;
            query: AggregateQueryOperation<ProspectContact>;
        };
        lookups(dataOrId: string | { data: ProspectContactInput }): ProspectContact$Lookups;
        getDefaults: GetDefaultsOperation<ProspectContact>;
    }
    export interface ProspectSalesReps extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        salesRep: SalesRep;
    }
    export interface ProspectSalesRepsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        salesRep?: string;
    }
    export interface ProspectSalesRepsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        salesRep: SalesRep;
    }
    export interface ProspectSalesReps$Lookups {
        salesRep: QueryOperation<SalesRep>;
    }
    export interface ProspectSalesReps$Operations {
        query: QueryOperation<ProspectSalesReps>;
        read: ReadOperation<ProspectSalesReps>;
        aggregate: {
            read: AggregateReadOperation<ProspectSalesReps>;
            query: AggregateQueryOperation<ProspectSalesReps>;
        };
        lookups(dataOrId: string | { data: ProspectSalesRepsInput }): ProspectSalesReps$Lookups;
        getDefaults: GetDefaultsOperation<ProspectSalesReps>;
    }
    export interface ProspectStatisticalGroups extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        value: MiscellaneousTable;
    }
    export interface ProspectStatisticalGroupsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        value?: string;
    }
    export interface ProspectStatisticalGroupsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        value: MiscellaneousTable;
    }
    export interface ProspectStatisticalGroups$Lookups {
        value: QueryOperation<MiscellaneousTable>;
    }
    export interface ProspectStatisticalGroups$Operations {
        query: QueryOperation<ProspectStatisticalGroups>;
        read: ReadOperation<ProspectStatisticalGroups>;
        aggregate: {
            read: AggregateReadOperation<ProspectStatisticalGroups>;
            query: AggregateQueryOperation<ProspectStatisticalGroups>;
        };
        lookups(dataOrId: string | { data: ProspectStatisticalGroupsInput }): ProspectStatisticalGroups$Lookups;
        getDefaults: GetDefaultsOperation<ProspectStatisticalGroups>;
    }
    export interface Prospect extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: BusinessPartner;
        customerCategory: CustomerCategory;
        groupCustomer: Customer;
        defaultAddress: ProspectAddress;
        defaultContact: ProspectContact;
        isActive: boolean;
        currency: Currency;
        commissionCategory: CommissionCategory;
        addresses: ClientCollection<ProspectAddress>;
        contacts: ClientCollection<ProspectContact>;
        acronym: string;
        companyName1: string;
        companyName2: string;
        companyNames: ClientCollection<BusinessPartnerCompanyNames>;
        country: Country;
        europeanUnionVatNumber: string;
        fiscalCode: string;
        isMailingProhibited: boolean;
        isPhysicalPerson: boolean;
        language: Language;
        salesReps: ClientCollection<ProspectSalesReps>;
        statisticalGroups: ClientCollection<ProspectStatisticalGroups>;
    }
    export interface ProspectInput extends ClientNodeInput {
        code?: string;
        customerCategory?: string;
        groupCustomer?: string;
        defaultAddress?: string;
        defaultContact?: string;
        isActive?: boolean | string;
        currency?: string;
        commissionCategory?: CommissionCategory;
        addresses?: Partial<ProspectAddressInput>[];
        contacts?: Partial<ProspectContactInput>[];
        acronym?: string;
        companyName1?: string;
        companyName2?: string;
        companyNames?: Partial<BusinessPartnerCompanyNamesInput>[];
        country?: string;
        europeanUnionVatNumber?: string;
        fiscalCode?: string;
        isMailingProhibited?: boolean | string;
        isPhysicalPerson?: boolean | string;
        language?: string;
        salesReps?: Partial<ProspectSalesRepsInput>[];
        statisticalGroups?: Partial<ProspectStatisticalGroupsInput>[];
    }
    export interface ProspectBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: BusinessPartner;
        customerCategory: CustomerCategory;
        groupCustomer: Customer;
        defaultAddress: ProspectAddress;
        defaultContact: ProspectContact;
        isActive: boolean;
        currency: Currency;
        commissionCategory: CommissionCategory;
        addresses: ClientCollection<ProspectAddress>;
        contacts: ClientCollection<ProspectContact>;
        acronym: string;
        companyName1: string;
        companyName2: string;
        companyNames: ClientCollection<BusinessPartnerCompanyNames>;
        country: Country;
        europeanUnionVatNumber: string;
        fiscalCode: string;
        isMailingProhibited: boolean;
        isPhysicalPerson: boolean;
        language: Language;
        salesReps: ClientCollection<ProspectSalesRepsBinding>;
        statisticalGroups: ClientCollection<ProspectStatisticalGroupsBinding>;
    }
    export interface Prospect$Lookups {
        code: QueryOperation<BusinessPartner>;
        customerCategory: QueryOperation<CustomerCategory>;
        groupCustomer: QueryOperation<Customer>;
        defaultAddress: QueryOperation<ProspectAddress>;
        defaultContact: QueryOperation<ProspectContact>;
        currency: QueryOperation<Currency>;
        country: QueryOperation<Country>;
        language: QueryOperation<Language>;
    }
    export interface Prospect$Operations {
        query: QueryOperation<Prospect>;
        read: ReadOperation<Prospect>;
        aggregate: {
            read: AggregateReadOperation<Prospect>;
            query: AggregateQueryOperation<Prospect>;
        };
        lookups(dataOrId: string | { data: ProspectInput }): Prospect$Lookups;
        getDefaults: GetDefaultsOperation<Prospect>;
    }
    export interface SalesRep extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: BusinessPartner;
        name: string;
        businessPartner: BusinessPartner;
    }
    export interface SalesRepInput extends ClientNodeInput {
        code?: string;
        name?: string;
        businessPartner?: string;
    }
    export interface SalesRepBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: BusinessPartner;
        name: string;
        businessPartner: BusinessPartner;
    }
    export interface SalesRep$Lookups {
        code: QueryOperation<BusinessPartner>;
        businessPartner: QueryOperation<BusinessPartner>;
    }
    export interface SalesRep$Operations {
        query: QueryOperation<SalesRep>;
        read: ReadOperation<SalesRep>;
        aggregate: {
            read: AggregateReadOperation<SalesRep>;
            query: AggregateQueryOperation<SalesRep>;
        };
        lookups(dataOrId: string | { data: SalesRepInput }): SalesRep$Lookups;
        getDefaults: GetDefaultsOperation<SalesRep>;
    }
    export interface ShipToCustomerAddressCompanyNames extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        customer: string;
        shipToAddress: string;
        companyName: string;
    }
    export interface ShipToCustomerAddressCompanyNamesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        customer?: string;
        shipToAddress?: string;
        companyName?: string;
    }
    export interface ShipToCustomerAddressCompanyNamesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        customer: string;
        shipToAddress: string;
        companyName: string;
    }
    export interface ShipToCustomerAddressCompanyNames$Operations {
        query: QueryOperation<ShipToCustomerAddressCompanyNames>;
        read: ReadOperation<ShipToCustomerAddressCompanyNames>;
        aggregate: {
            read: AggregateReadOperation<ShipToCustomerAddressCompanyNames>;
            query: AggregateQueryOperation<ShipToCustomerAddressCompanyNames>;
        };
        getDefaults: GetDefaultsOperation<ShipToCustomerAddressCompanyNames>;
    }
    export interface ShipToCustomerAddressSalesReps extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        customer: string;
        shipToAddress: string;
        salesRep: SalesRep;
    }
    export interface ShipToCustomerAddressSalesRepsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        customer?: string;
        shipToAddress?: string;
        salesRep?: string;
    }
    export interface ShipToCustomerAddressSalesRepsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        customer: string;
        shipToAddress: string;
        salesRep: SalesRep;
    }
    export interface ShipToCustomerAddressSalesReps$Lookups {
        salesRep: QueryOperation<SalesRep>;
    }
    export interface ShipToCustomerAddressSalesReps$Operations {
        query: QueryOperation<ShipToCustomerAddressSalesReps>;
        read: ReadOperation<ShipToCustomerAddressSalesReps>;
        aggregate: {
            read: AggregateReadOperation<ShipToCustomerAddressSalesReps>;
            query: AggregateQueryOperation<ShipToCustomerAddressSalesReps>;
        };
        lookups(
            dataOrId: string | { data: ShipToCustomerAddressSalesRepsInput },
        ): ShipToCustomerAddressSalesReps$Lookups;
        getDefaults: GetDefaultsOperation<ShipToCustomerAddressSalesReps>;
    }
    export interface ShipToCustomerAddress extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        customer: Customer;
        shipToAddress: CustomerAddress;
        company: Company;
        isActive: boolean;
        shippingSite: Site;
        receiptSite: Site;
        language: Language;
        carrier: Carrier;
        incoterm: Incoterm;
        intrastatTransportLocation: CountryLocation;
        deliveryLeadTime: integer;
        isMondayWorkday: boolean;
        isTuesdayWorkday: boolean;
        isWednesdayWorkday: boolean;
        isThursdayWorkday: boolean;
        isFridayWorkday: boolean;
        isSaturdayWorkday: boolean;
        isSundayWorkday: boolean;
        unavailablePeriod: UnavailablePeriods;
        intrastatIncreaseCoefficient: string;
        europeanUnionVatNumber: string;
        incotermTown: string;
        forwardingAgent: Carrier;
        forwardingAgentAddress: Address;
        geographicCode: string;
        insideCityLimits: string;
        taxExemptionNumber: string;
        exemptionFlag: string;
        mustPrintPickTicket: boolean;
        mustPrintPackingSlip: boolean;
        entityUse: MiscellaneousTable;
        deliveryHeaderText: TextStream;
        pickingHeaderText: TextStream;
        companyNames: ClientCollection<ShipToCustomerAddressCompanyNames>;
        salesReps: ClientCollection<ShipToCustomerAddressSalesReps>;
    }
    export interface ShipToCustomerAddressInput extends ClientNodeInput {
        customer?: string;
        shipToAddress?: string;
        company?: string;
        isActive?: boolean | string;
        shippingSite?: string;
        receiptSite?: string;
        language?: string;
        carrier?: string;
        incoterm?: string;
        intrastatTransportLocation?: CountryLocation;
        deliveryLeadTime?: integer | string;
        isMondayWorkday?: boolean | string;
        isTuesdayWorkday?: boolean | string;
        isWednesdayWorkday?: boolean | string;
        isThursdayWorkday?: boolean | string;
        isFridayWorkday?: boolean | string;
        isSaturdayWorkday?: boolean | string;
        isSundayWorkday?: boolean | string;
        unavailablePeriod?: string;
        intrastatIncreaseCoefficient?: decimal | string;
        europeanUnionVatNumber?: string;
        incotermTown?: string;
        forwardingAgent?: string;
        forwardingAgentAddress?: string;
        geographicCode?: string;
        insideCityLimits?: string;
        taxExemptionNumber?: string;
        exemptionFlag?: string;
        mustPrintPickTicket?: boolean | string;
        mustPrintPackingSlip?: boolean | string;
        entityUse?: string;
        deliveryHeaderText?: TextStream;
        pickingHeaderText?: TextStream;
        companyNames?: Partial<ShipToCustomerAddressCompanyNamesInput>[];
        salesReps?: Partial<ShipToCustomerAddressSalesRepsInput>[];
    }
    export interface ShipToCustomerAddressBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        customer: Customer;
        shipToAddress: CustomerAddress;
        company: Company;
        isActive: boolean;
        shippingSite: Site;
        receiptSite: Site;
        language: Language;
        carrier: Carrier;
        incoterm: Incoterm;
        intrastatTransportLocation: CountryLocation;
        deliveryLeadTime: integer;
        isMondayWorkday: boolean;
        isTuesdayWorkday: boolean;
        isWednesdayWorkday: boolean;
        isThursdayWorkday: boolean;
        isFridayWorkday: boolean;
        isSaturdayWorkday: boolean;
        isSundayWorkday: boolean;
        unavailablePeriod: UnavailablePeriods;
        intrastatIncreaseCoefficient: string;
        europeanUnionVatNumber: string;
        incotermTown: string;
        forwardingAgent: Carrier;
        forwardingAgentAddress: Address;
        geographicCode: string;
        insideCityLimits: string;
        taxExemptionNumber: string;
        exemptionFlag: string;
        mustPrintPickTicket: boolean;
        mustPrintPackingSlip: boolean;
        entityUse: MiscellaneousTable;
        deliveryHeaderText: TextStream;
        pickingHeaderText: TextStream;
        companyNames: ClientCollection<ShipToCustomerAddressCompanyNamesBinding>;
        salesReps: ClientCollection<ShipToCustomerAddressSalesRepsBinding>;
    }
    export interface ShipToCustomerAddress$Lookups {
        customer: QueryOperation<Customer>;
        shipToAddress: QueryOperation<CustomerAddress>;
        company: QueryOperation<Company>;
        shippingSite: QueryOperation<Site>;
        receiptSite: QueryOperation<Site>;
        language: QueryOperation<Language>;
        carrier: QueryOperation<Carrier>;
        incoterm: QueryOperation<Incoterm>;
        unavailablePeriod: QueryOperation<UnavailablePeriods>;
        forwardingAgent: QueryOperation<Carrier>;
        forwardingAgentAddress: QueryOperation<Address>;
        entityUse: QueryOperation<MiscellaneousTable>;
    }
    export interface ShipToCustomerAddress$Operations {
        query: QueryOperation<ShipToCustomerAddress>;
        read: ReadOperation<ShipToCustomerAddress>;
        aggregate: {
            read: AggregateReadOperation<ShipToCustomerAddress>;
            query: AggregateQueryOperation<ShipToCustomerAddress>;
        };
        lookups(dataOrId: string | { data: ShipToCustomerAddressInput }): ShipToCustomerAddress$Lookups;
        getDefaults: GetDefaultsOperation<ShipToCustomerAddress>;
    }
    export interface SiteAddressAddressEmails extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        site: string;
        code: string;
        addressEmail: string;
        emailType: EmailAddressType;
    }
    export interface SiteAddressAddressEmailsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        site?: string;
        code?: string;
        addressEmail?: string;
    }
    export interface SiteAddressAddressEmailsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        site: string;
        code: string;
        addressEmail: string;
        emailType: EmailAddressType;
    }
    export interface SiteAddressAddressEmails$Operations {
        query: QueryOperation<SiteAddressAddressEmails>;
        read: ReadOperation<SiteAddressAddressEmails>;
        aggregate: {
            read: AggregateReadOperation<SiteAddressAddressEmails>;
            query: AggregateQueryOperation<SiteAddressAddressEmails>;
        };
        getDefaults: GetDefaultsOperation<SiteAddressAddressEmails>;
    }
    export interface SiteAddressAddressLines extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        site: string;
        code: string;
        addressLine: string;
    }
    export interface SiteAddressAddressLinesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        site?: string;
        code?: string;
        addressLine?: string;
    }
    export interface SiteAddressAddressLinesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        site: string;
        code: string;
        addressLine: string;
    }
    export interface SiteAddressAddressLines$Operations {
        query: QueryOperation<SiteAddressAddressLines>;
        read: ReadOperation<SiteAddressAddressLines>;
        aggregate: {
            read: AggregateReadOperation<SiteAddressAddressLines>;
            query: AggregateQueryOperation<SiteAddressAddressLines>;
        };
        getDefaults: GetDefaultsOperation<SiteAddressAddressLines>;
    }
    export interface SiteAddressAddressPhoneNumbers extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        site: string;
        code: string;
        addressPhoneNumber: string;
        phoneType: TelephoneType;
    }
    export interface SiteAddressAddressPhoneNumbersInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        site?: string;
        code?: string;
        addressPhoneNumber?: string;
    }
    export interface SiteAddressAddressPhoneNumbersBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        site: string;
        code: string;
        addressPhoneNumber: string;
        phoneType: TelephoneType;
    }
    export interface SiteAddressAddressPhoneNumbers$Operations {
        query: QueryOperation<SiteAddressAddressPhoneNumbers>;
        read: ReadOperation<SiteAddressAddressPhoneNumbers>;
        aggregate: {
            read: AggregateReadOperation<SiteAddressAddressPhoneNumbers>;
            query: AggregateQueryOperation<SiteAddressAddressPhoneNumbers>;
        };
        getDefaults: GetDefaultsOperation<SiteAddressAddressPhoneNumbers>;
    }
    export interface SiteAddress extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        site: Site;
        code: string;
        description: string;
        defaultBankId: SiteBankDetail;
        isDefault: boolean;
        zipCode: string;
        city: string;
        state: string;
        country: Country;
        countryName: string;
        website: string;
        externalIdentifier: string;
        isValid: boolean;
        addressEmails: ClientCollection<SiteAddressAddressEmails>;
        addressLines: ClientCollection<SiteAddressAddressLines>;
        addressPhoneNumbers: ClientCollection<SiteAddressAddressPhoneNumbers>;
    }
    export interface SiteAddressInput extends ClientNodeInput {
        entityType?: EntityType;
        site?: string;
        code?: string;
        description?: string;
        defaultBankId?: string;
        isDefault?: boolean | string;
        zipCode?: string;
        city?: string;
        state?: string;
        country?: string;
        countryName?: string;
        website?: string;
        externalIdentifier?: string;
        isValid?: boolean | string;
        addressEmails?: Partial<SiteAddressAddressEmailsInput>[];
        addressLines?: Partial<SiteAddressAddressLinesInput>[];
        addressPhoneNumbers?: Partial<SiteAddressAddressPhoneNumbersInput>[];
    }
    export interface SiteAddressBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        site: Site;
        code: string;
        description: string;
        defaultBankId: SiteBankDetail;
        isDefault: boolean;
        zipCode: string;
        city: string;
        state: string;
        country: Country;
        countryName: string;
        website: string;
        externalIdentifier: string;
        isValid: boolean;
        addressEmails: ClientCollection<SiteAddressAddressEmailsBinding>;
        addressLines: ClientCollection<SiteAddressAddressLinesBinding>;
        addressPhoneNumbers: ClientCollection<SiteAddressAddressPhoneNumbersBinding>;
    }
    export interface SiteAddress$Lookups {
        site: QueryOperation<Site>;
        defaultBankId: QueryOperation<SiteBankDetail>;
        country: QueryOperation<Country>;
    }
    export interface SiteAddress$Operations {
        query: QueryOperation<SiteAddress>;
        read: ReadOperation<SiteAddress>;
        aggregate: {
            read: AggregateReadOperation<SiteAddress>;
            query: AggregateQueryOperation<SiteAddress>;
        };
        lookups(dataOrId: string | { data: SiteAddressInput }): SiteAddress$Lookups;
        getDefaults: GetDefaultsOperation<SiteAddress>;
    }
    export interface SiteBankDetail extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        site: Site;
        bankId: string;
        address: SiteAddress;
        byDefault: boolean;
        beneficiary: string;
        payingBank1: string;
        payingBank2: string;
        payingBank3: string;
        payingBank4: string;
        ibanPrefix: string;
        bic: string;
        country: Country;
        currency: Currency;
        intermediaryBankName: string;
        intermediaryBankAddress1: string;
        intermediaryBankAddress2: string;
        intermediaryBankAddress3: string;
        intermediaryBankBic: string;
        intermediaryBankCountry: Country;
        nonResidentAccount: boolean;
        isrCustomerNumber: string;
    }
    export interface SiteBankDetailInput extends ClientNodeInput {
        entityType?: EntityType;
        site?: string;
        bankId?: string;
        address?: string;
        byDefault?: boolean | string;
        beneficiary?: string;
        payingBank1?: string;
        payingBank2?: string;
        payingBank3?: string;
        payingBank4?: string;
        ibanPrefix?: string;
        bic?: string;
        country?: string;
        currency?: string;
        intermediaryBankName?: string;
        intermediaryBankAddress1?: string;
        intermediaryBankAddress2?: string;
        intermediaryBankAddress3?: string;
        intermediaryBankBic?: string;
        intermediaryBankCountry?: string;
        nonResidentAccount?: boolean | string;
        isrCustomerNumber?: string;
    }
    export interface SiteBankDetailBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        site: Site;
        bankId: string;
        address: SiteAddress;
        byDefault: boolean;
        beneficiary: string;
        payingBank1: string;
        payingBank2: string;
        payingBank3: string;
        payingBank4: string;
        ibanPrefix: string;
        bic: string;
        country: Country;
        currency: Currency;
        intermediaryBankName: string;
        intermediaryBankAddress1: string;
        intermediaryBankAddress2: string;
        intermediaryBankAddress3: string;
        intermediaryBankBic: string;
        intermediaryBankCountry: Country;
        nonResidentAccount: boolean;
        isrCustomerNumber: string;
    }
    export interface SiteBankDetail$Lookups {
        site: QueryOperation<Site>;
        address: QueryOperation<SiteAddress>;
        country: QueryOperation<Country>;
        currency: QueryOperation<Currency>;
        intermediaryBankCountry: QueryOperation<Country>;
    }
    export interface SiteBankDetail$Operations {
        query: QueryOperation<SiteBankDetail>;
        read: ReadOperation<SiteBankDetail>;
        aggregate: {
            read: AggregateReadOperation<SiteBankDetail>;
            query: AggregateQueryOperation<SiteBankDetail>;
        };
        lookups(dataOrId: string | { data: SiteBankDetailInput }): SiteBankDetail$Lookups;
        getDefaults: GetDefaultsOperation<SiteBankDetail>;
    }
    export interface SiteContact extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        site: Site;
        code: ContactRelationship;
        position: FunctionContact;
        department: string;
        role: MiscellaneousTable;
        defaultAddress: string;
        landline: string;
        fax: string;
        email: string;
        cellPhone: string;
        isDataProtectionOfficer: boolean;
        contactRelationship: ContactRelationship;
        addressLines: ClientCollection<ContactRelationshipAddressLines>;
        relationshipCellPhone: string;
        relationshipCity: string;
        relationshipCountry: Country;
        relationshipCountryName: string;
        relationshipDateOfBirth: string;
        relationshipEmail: string;
        relationshipFax: string;
        relationshipFirstName: string;
        relationshipFullNameSearchKey: string;
        relationshipIsMailingProhibited: boolean;
        relationshipLandline: string;
        relationshipLanguage: Language;
        relationshipLastName: string;
        relationshipProfessionalCategory: MiscellaneousTable;
        relationshipState: string;
        relationshipTitle: Title;
        relationshipType: ContactType;
        relationshipZipCode: string;
    }
    export interface SiteContactInput extends ClientNodeInput {
        entityType?: EntityType;
        site?: string;
        code?: string;
        position?: FunctionContact;
        department?: string;
        role?: string;
        defaultAddress?: string;
        landline?: string;
        fax?: string;
        email?: string;
        cellPhone?: string;
        isDataProtectionOfficer?: boolean | string;
        contactRelationship?: string;
        addressLines?: Partial<ContactRelationshipAddressLinesInput>[];
        relationshipCellPhone?: string;
        relationshipCity?: string;
        relationshipCountry?: string;
        relationshipCountryName?: string;
        relationshipDateOfBirth?: string;
        relationshipEmail?: string;
        relationshipFax?: string;
        relationshipFirstName?: string;
        relationshipFullNameSearchKey?: string;
        relationshipIsMailingProhibited?: boolean | string;
        relationshipLandline?: string;
        relationshipLanguage?: string;
        relationshipLastName?: string;
        relationshipProfessionalCategory?: string;
        relationshipState?: string;
        relationshipTitle?: Title;
        relationshipType?: ContactType;
        relationshipZipCode?: string;
    }
    export interface SiteContactBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        site: Site;
        code: ContactRelationship;
        position: FunctionContact;
        department: string;
        role: MiscellaneousTable;
        defaultAddress: string;
        landline: string;
        fax: string;
        email: string;
        cellPhone: string;
        isDataProtectionOfficer: boolean;
        contactRelationship: ContactRelationship;
        addressLines: ClientCollection<ContactRelationshipAddressLines>;
        relationshipCellPhone: string;
        relationshipCity: string;
        relationshipCountry: Country;
        relationshipCountryName: string;
        relationshipDateOfBirth: string;
        relationshipEmail: string;
        relationshipFax: string;
        relationshipFirstName: string;
        relationshipFullNameSearchKey: string;
        relationshipIsMailingProhibited: boolean;
        relationshipLandline: string;
        relationshipLanguage: Language;
        relationshipLastName: string;
        relationshipProfessionalCategory: MiscellaneousTable;
        relationshipState: string;
        relationshipTitle: Title;
        relationshipType: ContactType;
        relationshipZipCode: string;
    }
    export interface SiteContact$Lookups {
        site: QueryOperation<Site>;
        code: QueryOperation<ContactRelationship>;
        role: QueryOperation<MiscellaneousTable>;
        contactRelationship: QueryOperation<ContactRelationship>;
        relationshipCountry: QueryOperation<Country>;
        relationshipLanguage: QueryOperation<Language>;
        relationshipProfessionalCategory: QueryOperation<MiscellaneousTable>;
    }
    export interface SiteContact$Operations {
        query: QueryOperation<SiteContact>;
        read: ReadOperation<SiteContact>;
        aggregate: {
            read: AggregateReadOperation<SiteContact>;
            query: AggregateQueryOperation<SiteContact>;
        };
        lookups(dataOrId: string | { data: SiteContactInput }): SiteContact$Lookups;
        getDefaults: GetDefaultsOperation<SiteContact>;
    }
    export interface SupplierAddressAddressEmails extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        supplier: string;
        code: string;
        addressEmail: string;
        emailType: EmailAddressType;
    }
    export interface SupplierAddressAddressEmailsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        supplier?: string;
        code?: string;
        addressEmail?: string;
    }
    export interface SupplierAddressAddressEmailsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        supplier: string;
        code: string;
        addressEmail: string;
        emailType: EmailAddressType;
    }
    export interface SupplierAddressAddressEmails$Operations {
        query: QueryOperation<SupplierAddressAddressEmails>;
        read: ReadOperation<SupplierAddressAddressEmails>;
        aggregate: {
            read: AggregateReadOperation<SupplierAddressAddressEmails>;
            query: AggregateQueryOperation<SupplierAddressAddressEmails>;
        };
        getDefaults: GetDefaultsOperation<SupplierAddressAddressEmails>;
    }
    export interface SupplierAddressAddressLines extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        supplier: string;
        code: string;
        addressLine: string;
    }
    export interface SupplierAddressAddressLinesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        supplier?: string;
        code?: string;
        addressLine?: string;
    }
    export interface SupplierAddressAddressLinesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        supplier: string;
        code: string;
        addressLine: string;
    }
    export interface SupplierAddressAddressLines$Operations {
        query: QueryOperation<SupplierAddressAddressLines>;
        read: ReadOperation<SupplierAddressAddressLines>;
        aggregate: {
            read: AggregateReadOperation<SupplierAddressAddressLines>;
            query: AggregateQueryOperation<SupplierAddressAddressLines>;
        };
        getDefaults: GetDefaultsOperation<SupplierAddressAddressLines>;
    }
    export interface SupplierAddressAddressPhoneNumbers extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        supplier: string;
        code: string;
        addressPhoneNumber: string;
        phoneType: TelephoneType;
    }
    export interface SupplierAddressAddressPhoneNumbersInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        supplier?: string;
        code?: string;
        addressPhoneNumber?: string;
    }
    export interface SupplierAddressAddressPhoneNumbersBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        supplier: string;
        code: string;
        addressPhoneNumber: string;
        phoneType: TelephoneType;
    }
    export interface SupplierAddressAddressPhoneNumbers$Operations {
        query: QueryOperation<SupplierAddressAddressPhoneNumbers>;
        read: ReadOperation<SupplierAddressAddressPhoneNumbers>;
        aggregate: {
            read: AggregateReadOperation<SupplierAddressAddressPhoneNumbers>;
            query: AggregateQueryOperation<SupplierAddressAddressPhoneNumbers>;
        };
        getDefaults: GetDefaultsOperation<SupplierAddressAddressPhoneNumbers>;
    }
    export interface SupplierAddress extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        supplier: Supplier;
        code: string;
        description: string;
        defaultBankId: SupplierBankDetail;
        isDefault: boolean;
        zipCode: string;
        city: string;
        state: string;
        country: Country;
        countryName: string;
        website: string;
        externalIdentifier: string;
        isValid: boolean;
        addressEmails: ClientCollection<SupplierAddressAddressEmails>;
        addressLines: ClientCollection<SupplierAddressAddressLines>;
        addressPhoneNumbers: ClientCollection<SupplierAddressAddressPhoneNumbers>;
    }
    export interface SupplierAddressInput extends ClientNodeInput {
        entityType?: EntityType;
        supplier?: string;
        code?: string;
        description?: string;
        defaultBankId?: string;
        isDefault?: boolean | string;
        zipCode?: string;
        city?: string;
        state?: string;
        country?: string;
        countryName?: string;
        website?: string;
        externalIdentifier?: string;
        isValid?: boolean | string;
        addressEmails?: Partial<SupplierAddressAddressEmailsInput>[];
        addressLines?: Partial<SupplierAddressAddressLinesInput>[];
        addressPhoneNumbers?: Partial<SupplierAddressAddressPhoneNumbersInput>[];
    }
    export interface SupplierAddressBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        supplier: Supplier;
        code: string;
        description: string;
        defaultBankId: SupplierBankDetail;
        isDefault: boolean;
        zipCode: string;
        city: string;
        state: string;
        country: Country;
        countryName: string;
        website: string;
        externalIdentifier: string;
        isValid: boolean;
        addressEmails: ClientCollection<SupplierAddressAddressEmailsBinding>;
        addressLines: ClientCollection<SupplierAddressAddressLinesBinding>;
        addressPhoneNumbers: ClientCollection<SupplierAddressAddressPhoneNumbersBinding>;
    }
    export interface SupplierAddress$Lookups {
        supplier: QueryOperation<Supplier>;
        defaultBankId: QueryOperation<SupplierBankDetail>;
        country: QueryOperation<Country>;
    }
    export interface SupplierAddress$Operations {
        query: QueryOperation<SupplierAddress>;
        read: ReadOperation<SupplierAddress>;
        aggregate: {
            read: AggregateReadOperation<SupplierAddress>;
            query: AggregateQueryOperation<SupplierAddress>;
        };
        lookups(dataOrId: string | { data: SupplierAddressInput }): SupplierAddress$Lookups;
        getDefaults: GetDefaultsOperation<SupplierAddress>;
    }
    export interface SupplierBankDetail extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        supplier: Supplier;
        bankId: string;
        address: SupplierAddress;
        byDefault: boolean;
        beneficiary: string;
        payingBank1: string;
        payingBank2: string;
        payingBank3: string;
        payingBank4: string;
        ibanPrefix: string;
        bic: string;
        country: Country;
        currency: Currency;
        intermediaryBankName: string;
        intermediaryBankAddress1: string;
        intermediaryBankAddress2: string;
        intermediaryBankAddress3: string;
        intermediaryBankBic: string;
        intermediaryBankCountry: Country;
        nonResidentAccount: boolean;
        isrCustomerNumber: string;
    }
    export interface SupplierBankDetailInput extends ClientNodeInput {
        entityType?: EntityType;
        supplier?: string;
        bankId?: string;
        address?: string;
        byDefault?: boolean | string;
        beneficiary?: string;
        payingBank1?: string;
        payingBank2?: string;
        payingBank3?: string;
        payingBank4?: string;
        ibanPrefix?: string;
        bic?: string;
        country?: string;
        currency?: string;
        intermediaryBankName?: string;
        intermediaryBankAddress1?: string;
        intermediaryBankAddress2?: string;
        intermediaryBankAddress3?: string;
        intermediaryBankBic?: string;
        intermediaryBankCountry?: string;
        nonResidentAccount?: boolean | string;
        isrCustomerNumber?: string;
    }
    export interface SupplierBankDetailBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        supplier: Supplier;
        bankId: string;
        address: SupplierAddress;
        byDefault: boolean;
        beneficiary: string;
        payingBank1: string;
        payingBank2: string;
        payingBank3: string;
        payingBank4: string;
        ibanPrefix: string;
        bic: string;
        country: Country;
        currency: Currency;
        intermediaryBankName: string;
        intermediaryBankAddress1: string;
        intermediaryBankAddress2: string;
        intermediaryBankAddress3: string;
        intermediaryBankBic: string;
        intermediaryBankCountry: Country;
        nonResidentAccount: boolean;
        isrCustomerNumber: string;
    }
    export interface SupplierBankDetail$Lookups {
        supplier: QueryOperation<Supplier>;
        address: QueryOperation<SupplierAddress>;
        country: QueryOperation<Country>;
        currency: QueryOperation<Currency>;
        intermediaryBankCountry: QueryOperation<Country>;
    }
    export interface SupplierBankDetail$Operations {
        query: QueryOperation<SupplierBankDetail>;
        read: ReadOperation<SupplierBankDetail>;
        aggregate: {
            read: AggregateReadOperation<SupplierBankDetail>;
            query: AggregateQueryOperation<SupplierBankDetail>;
        };
        lookups(dataOrId: string | { data: SupplierBankDetailInput }): SupplierBankDetail$Lookups;
        getDefaults: GetDefaultsOperation<SupplierBankDetail>;
    }
    export interface SupplierCategory extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        currency: Currency;
    }
    export interface SupplierCategoryInput extends ClientNodeInput {
        code?: string;
        description?: string;
        currency?: string;
    }
    export interface SupplierCategoryBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        currency: Currency;
    }
    export interface SupplierCategory$Lookups {
        currency: QueryOperation<Currency>;
    }
    export interface SupplierCategory$Operations {
        query: QueryOperation<SupplierCategory>;
        read: ReadOperation<SupplierCategory>;
        aggregate: {
            read: AggregateReadOperation<SupplierCategory>;
            query: AggregateQueryOperation<SupplierCategory>;
        };
        lookups(dataOrId: string | { data: SupplierCategoryInput }): SupplierCategory$Lookups;
        getDefaults: GetDefaultsOperation<SupplierCategory>;
    }
    export interface SupplierContact extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        supplier: Supplier;
        code: ContactRelationship;
        position: FunctionContact;
        department: string;
        role: MiscellaneousTable;
        defaultAddress: string;
        landline: string;
        fax: string;
        email: string;
        cellPhone: string;
        isDataProtectionOfficer: boolean;
        contactRelationship: ContactRelationship;
        addressLines: ClientCollection<ContactRelationshipAddressLines>;
        relationshipCellPhone: string;
        relationshipCity: string;
        relationshipCountry: Country;
        relationshipCountryName: string;
        relationshipDateOfBirth: string;
        relationshipEmail: string;
        relationshipFax: string;
        relationshipFirstName: string;
        relationshipFullNameSearchKey: string;
        relationshipIsMailingProhibited: boolean;
        relationshipLandline: string;
        relationshipLanguage: Language;
        relationshipLastName: string;
        relationshipProfessionalCategory: MiscellaneousTable;
        relationshipState: string;
        relationshipTitle: Title;
        relationshipType: ContactType;
        relationshipZipCode: string;
    }
    export interface SupplierContactInput extends ClientNodeInput {
        entityType?: EntityType;
        supplier?: string;
        code?: string;
        position?: FunctionContact;
        department?: string;
        role?: string;
        defaultAddress?: string;
        landline?: string;
        fax?: string;
        email?: string;
        cellPhone?: string;
        isDataProtectionOfficer?: boolean | string;
        contactRelationship?: string;
        addressLines?: Partial<ContactRelationshipAddressLinesInput>[];
        relationshipCellPhone?: string;
        relationshipCity?: string;
        relationshipCountry?: string;
        relationshipCountryName?: string;
        relationshipDateOfBirth?: string;
        relationshipEmail?: string;
        relationshipFax?: string;
        relationshipFirstName?: string;
        relationshipFullNameSearchKey?: string;
        relationshipIsMailingProhibited?: boolean | string;
        relationshipLandline?: string;
        relationshipLanguage?: string;
        relationshipLastName?: string;
        relationshipProfessionalCategory?: string;
        relationshipState?: string;
        relationshipTitle?: Title;
        relationshipType?: ContactType;
        relationshipZipCode?: string;
    }
    export interface SupplierContactBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        supplier: Supplier;
        code: ContactRelationship;
        position: FunctionContact;
        department: string;
        role: MiscellaneousTable;
        defaultAddress: string;
        landline: string;
        fax: string;
        email: string;
        cellPhone: string;
        isDataProtectionOfficer: boolean;
        contactRelationship: ContactRelationship;
        addressLines: ClientCollection<ContactRelationshipAddressLines>;
        relationshipCellPhone: string;
        relationshipCity: string;
        relationshipCountry: Country;
        relationshipCountryName: string;
        relationshipDateOfBirth: string;
        relationshipEmail: string;
        relationshipFax: string;
        relationshipFirstName: string;
        relationshipFullNameSearchKey: string;
        relationshipIsMailingProhibited: boolean;
        relationshipLandline: string;
        relationshipLanguage: Language;
        relationshipLastName: string;
        relationshipProfessionalCategory: MiscellaneousTable;
        relationshipState: string;
        relationshipTitle: Title;
        relationshipType: ContactType;
        relationshipZipCode: string;
    }
    export interface SupplierContact$Lookups {
        supplier: QueryOperation<Supplier>;
        code: QueryOperation<ContactRelationship>;
        role: QueryOperation<MiscellaneousTable>;
        contactRelationship: QueryOperation<ContactRelationship>;
        relationshipCountry: QueryOperation<Country>;
        relationshipLanguage: QueryOperation<Language>;
        relationshipProfessionalCategory: QueryOperation<MiscellaneousTable>;
    }
    export interface SupplierContact$Operations {
        query: QueryOperation<SupplierContact>;
        read: ReadOperation<SupplierContact>;
        aggregate: {
            read: AggregateReadOperation<SupplierContact>;
            query: AggregateQueryOperation<SupplierContact>;
        };
        lookups(dataOrId: string | { data: SupplierContactInput }): SupplierContact$Lookups;
        getDefaults: GetDefaultsOperation<SupplierContact>;
    }
    export interface SupplierProduct extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        supplier: BusinessPartner;
        priority: integer;
        supplierProduct: string;
        supplierProductDescription: string;
        supplierUpc: string;
        purchaseUnit: UnitOfMeasure;
        purchaseUnitToStockUnitConversionFactor: string;
        packingUnit: UnitOfMeasure;
        packingUnitToPurchaseUnitConversionFactor: string;
        euStatisticsIncrease: string;
        minimumPurchaseQuantity: string;
        landingCostCoefficient: string;
        fixedCostPerUnit: string;
        qualityRank: integer;
        qualityControlManagementMode: SubjectToControl;
        isBackToBackOrder: boolean;
        configurationJournal: string;
        subcontractLeadTime: integer;
        qualityControlFrequency: integer;
        qualityControlNumberEntries: integer;
        qualityProcessIdFrequency: integer;
        qualityProcessIdEntries: integer;
        isVersionPreloaded: boolean;
        text1004082: boolean;
        text1004085: boolean;
        purchasingText: TextStream;
    }
    export interface SupplierProductInput extends ClientNodeInput {
        product?: string;
        supplier?: string;
        priority?: integer | string;
        supplierProduct?: string;
        supplierProductDescription?: string;
        supplierUpc?: string;
        purchaseUnit?: string;
        purchaseUnitToStockUnitConversionFactor?: decimal | string;
        packingUnit?: string;
        packingUnitToPurchaseUnitConversionFactor?: decimal | string;
        euStatisticsIncrease?: decimal | string;
        minimumPurchaseQuantity?: decimal | string;
        landingCostCoefficient?: decimal | string;
        fixedCostPerUnit?: decimal | string;
        qualityRank?: integer | string;
        qualityControlManagementMode?: SubjectToControl;
        isBackToBackOrder?: boolean | string;
        configurationJournal?: string;
        subcontractLeadTime?: integer | string;
        qualityControlFrequency?: integer | string;
        qualityControlNumberEntries?: integer | string;
        qualityProcessIdFrequency?: integer | string;
        qualityProcessIdEntries?: integer | string;
        isVersionPreloaded?: boolean | string;
        text1004082?: boolean | string;
        text1004085?: boolean | string;
        purchasingText?: TextStream;
    }
    export interface SupplierProductBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        product: Product;
        supplier: BusinessPartner;
        priority: integer;
        supplierProduct: string;
        supplierProductDescription: string;
        supplierUpc: string;
        purchaseUnit: UnitOfMeasure;
        purchaseUnitToStockUnitConversionFactor: string;
        packingUnit: UnitOfMeasure;
        packingUnitToPurchaseUnitConversionFactor: string;
        euStatisticsIncrease: string;
        minimumPurchaseQuantity: string;
        landingCostCoefficient: string;
        fixedCostPerUnit: string;
        qualityRank: integer;
        qualityControlManagementMode: SubjectToControl;
        isBackToBackOrder: boolean;
        configurationJournal: string;
        subcontractLeadTime: integer;
        qualityControlFrequency: integer;
        qualityControlNumberEntries: integer;
        qualityProcessIdFrequency: integer;
        qualityProcessIdEntries: integer;
        isVersionPreloaded: boolean;
        text1004082: boolean;
        text1004085: boolean;
        purchasingText: TextStream;
    }
    export interface SupplierProduct$Lookups {
        product: QueryOperation<Product>;
        supplier: QueryOperation<BusinessPartner>;
        purchaseUnit: QueryOperation<UnitOfMeasure>;
        packingUnit: QueryOperation<UnitOfMeasure>;
    }
    export interface SupplierProduct$Operations {
        query: QueryOperation<SupplierProduct>;
        read: ReadOperation<SupplierProduct>;
        aggregate: {
            read: AggregateReadOperation<SupplierProduct>;
            query: AggregateQueryOperation<SupplierProduct>;
        };
        lookups(dataOrId: string | { data: SupplierProductInput }): SupplierProduct$Lookups;
        getDefaults: GetDefaultsOperation<SupplierProduct>;
    }
    export interface Supplier extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: BusinessPartner;
        category: SupplierCategory;
        payToBusinessPartner: BusinessPartner;
        payToBusinessPartnerAddress: BusinessPartnerAddress;
        billBySupplier: Supplier;
        billBySupplierAddress: SupplierAddress;
        groupSupplier: Supplier;
        riskSupplier: Supplier;
        ourCustomerNumberForSupplier: string;
        carrier: Carrier;
        defaultContact: SupplierContact;
        location: string;
        supplierABCClass: ProductAbcClass;
        rateType: ExchangeRateType;
        incoterm: Incoterm;
        intrastatTransportLocation: CountryLocation;
        addressByDefault: SupplierAddress;
        isMultiLineOrder: boolean;
        leadTimeRankingCoefficient: string;
        priceRankingCoefficient: string;
        qualityRankingCoefficient: string;
        quantityRankingCoefficient: string;
        freeRankingCoefficient: string;
        leadTimeRanking: string;
        priceRanking: string;
        qualityRanking: string;
        quantityRanking: string;
        freeRanking: string;
        totalRanking: string;
        creditControl: WorkInProgressControl;
        intrastatIncreaseCoefficient: string;
        mustRemindDelivery: boolean;
        mustRemindAcknowledgment: boolean;
        isDas2Submitted: boolean;
        isActive: boolean;
        isPaymentHeld: boolean;
        mustPrintOrderForm: boolean;
        mustPrintReceiptNote: boolean;
        mustPrintReturnSlip: boolean;
        ourCustomerNameForSupplier: string;
        is281Submitted: boolean;
        amountType: PriceAmountTaxTax;
        isCashVat: boolean;
        cashVatDeadline: string;
        selfBillingCode: string;
        rexNumber: string;
        hasNoWhiteListVerification: boolean;
        isElectronicInvoicingAllowed: boolean;
        contact: SupplierContact;
        startDateForElectronicInvoice: string;
        addresses: ClientCollection<SupplierAddress>;
        contacts: ClientCollection<SupplierContact>;
        acronym: string;
        businessPartnerSite: Site;
        cfonbPaymentMethod: MiscellaneousTable;
        companyName1: string;
        companyName2: string;
        companyNames: ClientCollection<BusinessPartnerCompanyNames>;
        consolidationCode: string;
        consolidationGroup: SiteGroupings;
        consolidationPartner: BusinessPartner;
        country: Country;
        customerOrSupplierOriginCategory: string;
        documentType: DocumentType;
        economicOperatorRegistrationAndIdNumber: string;
        europeanUnionVatNumber: string;
        fiscalCode: string;
        isCashExcluded: boolean;
        isIntersite: boolean;
        isMailingProhibited: boolean;
        isPhysicalPerson: boolean;
        isPublicSector: boolean;
        isServiceCaller: boolean;
        isServiceSupplier: boolean;
        italianTaxNumber: string;
        language: Language;
        nonResidentAccount: BusinessPartnerAddress;
        purchaseOrderText: TextStream;
        registrationNumber: string;
        relatedCompany: RelatedCompanySettings;
        reportAccessCode: Access;
        returnOrderText: TextStream;
        shortCompanyName: string;
        siteIdentificationNumber: string;
        standardIndustrialClassificationCode: string;
        vatNumber: string;
    }
    export interface SupplierInput extends ClientNodeInput {
        code?: string;
        category?: string;
        payToBusinessPartner?: string;
        payToBusinessPartnerAddress?: string;
        billBySupplier?: string;
        billBySupplierAddress?: string;
        groupSupplier?: string;
        riskSupplier?: string;
        ourCustomerNumberForSupplier?: string;
        carrier?: string;
        defaultContact?: string;
        location?: string;
        supplierABCClass?: ProductAbcClass;
        rateType?: ExchangeRateType;
        incoterm?: string;
        intrastatTransportLocation?: CountryLocation;
        addressByDefault?: string;
        isMultiLineOrder?: boolean | string;
        leadTimeRankingCoefficient?: decimal | string;
        priceRankingCoefficient?: decimal | string;
        qualityRankingCoefficient?: decimal | string;
        quantityRankingCoefficient?: decimal | string;
        freeRankingCoefficient?: decimal | string;
        leadTimeRanking?: decimal | string;
        priceRanking?: decimal | string;
        qualityRanking?: decimal | string;
        quantityRanking?: decimal | string;
        freeRanking?: decimal | string;
        totalRanking?: decimal | string;
        creditControl?: WorkInProgressControl;
        intrastatIncreaseCoefficient?: decimal | string;
        mustRemindDelivery?: boolean | string;
        mustRemindAcknowledgment?: boolean | string;
        isDas2Submitted?: boolean | string;
        isActive?: boolean | string;
        isPaymentHeld?: boolean | string;
        mustPrintOrderForm?: boolean | string;
        mustPrintReceiptNote?: boolean | string;
        mustPrintReturnSlip?: boolean | string;
        ourCustomerNameForSupplier?: string;
        is281Submitted?: boolean | string;
        amountType?: PriceAmountTaxTax;
        isCashVat?: boolean | string;
        cashVatDeadline?: string;
        selfBillingCode?: string;
        rexNumber?: string;
        hasNoWhiteListVerification?: boolean | string;
        isElectronicInvoicingAllowed?: boolean | string;
        contact?: string;
        startDateForElectronicInvoice?: string;
        addresses?: Partial<SupplierAddressInput>[];
        contacts?: Partial<SupplierContactInput>[];
        acronym?: string;
        businessPartnerSite?: string;
        cfonbPaymentMethod?: string;
        companyName1?: string;
        companyName2?: string;
        companyNames?: Partial<BusinessPartnerCompanyNamesInput>[];
        consolidationCode?: string;
        consolidationGroup?: string;
        consolidationPartner?: string;
        country?: string;
        customerOrSupplierOriginCategory?: string;
        documentType?: DocumentType;
        economicOperatorRegistrationAndIdNumber?: string;
        europeanUnionVatNumber?: string;
        fiscalCode?: string;
        isCashExcluded?: boolean | string;
        isIntersite?: boolean | string;
        isMailingProhibited?: boolean | string;
        isPhysicalPerson?: boolean | string;
        isPublicSector?: boolean | string;
        isServiceCaller?: boolean | string;
        isServiceSupplier?: boolean | string;
        italianTaxNumber?: string;
        language?: string;
        nonResidentAccount?: string;
        purchaseOrderText?: TextStream;
        registrationNumber?: string;
        relatedCompany?: RelatedCompanySettings;
        reportAccessCode?: string;
        returnOrderText?: TextStream;
        shortCompanyName?: string;
        siteIdentificationNumber?: string;
        standardIndustrialClassificationCode?: string;
        vatNumber?: string;
    }
    export interface SupplierBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: BusinessPartner;
        category: SupplierCategory;
        payToBusinessPartner: BusinessPartner;
        payToBusinessPartnerAddress: BusinessPartnerAddress;
        billBySupplier: Supplier;
        billBySupplierAddress: SupplierAddress;
        groupSupplier: Supplier;
        riskSupplier: Supplier;
        ourCustomerNumberForSupplier: string;
        carrier: Carrier;
        defaultContact: SupplierContact;
        location: string;
        supplierABCClass: ProductAbcClass;
        rateType: ExchangeRateType;
        incoterm: Incoterm;
        intrastatTransportLocation: CountryLocation;
        addressByDefault: SupplierAddress;
        isMultiLineOrder: boolean;
        leadTimeRankingCoefficient: string;
        priceRankingCoefficient: string;
        qualityRankingCoefficient: string;
        quantityRankingCoefficient: string;
        freeRankingCoefficient: string;
        leadTimeRanking: string;
        priceRanking: string;
        qualityRanking: string;
        quantityRanking: string;
        freeRanking: string;
        totalRanking: string;
        creditControl: WorkInProgressControl;
        intrastatIncreaseCoefficient: string;
        mustRemindDelivery: boolean;
        mustRemindAcknowledgment: boolean;
        isDas2Submitted: boolean;
        isActive: boolean;
        isPaymentHeld: boolean;
        mustPrintOrderForm: boolean;
        mustPrintReceiptNote: boolean;
        mustPrintReturnSlip: boolean;
        ourCustomerNameForSupplier: string;
        is281Submitted: boolean;
        amountType: PriceAmountTaxTax;
        isCashVat: boolean;
        cashVatDeadline: string;
        selfBillingCode: string;
        rexNumber: string;
        hasNoWhiteListVerification: boolean;
        isElectronicInvoicingAllowed: boolean;
        contact: SupplierContact;
        startDateForElectronicInvoice: string;
        addresses: ClientCollection<SupplierAddress>;
        contacts: ClientCollection<SupplierContact>;
        acronym: string;
        businessPartnerSite: Site;
        cfonbPaymentMethod: MiscellaneousTable;
        companyName1: string;
        companyName2: string;
        companyNames: ClientCollection<BusinessPartnerCompanyNames>;
        consolidationCode: string;
        consolidationGroup: SiteGroupings;
        consolidationPartner: BusinessPartner;
        country: Country;
        customerOrSupplierOriginCategory: string;
        documentType: DocumentType;
        economicOperatorRegistrationAndIdNumber: string;
        europeanUnionVatNumber: string;
        fiscalCode: string;
        isCashExcluded: boolean;
        isIntersite: boolean;
        isMailingProhibited: boolean;
        isPhysicalPerson: boolean;
        isPublicSector: boolean;
        isServiceCaller: boolean;
        isServiceSupplier: boolean;
        italianTaxNumber: string;
        language: Language;
        nonResidentAccount: BusinessPartnerAddress;
        purchaseOrderText: TextStream;
        registrationNumber: string;
        relatedCompany: RelatedCompanySettings;
        reportAccessCode: Access;
        returnOrderText: TextStream;
        shortCompanyName: string;
        siteIdentificationNumber: string;
        standardIndustrialClassificationCode: string;
        vatNumber: string;
    }
    export interface Supplier$Lookups {
        code: QueryOperation<BusinessPartner>;
        category: QueryOperation<SupplierCategory>;
        payToBusinessPartner: QueryOperation<BusinessPartner>;
        payToBusinessPartnerAddress: QueryOperation<BusinessPartnerAddress>;
        billBySupplier: QueryOperation<Supplier>;
        billBySupplierAddress: QueryOperation<SupplierAddress>;
        groupSupplier: QueryOperation<Supplier>;
        riskSupplier: QueryOperation<Supplier>;
        carrier: QueryOperation<Carrier>;
        defaultContact: QueryOperation<SupplierContact>;
        incoterm: QueryOperation<Incoterm>;
        addressByDefault: QueryOperation<SupplierAddress>;
        contact: QueryOperation<SupplierContact>;
        businessPartnerSite: QueryOperation<Site>;
        cfonbPaymentMethod: QueryOperation<MiscellaneousTable>;
        consolidationGroup: QueryOperation<SiteGroupings>;
        consolidationPartner: QueryOperation<BusinessPartner>;
        country: QueryOperation<Country>;
        language: QueryOperation<Language>;
        nonResidentAccount: QueryOperation<BusinessPartnerAddress>;
        reportAccessCode: QueryOperation<Access>;
    }
    export interface Supplier$Operations {
        query: QueryOperation<Supplier>;
        read: ReadOperation<Supplier>;
        aggregate: {
            read: AggregateReadOperation<Supplier>;
            query: AggregateQueryOperation<Supplier>;
        };
        lookups(dataOrId: string | { data: SupplierInput }): Supplier$Lookups;
        getDefaults: GetDefaultsOperation<Supplier>;
    }
    export interface TechnicalSheet extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        technicalSheet: string;
        lineNumber: integer;
        localizedDescription: string;
        sequence: integer;
    }
    export interface TechnicalSheetInput extends ClientNodeInput {
        technicalSheet?: string;
        lineNumber?: integer | string;
        localizedDescription?: string;
        sequence?: integer | string;
    }
    export interface TechnicalSheetBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        technicalSheet: string;
        lineNumber: integer;
        localizedDescription: string;
        sequence: integer;
    }
    export interface TechnicalSheet$Operations {
        query: QueryOperation<TechnicalSheet>;
        read: ReadOperation<TechnicalSheet>;
        aggregate: {
            read: AggregateReadOperation<TechnicalSheet>;
            query: AggregateQueryOperation<TechnicalSheet>;
        };
        getDefaults: GetDefaultsOperation<TechnicalSheet>;
    }
    export interface TimeTableSchemaTimes extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        startTime: string;
        endTime: string;
    }
    export interface TimeTableSchemaTimesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        startTime?: string;
        endTime?: string;
    }
    export interface TimeTableSchemaTimesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        startTime: string;
        endTime: string;
    }
    export interface TimeTableSchemaTimes$Operations {
        query: QueryOperation<TimeTableSchemaTimes>;
        read: ReadOperation<TimeTableSchemaTimes>;
        aggregate: {
            read: AggregateReadOperation<TimeTableSchemaTimes>;
            query: AggregateQueryOperation<TimeTableSchemaTimes>;
        };
        getDefaults: GetDefaultsOperation<TimeTableSchemaTimes>;
    }
    export interface TimeTableSchema extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        shortDescription: string;
        times: ClientCollection<TimeTableSchemaTimes>;
    }
    export interface TimeTableSchemaInput extends ClientNodeInput {
        code?: string;
        description?: string;
        shortDescription?: string;
        times?: Partial<TimeTableSchemaTimesInput>[];
    }
    export interface TimeTableSchemaBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        description: string;
        shortDescription: string;
        times: ClientCollection<TimeTableSchemaTimesBinding>;
    }
    export interface TimeTableSchema$Operations {
        query: QueryOperation<TimeTableSchema>;
        read: ReadOperation<TimeTableSchema>;
        aggregate: {
            read: AggregateReadOperation<TimeTableSchema>;
            query: AggregateQueryOperation<TimeTableSchema>;
        };
        getDefaults: GetDefaultsOperation<TimeTableSchema>;
    }
    export interface TransitAreaAddressAddressEmails extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        transitArea: string;
        code: string;
        addressEmail: string;
    }
    export interface TransitAreaAddressAddressEmailsInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        transitArea?: string;
        code?: string;
        addressEmail?: string;
    }
    export interface TransitAreaAddressAddressEmailsBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        transitArea: string;
        code: string;
        addressEmail: string;
    }
    export interface TransitAreaAddressAddressEmails$Operations {
        query: QueryOperation<TransitAreaAddressAddressEmails>;
        read: ReadOperation<TransitAreaAddressAddressEmails>;
        aggregate: {
            read: AggregateReadOperation<TransitAreaAddressAddressEmails>;
            query: AggregateQueryOperation<TransitAreaAddressAddressEmails>;
        };
        getDefaults: GetDefaultsOperation<TransitAreaAddressAddressEmails>;
    }
    export interface TransitAreaAddressAddressLines extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        transitArea: string;
        code: string;
        addressLine: string;
    }
    export interface TransitAreaAddressAddressLinesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        transitArea?: string;
        code?: string;
        addressLine?: string;
    }
    export interface TransitAreaAddressAddressLinesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        transitArea: string;
        code: string;
        addressLine: string;
    }
    export interface TransitAreaAddressAddressLines$Operations {
        query: QueryOperation<TransitAreaAddressAddressLines>;
        read: ReadOperation<TransitAreaAddressAddressLines>;
        aggregate: {
            read: AggregateReadOperation<TransitAreaAddressAddressLines>;
            query: AggregateQueryOperation<TransitAreaAddressAddressLines>;
        };
        getDefaults: GetDefaultsOperation<TransitAreaAddressAddressLines>;
    }
    export interface TransitAreaAddressAddressPhoneNumbers extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        transitArea: string;
        code: string;
        addressPhoneNumber: string;
    }
    export interface TransitAreaAddressAddressPhoneNumbersInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        entityType?: EntityType;
        transitArea?: string;
        code?: string;
        addressPhoneNumber?: string;
    }
    export interface TransitAreaAddressAddressPhoneNumbersBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        entityType: EntityType;
        transitArea: string;
        code: string;
        addressPhoneNumber: string;
    }
    export interface TransitAreaAddressAddressPhoneNumbers$Operations {
        query: QueryOperation<TransitAreaAddressAddressPhoneNumbers>;
        read: ReadOperation<TransitAreaAddressAddressPhoneNumbers>;
        aggregate: {
            read: AggregateReadOperation<TransitAreaAddressAddressPhoneNumbers>;
            query: AggregateQueryOperation<TransitAreaAddressAddressPhoneNumbers>;
        };
        getDefaults: GetDefaultsOperation<TransitAreaAddressAddressPhoneNumbers>;
    }
    export interface TransitAreaAddress extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        transitArea: TransitArea;
        code: string;
        description: string;
        isDefault: boolean;
        zipCode: string;
        city: string;
        state: string;
        country: Country;
        countryName: string;
        website: string;
        externalIdentifier: string;
        addressEmails: ClientCollection<TransitAreaAddressAddressEmails>;
        addressLines: ClientCollection<TransitAreaAddressAddressLines>;
        addressPhoneNumbers: ClientCollection<TransitAreaAddressAddressPhoneNumbers>;
    }
    export interface TransitAreaAddressInput extends ClientNodeInput {
        entityType?: EntityType;
        transitArea?: string;
        code?: string;
        description?: string;
        isDefault?: boolean | string;
        zipCode?: string;
        city?: string;
        state?: string;
        country?: string;
        countryName?: string;
        website?: string;
        externalIdentifier?: string;
        addressEmails?: Partial<TransitAreaAddressAddressEmailsInput>[];
        addressLines?: Partial<TransitAreaAddressAddressLinesInput>[];
        addressPhoneNumbers?: Partial<TransitAreaAddressAddressPhoneNumbersInput>[];
    }
    export interface TransitAreaAddressBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        entityType: EntityType;
        transitArea: TransitArea;
        code: string;
        description: string;
        isDefault: boolean;
        zipCode: string;
        city: string;
        state: string;
        country: Country;
        countryName: string;
        website: string;
        externalIdentifier: string;
        addressEmails: ClientCollection<TransitAreaAddressAddressEmailsBinding>;
        addressLines: ClientCollection<TransitAreaAddressAddressLinesBinding>;
        addressPhoneNumbers: ClientCollection<TransitAreaAddressAddressPhoneNumbersBinding>;
    }
    export interface TransitAreaAddress$Lookups {
        transitArea: QueryOperation<TransitArea>;
        country: QueryOperation<Country>;
    }
    export interface TransitAreaAddress$Operations {
        query: QueryOperation<TransitAreaAddress>;
        read: ReadOperation<TransitAreaAddress>;
        aggregate: {
            read: AggregateReadOperation<TransitAreaAddress>;
            query: AggregateQueryOperation<TransitAreaAddress>;
        };
        lookups(dataOrId: string | { data: TransitAreaAddressInput }): TransitAreaAddress$Lookups;
        getDefaults: GetDefaultsOperation<TransitAreaAddress>;
    }
    export interface TransitArea extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        placeType: PlaceType;
        longDescription: string;
        shortDescription: string;
        releaseTime: integer;
        site: Site;
        supplier: Supplier;
        transitAreaAddress: TransitAreaAddress;
        isActive: boolean;
    }
    export interface TransitAreaInput extends ClientNodeInput {
        code?: string;
        placeType?: PlaceType;
        longDescription?: string;
        shortDescription?: string;
        releaseTime?: integer | string;
        site?: string;
        supplier?: string;
        transitAreaAddress?: string;
        isActive?: boolean | string;
    }
    export interface TransitAreaBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        placeType: PlaceType;
        longDescription: string;
        shortDescription: string;
        releaseTime: integer;
        site: Site;
        supplier: Supplier;
        transitAreaAddress: TransitAreaAddress;
        isActive: boolean;
    }
    export interface TransitArea$Lookups {
        site: QueryOperation<Site>;
        supplier: QueryOperation<Supplier>;
        transitAreaAddress: QueryOperation<TransitAreaAddress>;
    }
    export interface TransitArea$Operations {
        query: QueryOperation<TransitArea>;
        read: ReadOperation<TransitArea>;
        aggregate: {
            read: AggregateReadOperation<TransitArea>;
            query: AggregateQueryOperation<TransitArea>;
        };
        lookups(dataOrId: string | { data: TransitAreaInput }): TransitArea$Lookups;
        getDefaults: GetDefaultsOperation<TransitArea>;
    }
    export interface UnavailablePeriodsLines extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        startDate: string;
        endDate: string;
        dateDescription: string;
    }
    export interface UnavailablePeriodsLinesInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        startDate?: string;
        endDate?: string;
        dateDescription?: string;
    }
    export interface UnavailablePeriodsLinesBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        startDate: string;
        endDate: string;
        dateDescription: string;
    }
    export interface UnavailablePeriodsLines$Operations {
        query: QueryOperation<UnavailablePeriodsLines>;
        read: ReadOperation<UnavailablePeriodsLines>;
        aggregate: {
            read: AggregateReadOperation<UnavailablePeriodsLines>;
            query: AggregateQueryOperation<UnavailablePeriodsLines>;
        };
        getDefaults: GetDefaultsOperation<UnavailablePeriodsLines>;
    }
    export interface UnavailablePeriods extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
        siteCompanyGroup: SiteGroupings;
        lines: ClientCollection<UnavailablePeriodsLines>;
    }
    export interface UnavailablePeriodsInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
        siteCompanyGroup?: string;
        lines?: Partial<UnavailablePeriodsLinesInput>[];
    }
    export interface UnavailablePeriodsBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
        siteCompanyGroup: SiteGroupings;
        lines: ClientCollection<UnavailablePeriodsLinesBinding>;
    }
    export interface UnavailablePeriods$Lookups {
        siteCompanyGroup: QueryOperation<SiteGroupings>;
    }
    export interface UnavailablePeriods$Operations {
        query: QueryOperation<UnavailablePeriods>;
        read: ReadOperation<UnavailablePeriods>;
        aggregate: {
            read: AggregateReadOperation<UnavailablePeriods>;
            query: AggregateQueryOperation<UnavailablePeriods>;
        };
        lookups(dataOrId: string | { data: UnavailablePeriodsInput }): UnavailablePeriods$Lookups;
        getDefaults: GetDefaultsOperation<UnavailablePeriods>;
    }
    export interface UnitOfMeasure extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
        numberOfDecimals: integer;
        unitType: UnitType;
        codeCeeOnu: MiscellaneousTable;
    }
    export interface UnitOfMeasureInput extends ClientNodeInput {
        code?: string;
        localizedDescription?: string;
        localizedShortDescription?: string;
        numberOfDecimals?: integer | string;
        unitType?: UnitType;
        codeCeeOnu?: string;
    }
    export interface UnitOfMeasureBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        localizedDescription: string;
        localizedShortDescription: string;
        numberOfDecimals: integer;
        unitType: UnitType;
        codeCeeOnu: MiscellaneousTable;
    }
    export interface UnitOfMeasure$Lookups {
        codeCeeOnu: QueryOperation<MiscellaneousTable>;
    }
    export interface UnitOfMeasure$Operations {
        query: QueryOperation<UnitOfMeasure>;
        read: ReadOperation<UnitOfMeasure>;
        aggregate: {
            read: AggregateReadOperation<UnitOfMeasure>;
            query: AggregateQueryOperation<UnitOfMeasure>;
        };
        lookups(dataOrId: string | { data: UnitOfMeasureInput }): UnitOfMeasure$Lookups;
        getDefaults: GetDefaultsOperation<UnitOfMeasure>;
    }
    export interface WeeklyStructureWeeklyStructureDailyCapacity extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        dailyCapicity: string;
        timeTableSchema: TimeTableSchema;
        capacityDayName: string;
    }
    export interface WeeklyStructureWeeklyStructureDailyCapacityInput extends VitalClientNodeInput {
        denormalizedIndex?: integer | string;
        code?: string;
        dailyCapicity?: decimal | string;
        timeTableSchema?: string;
    }
    export interface WeeklyStructureWeeklyStructureDailyCapacityBinding extends VitalClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        denormalizedIndex: integer;
        code: string;
        dailyCapicity: string;
        timeTableSchema: TimeTableSchema;
        capacityDayName: string;
    }
    export interface WeeklyStructureWeeklyStructureDailyCapacity$Lookups {
        timeTableSchema: QueryOperation<TimeTableSchema>;
    }
    export interface WeeklyStructureWeeklyStructureDailyCapacity$Operations {
        query: QueryOperation<WeeklyStructureWeeklyStructureDailyCapacity>;
        read: ReadOperation<WeeklyStructureWeeklyStructureDailyCapacity>;
        aggregate: {
            read: AggregateReadOperation<WeeklyStructureWeeklyStructureDailyCapacity>;
            query: AggregateQueryOperation<WeeklyStructureWeeklyStructureDailyCapacity>;
        };
        lookups(
            dataOrId: string | { data: WeeklyStructureWeeklyStructureDailyCapacityInput },
        ): WeeklyStructureWeeklyStructureDailyCapacity$Lookups;
        getDefaults: GetDefaultsOperation<WeeklyStructureWeeklyStructureDailyCapacity>;
    }
    export interface WeeklyStructure extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        standardCapicity: string;
        localizedDescription: string;
        localizedShortDescription: string;
        weeklyStructureDailyCapacity: ClientCollection<WeeklyStructureWeeklyStructureDailyCapacity>;
        weeklyCapacity: string;
    }
    export interface WeeklyStructureInput extends ClientNodeInput {
        code?: string;
        standardCapicity?: decimal | string;
        localizedDescription?: string;
        localizedShortDescription?: string;
        weeklyStructureDailyCapacity?: Partial<WeeklyStructureWeeklyStructureDailyCapacityInput>[];
    }
    export interface WeeklyStructureBinding extends ClientNode {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        standardCapicity: string;
        localizedDescription: string;
        localizedShortDescription: string;
        weeklyStructureDailyCapacity: ClientCollection<WeeklyStructureWeeklyStructureDailyCapacityBinding>;
        weeklyCapacity: string;
    }
    export interface WeeklyStructure$Operations {
        query: QueryOperation<WeeklyStructure>;
        read: ReadOperation<WeeklyStructure>;
        aggregate: {
            read: AggregateReadOperation<WeeklyStructure>;
            query: AggregateQueryOperation<WeeklyStructure>;
        };
        getDefaults: GetDefaultsOperation<WeeklyStructure>;
    }
    export interface CompanyExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        name: string;
        shortDescription: string;
        isLegalCompany: boolean;
        legislation: MiscellaneousTable;
        logo: Image;
        serviceId: string;
        addresses: ClientCollection<CompanyAddress>;
        contacts: ClientCollection<CompanyContact>;
        bankDetails: ClientCollection<CompanyBankDetail>;
    }
    export interface CompanyInputExtension {
        code?: string;
        name?: string;
        shortDescription?: string;
        isLegalCompany?: boolean | string;
        legislation?: string;
        logo?: string;
        serviceId?: string;
        addresses?: Partial<CompanyAddressInput>[];
        contacts?: Partial<CompanyContactInput>[];
        bankDetails?: Partial<CompanyBankDetailInput>[];
    }
    export interface CompanyBindingExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        name: string;
        shortDescription: string;
        isLegalCompany: boolean;
        legislation: MiscellaneousTable;
        logo: Image;
        serviceId: string;
        addresses: ClientCollection<CompanyAddress>;
        contacts: ClientCollection<CompanyContact>;
        bankDetails: ClientCollection<CompanyBankDetail>;
    }
    export interface GenericPrintReportExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        reportName: string;
    }
    export interface GenericPrintReportInputExtension {
        reportName?: string;
    }
    export interface GenericPrintReportBindingExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        reportName: string;
    }
    export interface GenericPrintReportExtension$Mutations {
        printReport: Node$Operation<
            {
                parameters?: {
                    reportName: string;
                    language: string;
                    destination: string;
                    parametersNames: string[];
                    parametersValues: string[];
                    errorCode: integer | string;
                };
            },
            {
                errorCode: integer;
            }
        >;
    }
    export interface GenericPrintReportExtension$Operations {
        mutations: GenericPrintReportExtension$Mutations;
        getDefaults: GetDefaultsOperation<GenericPrintReport>;
    }
    export interface SiteExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        name: string;
        isManufacturing: boolean;
        isStockSite: boolean;
        legalCompany: Company;
        unavailabilityCode: UnavailablePeriods;
        routingCode: string;
        electronicAddress: string;
        addresses: ClientCollection<SiteAddress>;
        contacts: ClientCollection<SiteContact>;
        bankDetails: ClientCollection<SiteBankDetail>;
    }
    export interface SiteInputExtension {
        code?: string;
        name?: string;
        isManufacturing?: boolean | string;
        isStockSite?: boolean | string;
        legalCompany?: string;
        unavailabilityCode?: string;
        routingCode?: string;
        electronicAddress?: string;
        addresses?: Partial<SiteAddressInput>[];
        contacts?: Partial<SiteContactInput>[];
        bankDetails?: Partial<SiteBankDetailInput>[];
    }
    export interface SiteBindingExtension {
        _updateUser: SysUser;
        _createUser: SysUser;
        code: string;
        name: string;
        isManufacturing: boolean;
        isStockSite: boolean;
        legalCompany: Company;
        unavailabilityCode: UnavailablePeriods;
        routingCode: string;
        electronicAddress: string;
        addresses: ClientCollection<SiteAddress>;
        contacts: ClientCollection<SiteContact>;
        bankDetails: ClientCollection<SiteBankDetail>;
    }
    export interface SiteExtension$Lookups {
        unavailabilityCode: QueryOperation<UnavailablePeriods>;
    }
    export interface SiteExtension$Operations {
        lookups(dataOrId: string | { data: SiteInput }): SiteExtension$Lookups;
    }
    export interface Package {
        '@sage/x3-master-data/AddressAddressEmails': AddressAddressEmails$Operations;
        '@sage/x3-master-data/AddressAddressLines': AddressAddressLines$Operations;
        '@sage/x3-master-data/AddressAddressPhoneNumbers': AddressAddressPhoneNumbers$Operations;
        '@sage/x3-master-data/Address': Address$Operations;
        '@sage/x3-master-data/BankDetail': BankDetail$Operations;
        '@sage/x3-master-data/BomCodes': BomCodes$Operations;
        '@sage/x3-master-data/BomDetail': BomDetail$Operations;
        '@sage/x3-master-data/BomHeader': BomHeader$Operations;
        '@sage/x3-master-data/BomProduct': BomProduct$Operations;
        '@sage/x3-master-data/BomRouting': BomRouting$Operations;
        '@sage/x3-master-data/BusinessPartnerAddressAddressEmails': BusinessPartnerAddressAddressEmails$Operations;
        '@sage/x3-master-data/BusinessPartnerAddressAddressLines': BusinessPartnerAddressAddressLines$Operations;
        '@sage/x3-master-data/BusinessPartnerAddressAddressPhoneNumbers': BusinessPartnerAddressAddressPhoneNumbers$Operations;
        '@sage/x3-master-data/BusinessPartnerAddress': BusinessPartnerAddress$Operations;
        '@sage/x3-master-data/BusinessPartnerBankDetail': BusinessPartnerBankDetail$Operations;
        '@sage/x3-master-data/BusinessPartnerCompanyException': BusinessPartnerCompanyException$Operations;
        '@sage/x3-master-data/BusinessPartnerCompanyNames': BusinessPartnerCompanyNames$Operations;
        '@sage/x3-master-data/BusinessPartnerContact': BusinessPartnerContact$Operations;
        '@sage/x3-master-data/BusinessPartner': BusinessPartner$Operations;
        '@sage/x3-master-data/Carrier': Carrier$Operations;
        '@sage/x3-master-data/CommonImage': CommonImage$Operations;
        '@sage/x3-master-data/CommonText': CommonText$Operations;
        '@sage/x3-master-data/CompanyAddressAddressEmails': CompanyAddressAddressEmails$Operations;
        '@sage/x3-master-data/CompanyAddressAddressLines': CompanyAddressAddressLines$Operations;
        '@sage/x3-master-data/CompanyAddressAddressPhoneNumbers': CompanyAddressAddressPhoneNumbers$Operations;
        '@sage/x3-master-data/CompanyAddress': CompanyAddress$Operations;
        '@sage/x3-master-data/CompanyBankDetail': CompanyBankDetail$Operations;
        '@sage/x3-master-data/CompanyContact': CompanyContact$Operations;
        '@sage/x3-master-data/ContactRelationshipAddressLines': ContactRelationshipAddressLines$Operations;
        '@sage/x3-master-data/ContactRelationship': ContactRelationship$Operations;
        '@sage/x3-master-data/Contact': Contact$Operations;
        '@sage/x3-master-data/Container': Container$Operations;
        '@sage/x3-master-data/CurrencyRate': CurrencyRate$Operations;
        '@sage/x3-master-data/Currency': Currency$Operations;
        '@sage/x3-master-data/CustomerAddressAddressEmails': CustomerAddressAddressEmails$Operations;
        '@sage/x3-master-data/CustomerAddressAddressLines': CustomerAddressAddressLines$Operations;
        '@sage/x3-master-data/CustomerAddressAddressPhoneNumbers': CustomerAddressAddressPhoneNumbers$Operations;
        '@sage/x3-master-data/CustomerAddress': CustomerAddress$Operations;
        '@sage/x3-master-data/CustomerBankDetail': CustomerBankDetail$Operations;
        '@sage/x3-master-data/CustomerCashTaxRules': CustomerCashTaxRules$Operations;
        '@sage/x3-master-data/CustomerCategory': CustomerCategory$Operations;
        '@sage/x3-master-data/CustomerContact': CustomerContact$Operations;
        '@sage/x3-master-data/CustomerPaymentDays': CustomerPaymentDays$Operations;
        '@sage/x3-master-data/CustomerProduct': CustomerProduct$Operations;
        '@sage/x3-master-data/CustomerSalesReps': CustomerSalesReps$Operations;
        '@sage/x3-master-data/CustomerStatisticalGroups': CustomerStatisticalGroups$Operations;
        '@sage/x3-master-data/Customer': Customer$Operations;
        '@sage/x3-master-data/Incoterm': Incoterm$Operations;
        '@sage/x3-master-data/Mapping': Mapping$Operations;
        '@sage/x3-master-data/MobileAutomationSetup': MobileAutomationSetup$Operations;
        '@sage/x3-master-data/PrintTemplate': PrintTemplate$Operations;
        '@sage/x3-master-data/ProductCategoryStatisticalGroups': ProductCategoryStatisticalGroups$Operations;
        '@sage/x3-master-data/ProductCategory': ProductCategory$Operations;
        '@sage/x3-master-data/ProductPackingUnits': ProductPackingUnits$Operations;
        '@sage/x3-master-data/ProductSite': ProductSite$Operations;
        '@sage/x3-master-data/ProductStatisticalGroups': ProductStatisticalGroups$Operations;
        '@sage/x3-master-data/ProductVersion': ProductVersion$Operations;
        '@sage/x3-master-data/Product': Product$Operations;
        '@sage/x3-master-data/ProspectAddressAddressEmails': ProspectAddressAddressEmails$Operations;
        '@sage/x3-master-data/ProspectAddressAddressLines': ProspectAddressAddressLines$Operations;
        '@sage/x3-master-data/ProspectAddressAddressPhoneNumbers': ProspectAddressAddressPhoneNumbers$Operations;
        '@sage/x3-master-data/ProspectAddress': ProspectAddress$Operations;
        '@sage/x3-master-data/ProspectContact': ProspectContact$Operations;
        '@sage/x3-master-data/ProspectSalesReps': ProspectSalesReps$Operations;
        '@sage/x3-master-data/ProspectStatisticalGroups': ProspectStatisticalGroups$Operations;
        '@sage/x3-master-data/Prospect': Prospect$Operations;
        '@sage/x3-master-data/SalesRep': SalesRep$Operations;
        '@sage/x3-master-data/ShipToCustomerAddressCompanyNames': ShipToCustomerAddressCompanyNames$Operations;
        '@sage/x3-master-data/ShipToCustomerAddressSalesReps': ShipToCustomerAddressSalesReps$Operations;
        '@sage/x3-master-data/ShipToCustomerAddress': ShipToCustomerAddress$Operations;
        '@sage/x3-master-data/SiteAddressAddressEmails': SiteAddressAddressEmails$Operations;
        '@sage/x3-master-data/SiteAddressAddressLines': SiteAddressAddressLines$Operations;
        '@sage/x3-master-data/SiteAddressAddressPhoneNumbers': SiteAddressAddressPhoneNumbers$Operations;
        '@sage/x3-master-data/SiteAddress': SiteAddress$Operations;
        '@sage/x3-master-data/SiteBankDetail': SiteBankDetail$Operations;
        '@sage/x3-master-data/SiteContact': SiteContact$Operations;
        '@sage/x3-master-data/SupplierAddressAddressEmails': SupplierAddressAddressEmails$Operations;
        '@sage/x3-master-data/SupplierAddressAddressLines': SupplierAddressAddressLines$Operations;
        '@sage/x3-master-data/SupplierAddressAddressPhoneNumbers': SupplierAddressAddressPhoneNumbers$Operations;
        '@sage/x3-master-data/SupplierAddress': SupplierAddress$Operations;
        '@sage/x3-master-data/SupplierBankDetail': SupplierBankDetail$Operations;
        '@sage/x3-master-data/SupplierCategory': SupplierCategory$Operations;
        '@sage/x3-master-data/SupplierContact': SupplierContact$Operations;
        '@sage/x3-master-data/SupplierProduct': SupplierProduct$Operations;
        '@sage/x3-master-data/Supplier': Supplier$Operations;
        '@sage/x3-master-data/TechnicalSheet': TechnicalSheet$Operations;
        '@sage/x3-master-data/TimeTableSchemaTimes': TimeTableSchemaTimes$Operations;
        '@sage/x3-master-data/TimeTableSchema': TimeTableSchema$Operations;
        '@sage/x3-master-data/TransitAreaAddressAddressEmails': TransitAreaAddressAddressEmails$Operations;
        '@sage/x3-master-data/TransitAreaAddressAddressLines': TransitAreaAddressAddressLines$Operations;
        '@sage/x3-master-data/TransitAreaAddressAddressPhoneNumbers': TransitAreaAddressAddressPhoneNumbers$Operations;
        '@sage/x3-master-data/TransitAreaAddress': TransitAreaAddress$Operations;
        '@sage/x3-master-data/TransitArea': TransitArea$Operations;
        '@sage/x3-master-data/UnavailablePeriodsLines': UnavailablePeriodsLines$Operations;
        '@sage/x3-master-data/UnavailablePeriods': UnavailablePeriods$Operations;
        '@sage/x3-master-data/UnitOfMeasure': UnitOfMeasure$Operations;
        '@sage/x3-master-data/WeeklyStructureWeeklyStructureDailyCapacity': WeeklyStructureWeeklyStructureDailyCapacity$Operations;
        '@sage/x3-master-data/WeeklyStructure': WeeklyStructure$Operations;
    }
    export interface GraphApi
        extends Package,
            SageX3Structure$Package,
            SageX3System$Package,
            SageXtremAppMetadata$Package,
            SageXtremX3SystemUtils$Package {}
}
declare module '@sage/x3-master-data-api' {
    export type * from '@sage/x3-master-data-api-partial';
}
declare module '@sage/x3-structure-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-master-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-system-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-master-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/xtrem-app-metadata-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-master-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/xtrem-x3-system-utils-api-partial' {
    import type { GraphApi as GraphApiExtension } from '@sage/x3-master-data-api';
    export interface GraphApi extends GraphApiExtension {}
}
declare module '@sage/x3-system-api-partial' {
    import type {
        CompanyBindingExtension,
        CompanyExtension,
        CompanyInputExtension,
        GenericPrintReportBindingExtension,
        GenericPrintReportExtension,
        GenericPrintReportExtension$Mutations,
        GenericPrintReportExtension$Operations,
        GenericPrintReportInputExtension,
        SiteBindingExtension,
        SiteExtension,
        SiteExtension$Lookups,
        SiteExtension$Operations,
        SiteInputExtension,
    } from '@sage/x3-master-data-api';
    export interface Company extends CompanyExtension {}
    export interface CompanyBinding extends CompanyBindingExtension {}
    export interface CompanyInput extends CompanyInputExtension {}
    export interface GenericPrintReport extends GenericPrintReportExtension {}
    export interface GenericPrintReportBinding extends GenericPrintReportBindingExtension {}
    export interface GenericPrintReportInput extends GenericPrintReportInputExtension {}
    export interface GenericPrintReport$Mutations extends GenericPrintReportExtension$Mutations {}
    export interface GenericPrintReport$Operations extends GenericPrintReportExtension$Operations {}
    export interface Site extends SiteExtension {}
    export interface SiteBinding extends SiteBindingExtension {}
    export interface SiteInput extends SiteInputExtension {}
    export interface Site$Lookups extends SiteExtension$Lookups {}
    export interface Site$Operations extends SiteExtension$Operations {}
}
